Dim Shared As ZString*13 sDimAutoEndsKeywords(1 To 21) = {"function" , "sub" , "type" , "scope" , "union" , "enum" ,_
"namespace" , "with" , "extern" , "constructor" , "destructor" , "operator" , "property" , "wend" , "loop" , "next" , "endif" , "select" , "#endif" , "asm" , "#endmacro"}

ReDim Shared As Byte bDimFlagLinesAutoEnds(0)

Function atc_k_function_proc(sLineText As String) As Integer export
	
	If Len(sLineText) < 15 Then Return 0
	
	If Left(sLineText,9) = "function " Then
		
		If InStr(sLineText , " as ") orelse InStr(sLineText , ")as ") Then
			
			Return 1
			
		EndIf
		
	EndIf
	
End Function

Function atc_k_private_proc(sLineText As String) As Integer export
	
	If Len(sLineText) < 15 Then Return 0
	
	If Left(sLineText,8) = "private " Then
		
		If InStr(sLineText , " function ") Then
			
			If InStr(sLineText , " as ") orelse InStr(sLineText , ")as ") Then
				
				Return 1
				
			EndIf
			
		ElseIf InStr(sLineText , " sub ") Then
			
			Return 2
			
		ElseIf InStr(sLineText , " operator ") Then
			
			If InStr(sLineText , ")") Then
				
				Return 12
				
			EndIf
			
		ElseIf InStr(sLineText , " property ") Then
			
			If InStr(sLineText , ")") Then
				
				Return 13
				
			EndIf
			
		ElseIf InStr(sLineText , " constructor ") Then
				
			Return 10
			
		ElseIf InStr(sLineText , " destructor ") Then
				
			Return 11					

		EndIf
		
	EndIf
	
End Function

Function atc_k_public_proc(sLineText As String) As Integer export
	
	If Len(sLineText) < 14 Then Return 0
	
	If Left(sLineText,7) = "public " Then
		
		If InStr(sLineText , " function ") Then
			
			If InStr(sLineText , " as ") orelse InStr(sLineText , ")as ") Then
				
				Return 1
				
			EndIf
			
		ElseIf InStr(sLineText , " sub ") Then
			
			Return 2
			
		ElseIf InStr(sLineText , " operator ") Then
			
			If InStr(sLineText , ")") Then
				
				Return 12
				
			EndIf
			
		ElseIf InStr(sLineText , " property ") Then
			
			If InStr(sLineText , ")") Then
				
				Return 13
				
			EndIf
			
		ElseIf InStr(sLineText , " constructor ") Then
				
			Return 10
			
		ElseIf InStr(sLineText , " destructor ") Then
				
			Return 11
					
		EndIf
		
	EndIf
	
End Function

Function atc_k_sub_proc(sLineText As String) As Integer export
	
	If Len(sLineText) < 7 Then Return 0
	
	If Left(sLineText,4) = "sub " Then
		
		If InStr(sLineText , ")") Then
			
			Return 1
			
		EndIf
		
	EndIf
	
End Function

Function atc_k_type_proc(sLineText As String) As Integer export
	
	If Len(sLineText) < 6 Then Return 0
	
	If Left(sLineText,5) = "type " Then
		
		If InStr(sLineText , " as ") Then
			
			Return 0
			
		EndIf
		
		Return 1
		
	EndIf
	
End Function

Function atc_k_scope_proc(sLineText As String) As Integer export
	
	Dim As Integer iLen = Len(sLineText)
	
	If iLen < 5 Then Return 0
	
	If Left(sLineText,5) = "scope" Then
		
		If iLen = 5 OrElse Mid(sLineText , 6 , 1) = " " Then
			
			Return 1
			
		EndIf
		
	EndIf
	
End Function

Function atc_k_union_proc(sLineText As String) As Integer export
	
	Dim As Integer iLen = Len(sLineText)
	
	If iLen < 5 Then Return 0
	
	If Left(sLineText,5) = "union" Then
		
		If iLen = 5 OrElse Mid(sLineText , 6 , 1) = " " Then
			
			Return 1
			
		EndIf
		
	EndIf
	
End Function

Function atc_k_enum_proc(sLineText As String) As Integer export
	
	Dim As Integer iLen = Len(sLineText)
	
	If iLen < 4 Then Return 0
	
	If Left(sLineText,4) = "enum" Then
		
		If iLen = 4 OrElse Mid(sLineText , 5 , 1) = " " Then
			
			Return 1
			
		EndIf
		
	EndIf
	
End Function

Function atc_k_namespace_proc(sLineText As String) As Integer export
	
	If Len(sLineText) < 11 Then Return 0
	
	If Left(sLineText,10) = "namespace " Then
		
		Return 1
		
	EndIf
	
End Function

Function atc_k_with_proc(sLineText As String) As Integer export
	
	If Len(sLineText) < 5 Then Return 0
	
	If Left(sLineText,5) = "with " Then
		
		Return 1
		
	EndIf
	
End Function

Function atc_k_extern_proc(sLineText As String) As Integer export
	
	dim as Long iLen = Len(sLineText)
	
	If iLen < 6 Then Return 0
	
	dim as string sTemp = Left(sLineText,7)
	
	If sTemp = "extern " orelse (iLen = 6 andalso sTemp = "extern") Then
		
		If InStr(sLineText , " as ") Then
			
			Return 0
			
		EndIf
		
		Return 1
		
	EndIf
	
End Function

Function atc_k_constructor_proc(sLineText As String) As Integer export
	
	If Len(sLineText) < 12 Then Return 0
	
	If Left(sLineText,12) = "constructor " Then
		
		Return 1
		
	EndIf
	
End Function

Function atc_k_destructor_proc(sLineText As String) As Integer export
	
	If Len(sLineText) < 11 Then Return 0
	
	If Left(sLineText,11) = "destructor " Then
		
		Return 1
		
	EndIf
	
End Function

Function atc_k_operator_proc(sLineText As String) As Integer export
	
	If Len(sLineText) < 11 Then Return 0
	
	If Left(sLineText,9) = "operator " Then
		
		If InStr(sLineText , ")") Then
			
			Return 1
			
		EndIf
		
	EndIf
	
End Function

Function atc_k_property_proc(sLineText As String) As Integer export
	
	If Len(sLineText) < 11 Then Return 0
	
	If Left(sLineText,9) = "property " Then
		
		If InStr(sLineText , ")") Then
			
			Return 1
			
		EndIf
		
	EndIf
	
End Function

Function atc_k_while_proc(sLineText As String) As Integer export
	
	If Len(sLineText) < 5 Then Return 0
	
	dim as string sTemp = Left(sLineText,6)
	
	select case sTemp
			
		Case "while " , "while("
			
			Return 1
			
	End Select
	
	if len(sTemp) = 5 ANDALSO sTemp = "while" THEN
		
		Return 1
		
	EndIf
	
End Function

Function atc_k_do_proc(sLineText As String) As Integer export
	
	Dim As Integer iLen = Len(sLineText)
	
	If iLen < 2 Then Return 0
	
	If Left(sLineText,2) = "do" Then
		
		If iLen = 2 OrElse Mid(sLineText , 3 , 1) = " " Then
			
			Return 1
			
		EndIf
		
	EndIf
	
End Function

Function atc_k_for_proc(sLineText As String) As Integer export
	
	If Len(sLineText) < 12 Then Return 0
	
	select case Left(sLineText,4)
			
		Case "for " , "for("
			
			If InStr(sLineText , " to ") Then
				
				Return 1
				
			EndIf			
			
	End Select
	
End Function

Function atc_k_if_proc(sLineText As String) As Integer export
	
	If Len(sLineText) < 7 Then Return 0
	
	select case Left(sLineText,3)
			
		Case "if " , "if("
			
			dim as Long iPos = instr(3, sLineText , " then")
			
			If iPos Then
				
				if len(sLineText) = iPos+4 then
					
					return 1
					
				else
					
					for i as Long = iPos+4 to len(sLineText)-1
						
						select case sLineText[i]
								
							Case 32 , 9 
								
								continue for
								
							case 39 
								
								function = 1
								
								exit for
								
							case else
								
								exit for
								
						End Select 
						
					Next
					
				EndIf
				
			EndIf		
			
	End Select
	
End Function

Function atc_k_select_proc(sLineText As String) As Integer export
	
	If Len(sLineText) < 11 Then Return 0

	If Left(sLineText,7) = "select " Then

		If InStr(sLineText , " case") Then
			
			Return 1
			
		EndIf
		
	EndIf
	
End Function

Function atc_k_m_if_proc(sLineText As String) As Integer export
	
	If Len(sLineText) < 5 Then Return 0
	
	If Left(sLineText,4) = "#if " _
	orelse (len(sLineText) > 6 andalso Left(sLineText,7) = "#ifdef ") _
	orelse (len(sLineText) > 7 andalso Left(sLineText,8) = "#ifndef ") Then
	
	Return 1
	elseif Left(sLineText , 7) = "#macro " then	
	Return 2
	EndIf
	
End Function

Function atc_k_asm_proc(sLineText As String) As Integer export
	
	dim as string szPosibleAsm = Rtrim(sLineText)
	
	If Len(szPosibleAsm) <> 3 Then Return 0
	
	If szPosibleAsm = "asm" Then
		
		Return 1
		
	EndIf
	
End Function

function atc_has_separator_proc(s as string) as long export
	
	dim as byte bEven 
	
	if InStr(s , ":") then
		
		for i as long= 0 to len(s) - 1
			
			if s[i] = 34 then
				
				bEven xor= 1 
				
			elseif s[i] = 58 then	
				
				if bEven = 0 then
					
					return 1
					
				EndIf
				
			EndIf
			
		Next
		
	endif
	
End Function

Function atc_check_simbol_underscore_proc(sText as string) as Long

	if len(sText) then
		
		sText = ac_truncate_blocks_proc(sText , chr(34) , chr(34))
		
	EndIf
	
	if len(sText) then
		
		sText = ac_truncate_blocks_proc(sText , "/'" , "'/")
		
	EndIf
	
	if len(sText) then
		
		sText = ac_truncate_blocks_proc(sText , "'" , "")
		
	EndIf	
	
	dim as string sSimbols = right(Rtrim(sText , any chr(10) & chr(13) & " " & chr(9)), 2)
	
	if right(sSimbols,1) = "_" then
		
		if len(sSimbols) = 2 then
			
			if (sSimbols[0] > &h2F andalso sSimbols[0] < &h3A) orelse _
			(sSimbols[0] > &h40 andalso sSimbols[0] < &h5B) orelse _
			(sSimbols[0] > &h60 andalso sSimbols[0] < &h7B) orelse sSimbols[0] = &h5F then
			
				return 0
			
			else
				
				return 1
				
			endif
		
		EndIf
		
		return 1
	
	else
		
		return 0
		
	EndIf	
	
End Function

function atc_get_string_from_multiline_text_proc(mt as Ihandle Ptr , iLine As Integer , sRet as string , iCheckUnderscoreFlag as Long) as long
	
	sRet = *IupGetAttribute(mt , "LINE" & iLine)
	
	dim as integer iLineTransfer  = iLine
	
	dim as long iBeginTransferLines = -2

	if iCheckUnderscoreFlag  = 1 andalso atc_check_simbol_underscore_proc(sRet) <> 0 then
		
		return -1
		
	EndIf	
	
	do
		
		if iLineTransfer > 0 then
			
			iLineTransfer -=1
			
			Dim As String sText = *IupGetAttribute(mt , "LINE" & iLineTransfer)

			select case atc_check_simbol_underscore_proc(sText)
				
				Case 1

					sRet = Rtrim(sText, any chr(10) & chr(13) & "_ ") & " " & sRet
					
					iBeginTransferLines = iLineTransfer
					
				case else
				
					exit do
				
			End Select
		
		else
		
			exit do
		
		EndIf
		
	Loop	

	return iBeginTransferLines
	
End Function

Function atc_get_autocomplect_proc(iLine As Integer , sAdded As String) As Integer export

	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Ihandle Ptr mt = TGlobalVariables->tTabsOptions(idTabs).multitext
	
	Dim As String sTextLine
	
	if atc_get_string_from_multiline_text_proc(mt , iLine , sTextLine , 1) = -1 then
		
		return 0
		
	EndIf

	Dim As Integer iL1  = Len(sTextLine), iL2
	
	If iL1 < 2 Then Return 0
	
	Dim As String sTextL = LTrim(sTextLine , Any Chr(9) & " ")
	
	sAdded = Left(sTextLine , iL1 - Len(sTextL) )
	
	sTextL = RTrim(sTextL , Any Chr(9) & Chr(32) & Chr(13) & Chr(10))
	
	iL2 = Len(sTextL)
	
	If iL2 < 2 OrElse atc_has_separator_proc(sTextL) = 1 Then Return 0 
	
	sTextL = LCase(sTextL)
	
	tbspc_fast_tab_in_space_proc(sTextL)

	Select Case Left(sTextL , 1)
			
		Case "f"
			
			if atc_k_for_proc(sTextL) Then Return 16
			
			If atc_k_function_proc(sTextL) Then Return 1
			
		Case "s"
			
			if atc_k_sub_proc(sTextL) Then Return 2
			
			If atc_k_select_proc(sTextL) Then Return 18
			
			If atc_k_scope_proc(sTextL) Then Return 4
			
		Case "t"
			
			if atc_k_type_proc(sTextL) Then Return 3
			
		Case "u"
			
			if atc_k_union_proc(sTextL) Then Return 5
			
		Case "e"
			
			if atc_k_enum_proc(sTextL) Then Return 6
			
			if atc_k_extern_proc(sTextL) Then Return 9
			
		Case "n"
			
			if atc_k_namespace_proc(sTextL) Then Return 7
			
		Case "w"
			
			if atc_k_while_proc(sTextL) Then Return 14
			
			if atc_k_with_proc(sTextL) Then Return 8

		Case "c"
			
			if atc_k_constructor_proc(sTextL) Then Return 10
			
		Case "d"
			
			if atc_k_do_proc(sTextL) Then Return 15
			
			if atc_k_destructor_proc(sTextL) Then Return 11
			
		Case "o"
			
			if atc_k_operator_proc(sTextL) Then Return 12
			
		Case "p"
			
			if atc_k_property_proc(sTextL) Then Return 13
			
			dim as Integer iRet = atc_k_private_proc(sTextL)
					
			if iRet then return iRet

			Return atc_k_public_proc(sTextL)
			
		Case "i"
			
			if atc_k_if_proc(sTextL) Then Return 17
			
		Case "#"
			
			select case atc_k_m_if_proc(sTextL)
					
				Case 1
					
					Return 19
					
				case 2
					
					Return 21
					
			End Select
			
		case "a"
			
			if atc_k_asm_proc(sTextL) Then Return 20
			
	End Select
	
End Function

Sub atc_cursor_on_column_proc(iLine As Integer , sAdded As String) export
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Ihandle Ptr mt = TGlobalVariables->tTabsOptions(idTabs).multitext
	
	Dim As Integer iPos = IupGetInt(mt, "CARETPOS")
	
	If Len(sAdded) Then
		
		IupSetAttribute(mt, "INSERT-1", sAdded )
		
		iPos = iPos + Len(sAdded)
		
	Else
		
		Dim As String sTextLine = *IupGetAttribute(mt , "LINE" & iLine)
		
		Dim As Integer iL1  = Len(sTextLine)
		
		Dim As String sTextL = LTrim(sTextLine , Any Chr(9) & " ")
		
		Dim As String sAdded = Left(sTextLine , iL1 - Len(sTextL) )
		
		If Len(sAdded) Then
			
			IupSetAttribute(mt, "INSERT-1", sAdded )
			
			iPos = iPos + Len(sAdded)
			
		EndIf
		
	EndIf
	
	IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "CARETPOS", iPos)
	
	IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "SCROLLTOPOS", iPos)
	
	
End Sub

Sub atc_autocomplect_proc(iLine As Integer) export
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Ihandle ptr mt = TGlobalVariables->tTabsOptions(idTabs).multitext
	
	Dim As String EOL
	
	Dim As Integer iPos = IupGetInt(mt, "CARETPOS")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends") = "WIN" Then
		
		EOL = Chr(13) & Chr(10)
		
	Else
		
		EOL = Chr(10)
		
	EndIf
	
	Dim As String sIndent
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","indent") = "TAB" Then
		
		sIndent = Chr(9)
		
	Else
		
		sIndent = Space(Val(*IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","indentsize")))
		
	EndIf  	
	
	Dim As String sAdded , sRest , sAddedFull 
	
	Dim As Integer iResult = atc_get_autocomplect_proc(iLine , sAdded)
	
	if iResult then
		
		sRest = *IupGetAttribute(mt , "LINE" & iLine+1) 
		
		sRest = rtrim(sRest, any chr(13) & chr(10))
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","plusrows") = "YES" Then
			
			if len(sRest) then

				sAddedFull = sAdded & sIndent & EOL & sAdded & sIndent & sRest & EOL & sAdded & sIndent & EOL & sAdded
				
				Dim As Integer iPosTemp
				
				IupTextConvertLinColToPos(mt, iLine+1, 0, cast(any ptr, @iPosTemp))
				
				IupSetStrf(mt, "DELETERANGE", !"%d,%d", iPosTemp, len(sRest))
				
			else
				
				sAddedFull = sAdded & sIndent & EOL & sAdded & sIndent & EOL & sAdded & sIndent & EOL & sAdded
				
			EndIf
		
		else
		
			if len(sRest) then

				sAddedFull = sAdded & sIndent & sRest & EOL & sAdded
				
				Dim As Integer iPosTemp
				
				IupTextConvertLinColToPos(mt, iLine+1, 0, cast(any ptr, @iPosTemp))
				
				IupSetStrf(mt, "DELETERANGE", !"%d,%d", iPosTemp, len(sRest))
				
			else
				
				sAddedFull = sAdded & sIndent & EOL & sAdded
				
			EndIf		 
		
		endif   	
		
	EndIf
	
	Select Case iResult
			
		Case 0
			
			atc_cursor_on_column_proc(iLine  , sAdded )
			
		Case 1 ' FUNCTION
			
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Function")
			
		Case 2 ' SUB
			
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Sub")
			
		Case 3  'TYPE
			
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Type")
			
		Case 4  'SCOPE
			
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Scope")
			
		Case 5  'UNION
			
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Union")
			
		Case 6  'ENUM
			
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Enum")
			
		Case 7  'NAMESPACE
			
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Namespace")
			
		Case 8  'WITH
			
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End With")
			
		Case 9  'EXTERN
			
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Extern")
			
		Case 10 'CONSTRUCTOR
			
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Constructor")
			
		Case 11 'DESTRUCTOR
			
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Destructor")
			
		Case 12 'OPERATOR
			
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Operator")
			
		Case 13 'PROPERTY
			
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Property")
			
		Case 14 'WHILE
			
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "Wend")
			
		Case 15 'DO
			
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "Loop")
			
		Case 16 'FOR
			
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "Next")
			
		Case 17 'IF
			
			If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","endifspace")  = "YES" Then
				
				IupSetAttribute(mt, "INSERT-1", sAddedFull & "End If")
				
			else
			
				IupSetAttribute(mt, "INSERT-1", sAddedFull & "EndIf")
				
			EndIf
			
		Case 18 'SELECT
			
			If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","plusrows") = "YES" Then
			
				if len(sRest) then
					
					IupSetAttribute(mt, "INSERT-1", sAdded & sIndent & EOL & sAdded & sIndent & "Case " & sRest & EOL & sAdded & sIndent & EOL & sAdded & "End Select")
					
				else
					
					IupSetAttribute(mt, "INSERT-1", sAdded & sIndent & EOL & sAdded & sIndent & "Case " & EOL & sAdded & sIndent & EOL & sAdded & "End Select")           	
					
				EndIf
			
			else
			
				if len(sRest) then
					
					IupSetAttribute(mt, "INSERT-1", sAdded & sIndent & "Case " & sRest & EOL & sAdded & "End Select")
					
				else
					
					IupSetAttribute(mt, "INSERT-1", sAdded & sIndent & "Case " & EOL & sAdded & "End Select")            	
					
				EndIf			
			
			endif
			
			iPos +=5
			
		Case 19 '#If
			
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "#EndIf")
			
		case 20 'ASM
			
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "End Asm")
			
		case 21 ' #MACRO
			
			IupSetAttribute(mt, "INSERT-1", sAddedFull & "#EndMacro")
			
	End Select
	
	If iResult Then
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","plusrows") = "YES" Then
			
			iPos  = iPos + Len(sAdded)*2 + 2*len(sIndent) + Len(EOL) + len(sRest)
			
		else
			
			iPos  = iPos + Len(sAdded) + len(sIndent) + len(sRest)
			
		EndIf

		IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "CARETPOS", iPos)
		
		IupSetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "SCROLLTOPOS", iPos)
		
	EndIf
	
End Sub

Function atc_autoindent0_proc(mt As Ihandle Ptr , iLine As Integer , iId As Long , ListMKLP as TMultiCommentsLinePositions ptr ) As Integer export
	
	Dim As Integer iLine2 = iLine
	
	Dim As String sIndent
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","indent") = "TAB" Then
		
		sIndent = Chr(9)
		
	Else
		
		sIndent = Space(Val(*IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","indentsize")))
		
	EndIf   
	
	Do
		
		Dim As String sTextLine = *IupGetAttribute(mt , "LINE" & iLine2)
		
		If Len(sTextLine) < 2 Then
			
			iLine2 +=1
			
			If IupGetInt(mt, "LINECOUNT") < iLine2 Then Exit Do
			
			Continue Do
			
		EndIf
		
		Select Case iId
				
			Case 1 To 13 , 17 , 18 , 20
				
				If iId = 17 Then
					
					If LCase(Left(sTextLine , 5)) =  "endif" Then
						
						If (iLine2 - iLine) > 0 Then
							
							For j As Integer = iLine To iLine2-1
								
								Dim As String sTextTemp = *IupGetAttribute(mt , "LINE" & j)
								
								If Len(sTextTemp) >=4 Then
									
									If LCase(Left(sTextTemp,4)) = "else" Then
										
										If bDimFlagLinesAutoEnds(j) = 0 Then
											
											bDimFlagLinesAutoEnds(j) = 1
											
											Continue For
											
										EndIf 
										
									EndIf
									
								EndIf
								
								Dim As Integer iPos
								
								IupTextConvertLinColToPos(mt, j , 0 , cast(any ptr,@iPos))
								
								IupSetAttribute(mt, "INSERT" & iPos, sIndent)
								
							Next
							
						EndIf
						
						iLine2+=1
						
						Exit Do
						
					EndIf
					
				EndIf
				
				
				If LCase(Left(sTextLine , 4)) =  "end " Then
					
					Dim i As Long
					
					For i = 5 To Len(sTextLine)
						
						If Mid(sTextLine, i , 1) <> " " Then
							
							Exit For
							
						EndIf
						
					Next
					
					If LCase(Mid(sTextLine, i , Len(sDimAutoEndsKeywords(iId)))) = sDimAutoEndsKeywords(iId) OrElse ( iId = 17 AndAlso (LCase(Mid(sTextLine, i , 2)) = "if")) Then
						
						If (iLine2 - iLine) > 0 Then
							
							For j As Integer = iLine To iLine2-1
								
								If iId = 17 Then
									
									Dim As String sTextTemp = *IupGetAttribute(mt , "LINE" & j)
									
									If Len(sTextTemp) >=4 Then
										
										If LCase(Left(sTextTemp,4)) = "else" Then
											
											If bDimFlagLinesAutoEnds(j) = 0 Then
												
												bDimFlagLinesAutoEnds(j) = 1
												
												Continue For
												
											EndIf      
											
										EndIf
										
									EndIf
									
								ElseIf iId = 18 Then  
									
									Dim As String sTextTemp = *IupGetAttribute(mt , "LINE" & j)
									
									dim as Long iLen = Len(sTextTemp)
									
									If (iLen < 5) orelse ((iLen >=5) andalso (LCase(Left(sTextTemp,5)) <> "case ")) Then
										
										Dim As Integer iPos
										
										IupTextConvertLinColToPos(mt, j , 0 , cast(any ptr,@iPos))
										
										IupSetAttribute(mt, "INSERT" & iPos, sIndent)                                 									
										
									EndIf                           
									
								EndIf
								
								Dim As Integer iPos
								
								IupTextConvertLinColToPos(mt, j , 0 , cast(any ptr,@iPos))
								
								IupSetAttribute(mt, "INSERT" & iPos, sIndent)
								
							Next
							
						EndIf
						
						iLine2+=1
						
						Exit Do
						
					EndIf
					
				EndIf
				
			Case 14 To 16 , 19 , 21

				If (LCase(Left(sTextLine , Len(sDimAutoEndsKeywords(iId)))) = sDimAutoEndsKeywords(iId)) Then
					
					if (len(sTextLine) = Len(sDimAutoEndsKeywords(iId))) orelse sTextLine[Len(sDimAutoEndsKeywords(iId))] = 32 orelse _
					sTextLine[Len(sDimAutoEndsKeywords(iId))] = 39 orelse sTextLine[Len(sDimAutoEndsKeywords(iId))] = 13 orelse _
					sTextLine[Len(sDimAutoEndsKeywords(iId))] = 9 orelse sTextLine[Len(sDimAutoEndsKeywords(iId))] = 10 then
					
					If (iLine2 - iLine) > 0 Then
						
						For j As Integer = iLine To iLine2-1
							
							Dim As String sTextTemp = *IupGetAttribute(mt , "LINE" & j)
							
							If iId = 19 Then
								
								If Len(sTextTemp) >=5 Then
									
									If LCase(Left(sTextTemp,5)) = "#else" Then
										
										If bDimFlagLinesAutoEnds(j) = 0 Then
											
											bDimFlagLinesAutoEnds(j) = 1
											
											Continue For
											
										EndIf 
										
									EndIf
									
								EndIf
								
							EndIf
							
							Dim As Integer iPos
							
							IupTextConvertLinColToPos(mt, j , 0 , cast(any ptr,@iPos))
							
							IupSetAttribute(mt, "INSERT" & iPos, sIndent)
							
						Next
						
					EndIf
					
					iLine2+=1
					
					Exit Do
					
				endif
				
				EndIf
				
		End Select
		
		if ListMKLP then
			
			if ListMKLP->IsIn(iLine2) then
				
				do
					
					if ListMKLP->IsIn(iLine2) then
						
						iLine2 +=1
						
						If IupGetInt(mt, "LINECOUNT") < iLine2 Then Return iLine2
						
						continue do
						
					else
						
						exit do
						
					EndIf				
					
				Loop
				
				continue do
				
			endif
			
		EndIf
		
		Dim As String sAdded		
		
		Dim As Integer iRet 
		
		if iId <> 20 then ' asm block
			
			iRet = atc_get_autocomplect_proc(iLine2 , sAdded)
			
		EndIf

		If iRet Then
			
			iLine2 = atc_autoindent0_proc(mt , iLine2+1 , iRet , ListMKLP)
			
		Else
			
			iLine2 +=1
			
		EndIf
		
		If IupGetInt(mt, "LINECOUNT") < iLine2 Then Exit Do
		
	Loop
	
	Return iLine2
	
End Function

Sub atc_autoindent_proc() export
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Exit Sub
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Ihandle ptr mt = TGlobalVariables->tTabsOptions(idTabs).multitext
	
	Dim As Integer iLine  , iLineCount = IupGetInt(mt, "LINECOUNT")
	
	If iLineCount < 3 Then Exit Sub
	
	ReDim As Byte bDimFlagLinesAutoEnds(iLineCount)
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	tbspc_spaces_to_tab_begin_proc()
	
	tbspc_tab_to_spaces_begin_proc()
	
	tbspc_remove_leading_spaces_proc(mt)
	
	dim as TMultiCommentsLinePositions ptr ListMKLP = cmt_multi_comments_line_positions_proc(mt)
	
	Dim As String sAdded
	
	Do
		
		if ListMKLP then
			
			if ListMKLP->IsIn(iLine) then
				
				iLine +=1
				
				If iLineCount <= iLine Then Exit Do
				
				continue do
				
			EndIf
			
		EndIf
		
		Dim As Integer iRet = atc_get_autocomplect_proc(iLine , sAdded)
		
		If iRet Then
			
			iLine = atc_autoindent0_proc(mt , iLine + 1 , iRet , ListMKLP)
			
		Else
			
			iLine +=1
			
		EndIf  
		
		If iLineCount <= iLine Then Exit Do
		
	Loop
	
	if ListMKLP then
		
		ListMKLP->delAll()
		
		delete ListMKLP
		
	EndIf	
	
	ReDim As Byte bDimFlagLinesAutoEnds(0)
	
	IupSetAttribute(mt, "ISCHANGES", "YES")
	
	IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
End Sub
