' get status compile (0 - bad , 1 - good)
Function cmp_status_compile_proc(szStr As Zstring Ptr) As Integer Export
	
	Dim As Long iFindPos = 0 , iReturn
	
	Do
		
		iFindPos = Instr(iFindPos+1 , *szStr , "error ")
		
		If iFindPos Then
			
			Dim As Long iFindColon = Instr(iFindPos , *szStr , ":")
			
			If iFindColon = 0 Then 
				
				iReturn = 1
				
				Continue Do
				
			Endif
			
			If (iFindColon - iFindPos) < 15 Then
				
				iReturn =  0
				
				Exit Do
				
			Else
				
				iReturn =  1
				
				Continue Do
				
			Endif
			
		Else
			
			iReturn =  1
			
			Exit Do
			
		Endif
		
	Loop
	
	If iReturn =  0 Then Return 0
	
	iFindPos = 0
	
	Do
		
		iFindPos = Instr(iFindPos+1 , *szStr , ": error: ")
		
		If iFindPos Then
			
			Dim As Long iFindC = Instrrev(*szStr , ".c:" , iFindPos)
			
			If iFindC Andalso (iFindPos - iFindC) < 15 Then
				
				iReturn = 0
				
				Exit Do
				
			Endif
			
		Else
			
			iReturn = 1
			
			Exit Do
			
		Endif
		
	Loop
	
	If iReturn =  0 Then Return 0
	
	iFindPos = 0
	
	Do
		
		#ifdef __fb_win32__
			
			iFindPos = Instr(iFindPos+1 , *szStr , "ld.exe:")
			
		#else
			
			iFindPos = Instr(iFindPos+1 , *szStr , "ld:")
			
		#endif
		
		If iFindPos Then
			
			iReturn =  0
			
			Exit Do
			
		Else
			
			iFindPos = Instr( 1 , *szStr , "Assembler messages:")
			
			If iFindPos Then
				
				iReturn =  0
				
			Else
				
				iReturn =  1
				
			Endif      
			
			Exit Do
			
		Endif
		
	Loop
	
	Return iReturn
	
End Function

' compile
Function cmp_compile_proc(pszCMD As Zstring Ptr , pszParamCMD As Zstring Ptr , iFlagProject As Long = 0 , iFlagQuickRun As Long = 0) As Integer Export
	
	Static As Zstring Ptr pszSavedInfo
	
	Static As Long ipLen = 100000
	
	Dim As Double dTimer = Timer
	
	If pszSavedInfo = 0 Then
		
		pszSavedInfo = Callocate(ipLen)
		
		if pszSavedInfo = 0 then
			
			winout_error_memory_proc()
			
			return 0
			
		EndIf
		
	Endif
	
	For i As Long = 1 To 1000
		
		If i  = 2 Then Continue For
		
		If pszDimErrors(i) Then
			
			Deallocate(pszDimErrors(i))
			
			pszDimErrors(i) = 0
			
		Endif
		
	Next
	
	*pszSavedInfo = ""
	
	#ifdef __fb_win32__
		
		Dim hChildRead  As HANDLE Ptr
		
		Dim hChildWrite As HANDLE Ptr
		
		Dim iReadBytes       As Ulong
		
		Dim szBuffer As Zstring * 1001	
		
		Dim sa As SECURITY_ATTRIBUTES
		
		sa.nLength = Sizeof(SECURITY_ATTRIBUTES)
		
		sa.bInheritHandle = True
		
		If CreatePipe(@hChildRead, @hChildWrite, @sa, NULL)  Then
			
			If SetHandleInformation(hChildRead, HANDLE_FLAG_INHERIT, NULL) Then
				
				Dim pi As PROCESS_INFORMATION
				
				Dim si As STARTUPINFO
				
				si.cb = Sizeof(STARTUPINFO)
				
				si.hStdError = hChildWrite   
				
				si.hStdOutput = hChildWrite  
				
				si.dwFlags = STARTF_USESTDHANDLES
				
				dim as zstring*1024 szCMDTemp = chr(34) & *pszCMD & chr(34) & " " & *pszParamCMD
				
				If CreateProcess( pszCMD ,strptr(szCMDTemp),NULL,NULL,True,CREATE_NO_WINDOW,NULL,NULL,@si,@pi) Then		   	
					
					Closehandle(hChildWrite)
					
					Do
						
						If ReadFile(hChildRead, @szBuffer, 1000, @iReadBytes, NULL) Then
							
							Dim As String sTemp = Left(szBuffer , iReadBytes)
							
							If Len(*pszSavedInfo) + Len(sTemp) > ipLen-1 Then
								
								pszSavedInfo = Reallocate(pszSavedInfo , ipLen + 100000)
								
								if pszSavedInfo = 0 then
									
									winout_error_memory_proc()
									
									Closehandle(hChildRead)
									
									Closehandle( pi.hProcess )
									
									Closehandle( pi.hThread )
									
									return 0
									
								EndIf
								
								ipLen += 100000
								
							Endif
							
							*pszSavedInfo &= sTemp
							
						Else
							
							Exit Do
							
						Endif
						
					Loop
					
					Closehandle(hChildRead)
					
					Closehandle( pi.hProcess )
					
					Closehandle( pi.hThread )
					
				Endif
				
			Endif
			
		Endif
		
	#else
		
		Dim As Integer FF = Freefile
		
		Dim As String sTempP
		
		Open Pipe *pszCMD & *pszParamCMD & " 2>&1" For Input As #FF
		
		While Not Eof( FF )
			
			Line Input #FF, sTempP
			
			If Len(*pszSavedInfo) + Len(sTempP) > ipLen-1 Then
				
				pszSavedInfo = Reallocate(pszSavedInfo , ipLen + 100000)
				
				if pszSavedInfo = 0 then
					
					winout_error_memory_proc()
					
					Close #FF
					
					return 0
					
				EndIf
				
				ipLen += 100000
				
			Endif
			
			*pszSavedInfo &= (sTempP & Chr(13) & Chr(10))
			
		Wend
		
		Close #FF	
		
	#endif
	
	Dim As Long iLen = Len(*pszSavedInfo)
	
	TGlobalVariables->bFlagFindInfo = 0
	
	IupSetfAttribute(TGlobalVariables->buildbox , "REMOVEITEM", "ALL")
	
	Dim As Integer iReturn
	
	Dim As String sTemp 
	
	If iFlagProject Then
		
		If iFlagQuickRun Then
			
			If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","checkcom") = "YES" Then
				
				sTemp = *pszCMD & " Project: """ & *(pProject.pszNameProject) & """ (-exx)"
				
			Else	
				
				sTemp = *pszCMD & " Project: """ & *(pProject.pszNameProject) & """ (No Options)"
				
			Endif
			
		Else
			
			sTemp = *pszCMD & " Project: """ & *(pProject.pszNameProject) & """ (" & *(pProject.pszParamProject) & ")"
			
		Endif
		
	Else
		
		sTemp = *pszCMD & *pszParamCMD
		
	Endif
	
	Dim As Zstring Ptr pszItem = enc_encode_buffer_proc("UTF-8", "" , Cast(Byte Ptr,Strptr(sTemp)), Len(sTemp),iReturn)
	
	pszDimErrors(1) = pszItem
	
	IupSetfAttribute(TGlobalVariables->buildbox , "1", pszDimErrors(1))
	
	IupSetfAttribute(TGlobalVariables->buildbox , "2", " ")
	
	Dim As Long iPosCombo = 3
	
	Dim As Long iPosFind = 0 , iOldFind = 1
	
	Dim As Integer iStatusCompile = cmp_status_compile_proc(*pszSavedInfo)
	
	If iLen > 3 Then
		
		Dim As Integer idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
		
		IupSetStrAttribute(TGlobalVariables->tabs , "CURRENTCOMPILE", Str(idTabs))
		
		Dim As Ihandle Ptr mt = TGlobalVariables->tTabsOptions(idTabs).multitext   
		
		*pszSavedInfo = misc_replace_string_proc(*pszSavedInfo , Chr(13) & Chr(10) , Chr(10) ,  , 1)
		
		Do
			
			iPosFind = Instr(iPosFind+1,*pszSavedInfo, Chr(10))
			
			If iPosFind  Andalso iPosCombo < 999 Then
				
				sTemp = Mid(*pszSavedInfo ,iOldFind, (iPosFind-iOldFind))
				
				sTemp = misc_replace_string_proc(sTemp , "%" , " " , , 1 )
				
				pszItem = enc_encode_buffer_proc("UTF-8", "" , Cast(Byte Ptr,Strptr(sTemp)), Len(sTemp),iReturn)
				
				pszDimErrors(iPosCombo) = pszItem
				
				If pszItem Then
					
					IupSetfAttribute(TGlobalVariables->buildbox , Str(iPosCombo), pszDimErrors(iPosCombo) )
					
				Endif
				
				iPosCombo +=1
				
				iOldFind = iPosFind+1
				
			Else
				
				dTimer = (Timer - dTimer)
				
				IupSetfAttribute(TGlobalVariables->buildbox , Str(iPosCombo), " ")
				
				If iStatusCompile = 1 Then
					
					IupSetfAttribute(TGlobalVariables->buildbox , Str(iPosCombo+1), "Make done (" & Time & " | " & Left(Str(dTimer), 4) & " sec)")
					
				Else
					
					IupSetfAttribute(TGlobalVariables->buildbox , Str(iPosCombo+1), "Build error (" & Time & " | " & Left(Str(dTimer), 4) & " sec)")
					
				Endif
				
				Exit Do
				
			Endif
			
		Loop
		
	Else
		
		dTimer = (Timer - dTimer)
		
		IupSetfAttribute(TGlobalVariables->buildbox , "3", "Make done (" & Time & " | " & Left(Str(dTimer), 4) & " sec)")
		
	Endif
	
	Return iStatusCompile
	
End Function

'preparation before compiling
Function cmp_prepare_compile_proc() As Integer Export
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return 0
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathcompilier") = "" Then
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"),_
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorpathcompile"))
		
		Return 0
		
	Endif   
	
	Dim As Ihandle Ptr list_combo = IupGetDialogChild(TGlobalVariables->toolbar, "comboselectbuild")
	
	Dim As Integer iPosCombo = Val(*IupGetAttribute(list_combo , "VALUE"))
	
	Dim As String sComboText = *IupGetAttribute(list_combo , Str(iPosCombo))
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Chdir(*IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext , "FILEPATH"))
	
	Dim As Zstring*256 szCompilier = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathcompilier")
	
	Dim As Zstring Ptr pszOptionsCompilier
	
	Dim As Long iFlagProject
	
	szCompilier = enc_encode_path_proc(szCompilier , 0)
	
	If Left(szCompilier , 2) = "$A" Then
		
		szCompilier = Exepath() & Mid( szCompilier , 3)
		
	Endif
	
	If Left(sComboText , 3) = "PRJ" Then
		
		#ifdef __fb_win32__
			
			Dim As String sSep = "\"
			
		#else
			
			Dim As String sSep = "/"
			
		#endif
		
		Dim As String sPathDir = *(pProject.pszPathProject) & sSep
		
		Dim As String sOptions = " "
		
		Dim As Long iLen
		
		For i As Long = 0 To 1000
			
			If pProject.tBasFiles(i).pszFile Then
				
				sOptions &= Chr(34) & sPathDir & *(pProject.tBasFiles(i).pszFile) & Chr(34) & " "
				
				For j As Long = 1 To IupGetChildCount(TGlobalVariables->tabs) - 1
					
					If TGlobalVariables->tTabsOptions(j).multitext = pProject.tBasFiles(i).mt Then
						
						If *IupGetAttribute(TGlobalVariables->tTabsOptions(j).multitext, "ISCHANGES") = "YES" Then
							
							fl_save_proc(j)
							
						Endif
						
						Exit For
						
					Endif
					
				Next
				
			Else
				
				Exit For
				
			Endif
			
		Next
		
		For i As Long = 0 To 1000
			
			If pProject.tBiFiles(i).pszFile Then
				
				For j As Long = 1 To IupGetChildCount(TGlobalVariables->tabs) - 1
					
					If TGlobalVariables->tTabsOptions(j).multitext = pProject.tBiFiles(i).mt Then
						
						If *IupGetAttribute(TGlobalVariables->tTabsOptions(j).multitext, "ISCHANGES") = "YES" Then
							
							fl_save_proc(j)
							
						Endif
						
						Exit For
						
					Endif
					
				Next
				
			Else
				
				Exit For
				
			Endif
			
		Next			
		
		For i As Long = 0 To 100
			
			If pProject.tRcFiles(i).pszFile Then
				
				#ifdef __fb_win32__
					
					sOptions &= Chr(34) & sPathDir & *(pProject.tRcFiles(i).pszFile) & Chr(34) & " "
					
				#endif
				
				For j As Long = 1 To IupGetChildCount(TGlobalVariables->tabs) - 1
					
					If TGlobalVariables->tTabsOptions(j).multitext = pProject.tRcFiles(i).mt Then
						
						If *IupGetAttribute(TGlobalVariables->tTabsOptions(j).multitext, "ISCHANGES") = "YES" Then
							
							fl_save_proc(j)
							
						Endif
						
						Exit For
						
					Endif
					
				Next
				
			Else
				
				Exit For
				
			Endif
			
		Next
		
		Dim As String sMain = Chr(34) & Mid(*(pProject.tBasFiles(pProject.iCurentMainFile).pszFile) , 1, Len(*(pProject.tBasFiles(pProject.iCurentMainFile).pszFile)) - 4) & Chr(34)
		
		Dim As String sTempParam = Lcase(*(pProject.pszParamProject))
		
		#ifdef __fb_win32__
			
			If Instr(sTempParam , "-dylib") Orelse Instr(sTempParam , "-dll") Then
				
				sOptions &= *(pProject.pszParamProject) & " -m " & sMain & " -x " & Chr(34) & *(pProject.pszNameProject) & ".dll" & Chr(34)
				
			Elseif Instr(sTempParam , "-lib") Then
				
				sOptions &= *(pProject.pszParamProject) & " -x " & Chr(34) & "lib" & *(pProject.pszNameProject) & ".a" & Chr(34)
				
			Else
				
				sOptions &= *(pProject.pszParamProject) & " -m " & sMain & " -x " & Chr(34) & *(pProject.pszNameProject) & ".exe" & Chr(34)
				
			Endif
			
		#else	
			
			If Instr(sTempParam , "-dylib") Orelse Instr(sTempParam , "-dll") Then
				
				sOptions &= *(pProject.pszParamProject) & " -m " & sMain & " -x " & Chr(34) & *(pProject.pszNameProject) & ".so" & Chr(34)
				
			Elseif Instr(sTempParam , "-lib") Then
				
				sOptions &= *(pProject.pszParamProject) & " -x " & Chr(34) & "lib" & *(pProject.pszNameProject) & ".a" & Chr(34)
				
			Else
				
				sOptions &= *(pProject.pszParamProject) & " -m " & sMain & " -x " & Chr(34) & *(pProject.pszNameProject) & Chr(34)
				
			Endif
			
		#endif
		
		iLen = Len(sOptions)
		
		pszOptionsCompilier = Callocate(iLen + 10)
		
		if pszOptionsCompilier = 0 then
			
			winout_error_memory_proc()
			
			return 0
			
		EndIf
		
		*pszOptionsCompilier = sOptions
		
		iFlagProject = 1
		
	Else
		
		Dim As Zstring*256 szName = *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext , "FILENAME")
		
		If Len(szName) < 4 Orelse Lcase(Right(szName,4)) <> ".bas" Then
			
			IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"),_
			*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrornamecompile"))
			
			Return 0
			
		Endif
		
		Dim As Zstring*256 szFile = *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext , "FILEPATH") & szName
		
		Dim As Zstring Ptr pszTempOptions = Cast(Any Ptr,IupConfigGetVariableStr(TGlobalVariables->hConfig,"BUILD","c" & iPosCombo))
		
		pszOptionsCompilier = Callocate(Len(*pszTempOptions) + Len(szFile) + 10)
		
		if pszOptionsCompilier = 0 then
			
			winout_error_memory_proc()
			
			return 0
			
		EndIf
		
		*pszOptionsCompilier = *pszTempOptions
		
		*pszOptionsCompilier = " " & Chr(34) & szFile & Chr(34) & " " & *pszOptionsCompilier
		
		If *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ISCHANGES") = "YES" Then
			
			fl_save_proc(idTabs )
			
		Endif
		
	Endif
	
	IupSetfAttribute(TGlobalVariables->buildbox , "REMOVEITEM", "ALL")
	
	IupSetfAttribute(TGlobalVariables->buildbox , "1", "Wait, compilation in progress...")
	
	IupFlush()
	
	Function = cmp_compile_proc( szCompilier,  pszOptionsCompilier , iFlagProject)
	
	if pszOptionsCompilier then Deallocate(pszOptionsCompilier)
	
End Function

Sub cmp_create_exe_script_proc(sEXE As String , sParamsCommand As String)
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Zstring*256 szPathName = *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext , "FILEPATH")
	
	Dim As Integer f = Freefile
	
	Dim As String sNameMake = "make_ifb1221"
	
	#ifdef __fb_win32__
		
		Dim As String sPathScript = szPathName & sNameMake & ".cmd"
		
		If Fileexists(sPathScript) Then
			
			Kill(sPathScript)
			
		Endif
		
		Open sPathScript For Binary As #f
		
		If Err > 0 Then Exit Sub
		
		Dim As Zstring*1300 szDosPath = Chr(34) & sEXE & Chr(34) & sParamsCommand
		
		CharToOem(szDosPath , szDosPath)
		
		Dim As String sBuffer = szDosPath & Chr(13) & Chr(10) & "pause"
		
		Put #f, , sBuffer
		
		Close #f
		
		Shell( Chr(34) & Chr(34) & sPathScript & Chr(34) & " & del " & Chr(34) & sPathScript & Chr(34 ) & Chr(34))
		
	#else
		
		Dim As String sPathScript
		
		If Len(szPathName) Then
			
			sPathScript = szPathName & sNameMake & ".sh"
			
		Else
			
			sPathScript = "./" & sNameMake & ".sh"
			
		Endif
		
		If Fileexists(sPathScript) Then
			
			Kill( sPathScript )
			
		Endif		
		
		sPathScript = misc_replace_string_proc(sPathScript," ","\ ",,1)
		
		sPathScript = misc_replace_string_proc(sPathScript,"(","\(",,1)
		
		sPathScript = misc_replace_string_proc(sPathScript,")","\)",,1)		
		
		If Len(szPathName) Then
			
			Open szPathName & sNameMake & ".sh" For Binary As #f
			
		Else
			
			Open "./" & sNameMake & ".sh" For Binary As #f
			
		Endif
		
		If Err > 0 Then Exit Sub
		
		Dim As String sBuffer = "#!/bin/sh" & Chr(10) & Chr(10) & _
		"rm " & sPathScript & Chr(10) & Chr(10) & sEXE & sParamsCommand & Chr(10) & Chr(10) & "exec bash"
		
		Put #f, , sBuffer
		
		Close #f
		
		If Lcase(*IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path", "pathterminal")) = "gnome-terminal" Then
			
			Shell( *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path", "pathterminal") & " -- chmod 755 " & sPathScript )
			
			Shell( *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path", "pathterminal") & " -- " & sPathScript )
			
		Else
			
			Shell( *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path", "pathterminal") & " -e ""chmod 755 " & sPathScript & """" )
			
			Shell( *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path", "pathterminal") & " -e """ & sPathScript & """" )
			
		Endif
		
	#endif
	
End Sub

' A separate thread to run exe
Sub cmp_startExeThread_proc ( Byval param As Any Ptr ) Export
	
	Dim As TProcess Ptr anyProcess = Cast( TProcess Ptr, param )
	
	Dim As Zstring*1024 sParamsCommand = *IupConfigGetVariableStr(TGlobalVariables->hConfig, "BUILD", "comexeparams")
	
	If Len(sParamsCommand) Then
		
		sParamsCommand = misc_replace_string_proc(sParamsCommand,"$_GDB_","")	
		
	Endif
	
	#ifdef __fb_win32__ 
		
		If Len(sParamsCommand) Then
			
			sParamsCommand = " " & Trim(enc_encode_path_proc(sParamsCommand , 0))
			
		Endif
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","checkcom") = "YES" Then
			
			cmp_create_exe_script_proc(*(anyProcess->pszExeName) , sParamsCommand)
			
		Else   
			
			Exec( *(anyProcess->pszExeName), Trim(sParamsCommand) )
			
		Endif
		
	#else
		
		Dim As String sPath = misc_replace_string_proc(*(anyProcess->pszExeName)," ","\ ",,1)
		
		sPath = misc_replace_string_proc(sPath,"(","\(",,1)
		
		sPath = misc_replace_string_proc(sPath,")","\)",,1)		
		
		If Len(sParamsCommand) Then
			
			sParamsCommand = " " & Trim(sParamsCommand)
			
		Endif
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","checkcom") = "YES" Then
			
			cmp_create_exe_script_proc(sPath , sParamsCommand)
			
		Else
			
			If Lcase(*IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path", "pathterminal")) = "gnome-terminal" Then
				
				Shell( *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path", "pathterminal") & " -- " & sPath & sParamsCommand)
				
			Else
				
				Shell( *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path", "pathterminal") & " -e """ & sPath & sParamsCommand & """" )
				
			Endif
			
		Endif
		
	#endif
	
	If anyProcess->pszFileName Then
		
		If Fileexists(*(anyProcess->pszFileName)) Then Kill *(anyProcess->pszFileName)
		
		If Fileexists(*(anyProcess->pszExeName)) Then Kill *(anyProcess->pszExeName)
		
	Endif
	
	If anyProcess->pszFileName Then Deallocate(anyProcess->pszFileName)
	
	If anyProcess->pszExeName Then Deallocate(anyProcess->pszExeName)
	
	Delete anyProcess
	
End Sub


' start compiled program
Sub cmp_start_program_proc () Export
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Exit Sub
	
	#ifdef __fb_win32__ 
	#else
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path", "pathterminal") = "" Then
			
			IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"),_
			*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrornotterminal"))   
			
			Exit Sub   
			
		Endif
	#endif
	
	Dim As Ihandle Ptr list_combo = IupGetDialogChild(TGlobalVariables->toolbar, "comboselectbuild")
	
	Dim As Integer iPosCombo = Val(*IupGetAttribute(list_combo , "VALUE"))
	
	Dim As String sComboText = *IupGetAttribute(list_combo , Str(iPosCombo))
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Zstring*256 szName = *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext , "FILENAME")
	
	Dim As Zstring*256 szFile
	
	If Left(sComboText , 3) = "PRJ" Then
		
		#ifdef __fb_win32__ 
			
			szFile = *(pProject.pszPathProject) & "\" & *(pProject.pszNameProject) & ".exe"
			
		#else
			
			szFile = *(pProject.pszPathProject) & "/" & *(pProject.pszNameProject)
			
		#endif
		
	Else
		
		If Len(szName) < 4 Orelse Lcase(Right(szName,4)) <> ".bas" Then
			
			IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"),_
			*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrornamecompile"))
			
			Exit Sub
			
		Else
			
			szName = Left(szName, Len(szName) - 4)
			
			#ifdef __fb_win32__ 
				
				szName &= ".exe"
				
			#endif      
			
		Endif
		
		szFile = *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext , "FILEPATH") & szName
		
	Endif
	
	If Fileexists(szFile) = 0 Then Exit Sub
	
	Dim As TProcess Ptr anyProcess = New TProcess
	
	if anyProcess = 0 then
		
		winout_error_memory_proc()
		
		exit sub
		
	EndIf
	
	anyProcess->pszExeName = Callocate(Len(szFile)+30)
	
	if anyProcess->pszExeName = 0 then
		
		winout_error_memory_proc()
		
		delete anyProcess
		
		exit sub
		
	EndIf
	
	*(anyProcess->pszExeName) = szFile
	
	Dim As Any Ptr thread = Threadcreate( Cast(Any Ptr,@cmp_startExeThread_proc), Cast(Any Ptr,anyProcess) )
	
End Sub


Sub cmp_quick_run_proc() Export 
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Exit Sub
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathcompilier") = "" Then
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"),_
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorpathcompile"))
		
		Exit Sub	 
		
	Endif
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Long iFlagProject , iFlagQuickRun
	
	Dim As Ihandle Ptr list_combo = IupGetDialogChild(TGlobalVariables->toolbar, "comboselectbuild")
	
	Dim As Integer iPosCombo = Val(*IupGetAttribute(list_combo , "VALUE"))
	
	Dim As String sComboText = *IupGetAttribute(list_combo , Str(iPosCombo))
	
	Dim As Zstring*256 szPathName = *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext , "FILEPATH")   
	
	Dim As Zstring Ptr pszOptionsCompilier
	
	Dim As Zstring*256 szCompilier = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathcompilier")
	
	szCompilier = enc_encode_path_proc(szCompilier , 0)
	
	If Left(szCompilier , 2) = "$A" Then
		
		szCompilier = Exepath() & Mid( szCompilier , 3)
		
	Endif
	
	If szPathName <> "" Then
		
		Chdir(szPathName)
		
	Else
		
		Chdir(Exepath)
		
	Endif
	
	If Len(szPathName)  Then
		
		szPathName &= "FBTEMP.bas"
		
	Else
		
		#ifdef __fb_win32__ 
			
			szPathName = Exepath & "\FBTEMP.bas"
			
		#else
			
			szPathName = Exepath & "/FBTEMP.bas"
			
		#endif
		
	Endif
	
	If Left(sComboText , 3) = "PRJ" Then
		
		#ifdef __fb_win32__
			
			Dim As String sPathDir = *(pProject.pszPathProject) & "\"
			
		#else
			
			Dim As String sPathDir = *(pProject.pszPathProject) & "/"
			
		#endif
		
		Dim As String sOptions = " "
		
		Dim As Long iLen
		
		For i As Long = 0 To 1000
			
			If pProject.tBasFiles(i).pszFile Then
				
				sOptions &= Chr(34) & sPathDir & *(pProject.tBasFiles(i).pszFile) & Chr(34) & " "
				
				For j As Long = 1 To IupGetChildCount(TGlobalVariables->tabs) - 1
					
					If TGlobalVariables->tTabsOptions(j).multitext = pProject.tBasFiles(i).mt Then
						
						If *IupGetAttribute(TGlobalVariables->tTabsOptions(j).multitext, "ISCHANGES") = "YES" Then
							
							fl_save_proc(j)
							
						Endif
						
						Exit For
						
					Endif
					
				Next
				
			Else
				
				Exit For
				
			Endif
			
		Next
		
		For i As Long = 0 To 1000
			
			If pProject.tBiFiles(i).pszFile Then
				
				For j As Long = 1 To IupGetChildCount(TGlobalVariables->tabs) - 1
					
					If TGlobalVariables->tTabsOptions(j).multitext = pProject.tBiFiles(i).mt Then
						
						If *IupGetAttribute(TGlobalVariables->tTabsOptions(j).multitext, "ISCHANGES") = "YES" Then
							
							fl_save_proc(j)
							
						Endif
						
						Exit For
						
					Endif
					
				Next
				
			Else
				
				Exit For
				
			Endif
			
		Next
		
		For i As Long = 0 To 100
			
			If pProject.tRcFiles(i).pszFile Then
				
				#ifdef __fb_win32__
					
					sOptions &= Chr(34) & sPathDir & *(pProject.tRcFiles(i).pszFile) & Chr(34) & " "
					
				#endif
				
				For j As Long = 1 To IupGetChildCount(TGlobalVariables->tabs) - 1
					
					If TGlobalVariables->tTabsOptions(j).multitext = pProject.tRcFiles(i).mt Then
						
						If *IupGetAttribute(TGlobalVariables->tTabsOptions(j).multitext, "ISCHANGES") = "YES" Then
							
							fl_save_proc(j)
							
						Endif
						
						Exit For
						
					Endif
					
				Next
				
			Else
				
				Exit For
				
			Endif
			
		Next
		
		Dim As String sMain = Chr(34) & Mid(*(pProject.tBasFiles(pProject.iCurentMainFile).pszFile) , 1, Len(*(pProject.tBasFiles(pProject.iCurentMainFile).pszFile)) - 4) & Chr(34)
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","checkcom") = "YES" Then
			
			sOptions &= " -exx -m " & sMain & " -x FBTEMP"
			
		Else
			
			sOptions &= " -m " & sMain & " -x FBTEMP"
			
		Endif
		
		#ifdef __fb_win32__
			
			sOptions &= ".exe"
			
		#endif
		
		iLen = Len(sOptions)
		
		pszOptionsCompilier = Callocate(iLen + 10)
		
		if pszOptionsCompilier = 0 then
			
			winout_error_memory_proc()
			
			exit sub
			
		EndIf
		
		*pszOptionsCompilier = sOptions
		
		iFlagProject = 1
		
		iFlagQuickRun = 1	
		
	Else
		
		Dim As Long iSizeReturn
		
		Dim As Byte Ptr pbData = fl_prepare_before_saving_proc(iSizeReturn , idTabs )
		
		If pbData <> 0 Then
			
			If fl_write_file_proc(szPathName ,pbData,iSizeReturn) = 0 Then
				
				IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"),_
				*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorwritefile"))
				
				Deallocate(pbData)
				
				Exit Sub
				
			Else
				
				Deallocate(pbData)
				
			Endif
			
		Else
			
			Exit Sub	
			
		Endif
		
		pszOptionsCompilier = Callocate(Len(szPathName) + 20)
		
		if pszOptionsCompilier = 0 then
			
			winout_error_memory_proc()
			
			exit sub
			
		EndIf
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","checkcom") = "YES" Then
			
			*pszOptionsCompilier = "-exx"
			
		Endif
		
		*pszOptionsCompilier = " " & Chr(34) & szPathName & Chr(34) & " " & *pszOptionsCompilier
		
	Endif
	
	IupSetfAttribute(TGlobalVariables->buildbox , "REMOVEITEM", "ALL")
	
	IupSetfAttribute(TGlobalVariables->buildbox , "1", "Wait, compilation in progress...")
	
	IupFlush()
	
	Dim As Integer iStatus = cmp_compile_proc( szCompilier,  pszOptionsCompilier  , iFlagProject , iFlagQuickRun)
	
	if pszOptionsCompilier then Deallocate(pszOptionsCompilier)
	
	If iStatus Then
		
		Dim As Zstring*256 szExe
		
		szExe = Left(szPathName, Len(szPathName) - 4)
		
		#ifdef __fb_win32__ 
			
			szExe &= ".exe"
			
		#endif  
		
		If Fileexists(szExe) = 0 Then 
			
			If Fileexists(szPathName) Then Kill szPathName 
			
			Exit Sub
			
		Endif
		
		Dim As TProcess Ptr anyProcess = New TProcess
		
		if anyProcess = 0 then
			
			winout_error_memory_proc()
			
			exit sub
			
		EndIf
		
		anyProcess->pszExeName = Callocate(Len(szExe)+30) ' +30 for rewrite spaces on the "\ "
		
		anyProcess->pszFileName = Callocate(Len(szPathName)+1)
		
		if anyProcess->pszExeName = 0 orelse anyProcess->pszFileName = 0 then
			
			if anyProcess->pszExeName then deallocate(anyProcess->pszExeName) 
			
			if anyProcess->pszFileName then deallocate(anyProcess->pszFileName)
			
			winout_error_memory_proc()
			
			exit sub
			
		EndIf
		
		*(anyProcess->pszExeName) = szExe
		
		*(anyProcess->pszFileName) = szPathName
		
		Dim As Any Ptr thread = Threadcreate( Cast(Any Ptr,@cmp_startExeThread_proc), Cast(Any Ptr,anyProcess) )   
		
	Else
		
		If Fileexists(szPathName) Then Kill szPathName
		
	Endif
	
End Sub

Sub cmp_run_with_debug_proc() Export
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Exit Sub
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As String sPathDebugger = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathdebugger")
	
	Dim As Ihandle Ptr list_combo = IupGetDialogChild(TGlobalVariables->toolbar, "comboselectbuild")
	
	Dim As Integer iPosCombo = Val(*IupGetAttribute(list_combo , "VALUE"))
	
	Dim As String sComboText = *IupGetAttribute(list_combo , Str(iPosCombo))
	
	Dim As String sPathFile , sParamsCommand
	
	If Len(sPathDebugger) = 0 Then
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle") , _
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorpathdebug"))
		
		Exit Sub
		
	Endif
	
	sPathDebugger = enc_encode_path_proc(sPathDebugger , 0)
	
	If Left(sPathDebugger , 2) = "$A" Then
		
		sPathDebugger = Exepath() & Mid( sPathDebugger , 3)
		
	Endif
	
	If Left(sComboText , 3) = "PRJ" Then
		
		#ifdef __fb_win32__ 
			
			sPathFile = *(pProject.pszPathProject) & "\" & *(pProject.pszNameProject) & ".bas"
			
		#else
			
			sPathFile = *(pProject.pszPathProject) & "/" & *(pProject.pszNameProject) & ".bas"
			
		#endif
		
	Else
		
		sPathFile = *IupGetAttribute(TGlobalVariables->tTabsOptions(idtabs).multitext,"FILEPATH") 
		
		If Len(sPathFile) = 0 Then
			
			IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"),_
			*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrornamecompile"))      
			
			Exit Sub
			
		Endif
		
		sPathFile &= *IupGetAttribute(TGlobalVariables->tTabsOptions(idtabs).multitext,"FILENAME")
		
	Endif
	
	If Lcase(Right(sPathFile , 4)) = ".bas" Then   
		
		sPathFile = Left(sPathFile , Len(sPathFile)-4)
		
		#ifdef __fb_win32__ 
			
			sPathFile &= ".exe"
			
		#endif 
		
		If Fileexists(sPathFile) Then
			
			#ifndef __fb_win32__
				
				sPathFile = misc_replace_string_proc(sPathFile," ","\ ")
				
			#endif
			
			sPathFile = Chr(34) & sPathFile & Chr(34)
			
			sParamsCommand = *IupConfigGetVariableStr(TGlobalVariables->hConfig, "BUILD", "comexeparams")
			
			If Len(sParamsCommand) Then
				
				#ifdef __fb_win32__ 
					
					sParamsCommand = enc_encode_path_proc(sParamsCommand , 0)
					
				#endif
				
				Dim As Long iFind = Instr(sParamsCommand , "$_GDB_")
				
				If iFind Then
					
					sParamsCommand = misc_replace_string_proc(sParamsCommand,"$_GDB_","")
					
					sPathFile = "--args " & sPathFile & " " & Trim(sParamsCommand)
					
				Else
					
					sPathFile &= (" " & Trim(sParamsCommand))
					
				Endif
				
			Endif
			
			IupExecute(sPathDebugger, sPathFile)
			
		Else
			
			IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"),_
			*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrornotexist"))		   
			
		Endif
		
	Else
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"),_
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrornamecompile"))		
		
	Endif
	
End Sub

Sub cmp_command_for_exe_proc()
	
	Dim As Ihandle Ptr com_dlg , btncomok , btncomcancel , txtcom, lbl, vbox , hboxtxt, hboxbtn , hboxlbl
	
	txtcom = IupText("")
	
	IupSetAttributes(txtcom, "EXPAND=YES")
	
	IupSetAttribute(txtcom, "NAME", "COM_TXT")
	
	IupSetAttribute(txtcom, "MINSIZE", "400x25")
	
	IupSetStrAttribute(txtcom, "VALUE", *IupConfigGetVariableStr(TGlobalVariables->hConfig,"BUILD","comexeparams"))
	
	btncomok = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtnok"),NULL)
	
	IupSetAttribute(btncomok, "NAME", "COM_OK")
	
	IupSetAttribute(btncomok, "MINSIZE", "85x")
	
	IupSetCallback(btncomok, "ACTION", Cast(Any Ptr , @com_btnok_action_callback))
	
	btncomcancel = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtncancel"),NULL)
	
	IupSetAttribute(btncomcancel, "NAME", "COM_CANCEL")
	
	IupSetAttribute(btncomcancel, "MINSIZE", "85x")
	
	IupSetCallback(btncomcancel, "ACTION", Cast(Any Ptr , @com_btncancel_action_callback))
	
	lbl = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"tipgdb"))
	
	IupSetAttribute(lbl, "MINSIZE", "x80")
	
	IupSetAttribute(lbl, "MAXSIZE", "400x")
	
	IupSetAttribute(lbl, "WORDWRAP", "YES")
	
	hboxtxt = IupHbox( txtcom , null)
	
	hboxbtn = IupHbox(IupFill() , btncomok , btncomcancel, IupFill(), null)
	
	hboxlbl = IupHbox( IupFill(), lbl , IupFill(), null)
	
	IupSetAttribute(hboxtxt, "NMARGIN" , "10x")
	
	IupSetAttribute(hboxbtn, "NMARGIN" , "10x")
	
	IupSetAttribute(hboxlbl, "NMARGIN" , "10x")
	
	IupSetAttribute(hboxlbl, "FGCOLOR" , "230 100 50")
	
	IupSetAttribute(hboxbtn , "GAP" , "10")
	
	vbox = IupVbox(IUpFill() , hboxtxt , hboxlbl, hboxbtn , IupFill(), null)
	
	IupSetAttribute(vbox , "GAP" , "20")
	
	com_dlg = IupDialog(vbox)
	
	IupSetAttribute(com_dlg, "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"menucommand"))
	
	IupSetAttribute(com_dlg, "DIALOGFRAME", "Yes")
	
	IupSetAttributeHandle(com_dlg, "PARENTDIALOG", TGlobalVariables->dlg )
	
	IupSetAttributeHandle(com_dlg, "DEFAULTENTER", btncomok)
	
	IupSetAttributeHandle(com_dlg, "DEFAULTESC", btncomcancel)
	
	IupSetCallback(com_dlg, "CLOSE_CB", Cast(Any Ptr , @com_close_action_callback))
	
	IupShow(com_dlg)
	
End Sub
