' Simvols to lowercase or uppercase
Sub cnv_convert_lower_or_upper_case_proc (iParam As Integer ) Export 
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Integer iStartPos, iEndPos
	
	IupGetIntInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTIONPOS", Cast(Any Ptr,@iStartPos), Cast(Any Ptr,@iEndPos))
	
	Dim As Zstring Ptr pszText = IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTEDTEXT")
	
	If Len(*pszText) = 0 Then Exit Sub
	
	Dim As Integer iSizeReturn
	
	Dim As Wstring Ptr pwsFileToCode
	
	Dim As Zstring Ptr pszFileToCode2
	
	#ifdef __fb_win32__	
		pwsFileToCode = Cast(Wstring Ptr , enc_encode_buffer_proc("UTF-16LE", "UTF-8" , Cast(Byte Ptr, pszText) , Len(*pszText) , iSizeReturn))	
	#else	
		pwsFileToCode = Cast(Wstring Ptr , enc_encode_buffer_proc("UTF-32LE", "UTF-8" , Cast(Byte Ptr, pszText) , Len(*pszText) , iSizeReturn))	
	#endif	
	
	If pwsFileToCode Then
		
		If iParam = 0 Then
			
			*pwsFileToCode = Lcase(*pwsFileToCode)
			
		Else
			
			*pwsFileToCode = Ucase(*pwsFileToCode)
			
		Endif	
		
	Else
		
		Exit Sub
		
	Endif	
	
	#ifdef __fb_win32__
		pszFileToCode2 = Cast(Zstring Ptr , enc_encode_buffer_proc("UTF-8", "UTF-16LE" , Cast(Byte Ptr, pwsFileToCode ) , Len(*pwsFileToCode)*Sizeof(Wstring) , iSizeReturn))	
	#else	
		pszFileToCode2 = Cast(Zstring Ptr , enc_encode_buffer_proc("UTF-8", "UTF-32LE" , Cast(Byte Ptr, pwsFileToCode ) , Len(*pwsFileToCode)*Sizeof(Wstring) , iSizeReturn))	
	#endif
	
	If pszFileToCode2 Then
		
		IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
		
		IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTEDTEXT", pszFileToCode2)
		
		IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTIONPOS", !"%d:%d", iStartPos, iEndPos)
		
		IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "UNDOACTION", "End")
		
		IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ISCHANGES", "YES")
		
		Deallocate (pwsFileToCode)
		
		Deallocate (pszFileToCode2)
		
	Else
		
		Deallocate (pwsFileToCode)
		
	Endif
	
End Sub

Type CNV_TYPE_BLOCKS_COMMENTS
	
	iStartBlock As Long
	
	iEndBlock As Long	
	
End Type

Type CNV_TYPE_BLOCKS Extends CNV_TYPE_BLOCKS_COMMENTS
	
	iStartTwoWord As Long
	
	iEndTwoWord As Long
	
End Type

Redim Shared As CNV_TYPE_BLOCKS cnv_iBlocks()

Redim Shared As CNV_TYPE_BLOCKS_COMMENTS cnv_Comments_text()

Function cnv_get_commentstext_from_wbuffer(pwBuf As Wstring Ptr) As Long
	
	Dim As Long iBeginComments = 1 , iEndComments  , iIndex
	
	Do
		
		iBeginComments = Instr(iBeginComments , *pwBuf , "/'")
		
		If iBeginComments Then
			
			iEndComments = Instr(iBeginComments , *pwBuf , "'/")
			
			If iEndComments Then
				
				cnv_Comments_text(iIndex).iStartBlock = iBeginComments
				
				cnv_Comments_text(iIndex).iEndBlock = iEndComments
				
				iIndex +=1
				
				If iIndex > Ubound(cnv_Comments_text) Then
					
					Redim Preserve As CNV_TYPE_BLOCKS_COMMENTS cnv_Comments_text(iIndex + 100)
					
				Endif
				
				iBeginComments = iEndComments+2
				
			Else
				
				Return iIndex
				
			Endif
			
		Else
			
			iBeginComments = 1
			
			Do
				
				iBeginComments = Instr(iBeginComments , *pwBuf , "'")
				
				If iBeginComments Then
					
					iEndComments = Instr(iBeginComments , *pwBuf , Wchr(10))
					
					If iEndComments Then
						
						cnv_Comments_text(iIndex).iStartBlock = iBeginComments
						
						cnv_Comments_text(iIndex).iEndBlock = iEndComments
						
						iIndex +=1
						
						If iIndex > Ubound(cnv_Comments_text) Then
							
							Redim Preserve As CNV_TYPE_BLOCKS_COMMENTS cnv_Comments_text(iIndex + 100)
							
						Endif
						
						iBeginComments = iEndComments+1
						
					Else
						
						Return iIndex
						
					Endif
					
				Else
					
					Return iIndex
					
				Endif				
				
			Loop
			
		Endif
		
	Loop
	
End Function

Function cnv_find_commenttext(Byref iStart As Long , iIndexCommentsArray As Long) As Long
	
	For j As Long = 0 To iIndexCommentsArray - 1
		
		If iStart > cnv_Comments_text(j).iStartBlock Andalso iStart < cnv_Comments_text(j).iEndBlock Then
			
			iStart = cnv_Comments_text(j).iEndBlock
			
			Return 1
			
		Endif
		
	Next
	
End Function

Function cnv_find_asmblock(pwBuf As Wstring Ptr) As Long
	
	Dim As Long iStart = 1 , iEnd , iLenBuf = Len(*pwBuf) , iIndexArray , iIndexCommentsArray
	
	If iLenBuf < 4 Then Return 0
	
	Redim As CNV_TYPE_BLOCKS cnv_iBlocks(100)
	
	Redim As CNV_TYPE_BLOCKS_COMMENTS cnv_Comments_text(100)
	
	Dim As Wstring Ptr pTempBuf = Callocate((iLenBuf+2)*Sizeof(Wstring))
	
	if pTempBuf = 0 then
		
		winout_error_memory_proc()
		
		return 0
		
	EndIf
	
	*pTempBuf = Lcase(*pwBuf)
	
	iIndexCommentsArray = cnv_get_commentstext_from_wbuffer(pTempBuf)
	
	Do
		
		iStart = Instr(iStart , *pTempBuf , "asm")
		
		If iStart Then
			
			If cnv_find_commenttext(iStart , iIndexCommentsArray) Then
				
				Continue Do
				
			Endif
			
			If iStart < iLenBuf - 3 Then
				
				If iStart = 1 Orelse (*pTempBuf)[iStart-2] = 10 Orelse (*pTempBuf)[iStart-2] = 32  Orelse (*pTempBuf)[iStart-2] = 9 Then
					
					Var iFindEndString = Instr(iStart , *pTempBuf , Wchr(10))
					
					If iFindEndString Then
						
						If Len(Trim(Mid(*pTempBuf , iStart , iFindEndString - iStart) , Any Wchr(13) & Wchr(10) & Wchr(9) & " ")) = 3 _
						Orelse (*pTempBuf)[iStart+2] = 47 Orelse (*pTempBuf)[iStart+2] = 39 Then
							
							iEnd = iStart+3
							
							Do
								
								iEnd = Instr(iEnd , *pTempBuf , "asm")
								
								If iEnd Then
									
									If cnv_find_commenttext(iEnd , iIndexCommentsArray) Then
										
										Continue Do
										
									Else
										
										If ((*pTempBuf)[iEnd-2] = 32 Orelse (*pTempBuf)[iEnd-2] = 9) _
										Andalso ((*pTempBuf)[iEnd+2] = 32 Orelse (*pTempBuf)[iEnd+2] = 9 _
										Orelse (*pTempBuf)[iEnd+2] = 13 Orelse (*pTempBuf)[iEnd+2] = 10 _
										Orelse (*pTempBuf)[iEnd+2] = 47 Orelse (*pTempBuf)[iEnd+2] = 39 _
										Orelse (*pTempBuf)[iEnd+2] = 0) Then
											
											Exit Do
											
										Endif
										
										iEnd+=3
										
										Continue Do
										
									Endif
									
								Else
									
									Exit Do
									
								Endif
								
							Loop
							
							If iEnd Then
								
								cnv_iBlocks(iIndexArray).iStartBlock = iStart - 1
								
								cnv_iBlocks(iIndexArray).iStartTwoWord = Instrrev( *pTempBuf , "end" , iEnd )
								
								cnv_iBlocks(iIndexArray).iEndBlock = iEnd+1
								
								cnv_iBlocks(iIndexArray).iEndTwoWord = cnv_iBlocks(iIndexArray).iEndBlock
								
								iStart = cnv_iBlocks(iIndexArray).iEndBlock + 1
								
							Else
								
								Exit Do	
								
							Endif
							
						Else
							
							If (*pTempBuf)[iStart+2] = 32 Orelse (*pTempBuf)[iStart+2] = 9 Then
								
								Dim As Wstring*200 wsTemp = Ltrim(Mid(*pTempBuf , iStart+3 , iFindEndString-(iStart+3)) , Any Wchr(9) & " ")
								
								If wsTemp[0] = 39 Orelse wsTemp[0] = 47 Then
									
									iEnd = iStart+3
									
									Do
										
										iEnd = Instr(iEnd , *pTempBuf , "asm")
										
										If iEnd Then
											
											If cnv_find_commenttext(iEnd , iIndexCommentsArray) Then
												
												Continue Do
												
											Else
												
												If ((*pTempBuf)[iEnd-2] = 32 Orelse (*pTempBuf)[iEnd-2] = 9) _
												Andalso ((*pTempBuf)[iEnd+2] = 32 Orelse (*pTempBuf)[iEnd+2] = 9 _
												Orelse (*pTempBuf)[iEnd+2] = 13 Orelse (*pTempBuf)[iEnd+2] = 10 _
												Orelse (*pTempBuf)[iEnd+2] = 47 Orelse (*pTempBuf)[iEnd+2] = 39 _
												Orelse (*pTempBuf)[iEnd+2] = 0) Then
													
													Exit Do
													
												Endif
												
												iEnd+=3
												
												Continue Do
												
											Endif
											
										Else
											
											Exit Do
											
										Endif
										
									Loop
									
									If iEnd Then
										
										cnv_iBlocks(iIndexArray).iStartBlock = iStart - 1
										
										cnv_iBlocks(iIndexArray).iStartTwoWord = Instrrev( *pTempBuf , "end" , iEnd )
										
										cnv_iBlocks(iIndexArray).iEndBlock = iEnd+1
										
										cnv_iBlocks(iIndexArray).iEndTwoWord = cnv_iBlocks(iIndexArray).iEndBlock
										
										iStart = cnv_iBlocks(iIndexArray).iEndBlock + 1
										
									Else
										
										Exit Do	
										
									Endif									
									
								Else
									
									cnv_iBlocks(iIndexArray).iEndBlock = iFindEndString - 1
									
									iStart = iFindEndString
									
								Endif
								
							Else
								
								iStart+=3
								
								Continue Do
								
							Endif
							
						Endif
						
						iIndexArray +=1
						
						If iIndexArray > Ubound(cnv_iBlocks) Then
							
							Redim Preserve As CNV_TYPE_BLOCKS cnv_iBlocks(Ubound(cnv_iBlocks)+50)
							
						Endif
						
					Else
						
						cnv_iBlocks(iIndexArray).iStartBlock = iStart - 1
						
						cnv_iBlocks(iIndexArray).iEndBlock = iLenBuf - 1
						
						iIndexArray +=1
						
						Exit Do
						
					Endif
					
				Else
					
					Exit Do
					
				Endif
				
			Else
				
				Exit Do
				
			Endif	
			
		Else
			
			Exit Do
			
		Endif
		
	Loop
	
	Deallocate(pTempBuf)
	
	Return iIndexArray
	
End Function

Redim Shared As Wstring*100 cnv_wArrayWords(500)

Function cnv_find_word_from_position_unibuffer(pwBuf As Wstring Ptr , iPositionFind As Long , Byref iStart As Long, Byref iEnd As Long) As Integer
	
	Static As Long iFlagFill
	
	If iFlagFill = 0 Then
		
		Dim As Wstring Ptr pws = Callocate((Len(*(TGlobalVariables->pszKeywords0)) + _
		Len(*(TGlobalVariables->pszKeywords1)) + _
		Len(*(TGlobalVariables->pszKeywords2)) + _
		Len(*(TGlobalVariables->pszKeywords3)) + 10) * Sizeof(Wstring))
		
		If pws Then
			
			*pws = Trim(*(TGlobalVariables->pszKeywords0) , Any !"\n \r") & " " & _
			Trim(*(TGlobalVariables->pszKeywords1) , Any !"\n \r") & " " & _
			Trim(*(TGlobalVariables->pszKeywords2) , Any !"\n \r") & " " & _
			Trim(*(TGlobalVariables->pszKeywords3) , Any !"\n \r") & " " 
			
			If Len(*pws) Then
				
				Dim As Long iStartFind = 1 , iEndFind , iIndexArray
				
				Do
					
					iEndFind = Instr(iStartFind , *pws , " ")
					
					If iEndFind Then
						
						If iIndexArray > Ubound(cnv_wArrayWords) Then
							
							Redim Preserve As Wstring*100 cnv_wArrayWords(Ubound(cnv_wArrayWords) + 100)
							
						Endif
						
						cnv_wArrayWords(iIndexArray) = Mid(*pws ,iStartFind , iEndFind - iStartFind)
						
						iStartFind = iEndFind + 1
						
						iIndexArray +=1
						
					Else
						
						Exit Do
						
					Endif
					
				Loop
				
			Endif
			
			Deallocate(pws)			
			
		Endif
		
		iFlagFill = 1
		
	Endif
	
	Dim As Long iLenBuf = Len(*pwBuf) , iStartFind = -1 , iEndFind , iFlagMultiComment
	
	Static As Wstring*200 wsWord
	
	wsWord = ""
	
	For i As Long = iPositionFind To iLenBuf
		
		Dim As Long iChar = (*pwBuf)[i]
		
		If (iChar > 47 Andalso iChar < 58) Orelse (iChar > 64 Andalso iChar < 91) _
		Orelse (iChar > 96 Andalso iChar < 123) Orelse iChar = 95 Orelse iChar = 35 _
		Orelse iChar = 36 Then
			
			Dim As Wstring*2 wChar = pwBuf[i]
			
			wsWord &= wChar
			
		Elseif (iChar > 8 Andalso iChar < 34) Orelse (iChar > 36 Andalso iChar < 48) _
			Orelse (iChar > 57 Andalso iChar < 65) Orelse (iChar > 90 Andalso iChar < 95) Then
			
			If Len(wsWord) Then
				
				wsWord = Lcase(wsWord)
				
				For j As Long = 0 To Ubound(cnv_wArrayWords)
					
					If cnv_wArrayWords(j) = wsWord Then
						
						iStart = iStartFind+1
						
						iEnd = i - 1
						
						Return 1							
						
					Endif
					
				Next
				
				wsWord = ""
				
				iStartFind = i
				
			Else
				
				If iChar = 47 Andalso (i < iLenBuf) Then
					
					Dim As Wstring*2 wTempChar = pwBuf[i+1]
					
					If wTempChar = "'" Then
						
						Dim As Long iFindEndMC = Instr(i+1 , *pwBuf , "'/")
						
						If iFindEndMC Then
							
							i = iFindEndMC 
							
						Else
							
							Exit For
							
						Endif
						
					Endif
					
				Elseif iChar = 39 Then
					
					If i < iLenBuf Then
						
						Dim As Long iFindEndMC = Instr(i+1 , *pwBuf , Wchr(10))
						
						If iFindEndMC Then
							
							If iFindEndMC < iLenBuf Then
								
								i = iFindEndMC - 1
								
							Else
								
								Exit For
								
							Endif
							
						Else
							
							Exit For
							
						Endif							
						
					Endif
					
				Endif
				
				iStartFind = i
				
			Endif
			
		Elseif iChar = 34 Then
			
			If Len(wsWord) Then
				
				wsWord = Lcase(wsWord)
				
				For j As Long = 0 To Ubound(cnv_wArrayWords)
					
					If cnv_wArrayWords(j) = wsWord Then
						
						iStart = iStartFind+1
						
						iEnd = i - 1
						
						Return 1							
						
					Endif
					
				Next
				
				wsWord = ""
				
				iStartFind = i
				
			Endif
			
			If i < iLenBuf Then
				
				Dim As Long iFindEndQ = Instr(i+2 , *pwBuf , """")
				
				Dim As Long iFindEnd10 = Instr(i+1 , *pwBuf , Wchr(10))
				
				If (iFindEndQ Andalso iFindEnd10 Andalso (iFindEndQ < iFindEnd10)) _
				Orelse (iFindEnd10 = 0 Andalso iFindEndQ) Then
					
					If iFindEndQ < iLenBuf Then
						
						i = iFindEndQ - 1
						
						iStartFind = i
						
					Else
						
						Exit For
						
					Endif
					
				Else
					
					If iFindEnd10 Then
						
						If iFindEnd10 < iLenBuf Then
							
							i = iFindEnd10 - 1
							
							iStartFind = i
							
						Else 
							
							Exit For	
							
						Endif
						
					Else
						
						Exit For
						
					Endif
					
				Endif							
				
			Endif			
			
		Else
			
			If i < iLenBuf Then
				
				wsWord = ""
				
			Else
				
				If Len(wsWord) Then
					
					wsWord = Lcase(wsWord)
					
					For j As Long = 0 To Ubound(cnv_wArrayWords)
						
						If cnv_wArrayWords(j) = wsWord Then
							
							iStart = iStartFind+1
							
							iEnd = i - 1
							
							Return 1							
							
						Endif
						
					Next
					
				Endif
				
			Endif						
			
		Endif
		
	Next
	
End Function

Sub cnv_convert_word_asmwords(pwsToCode As Wstring Ptr  , iBeginWordPosition As Long , iEndWordPosition As Long , iCodeCase As Long)
	
	For i As Long = iBeginWordPosition To iEndWordPosition
		
		If iCodeCase = 1 Then
			
			Mid(pwsToCode[i] , 1 ,1) = Ucase(Mid(pwsToCode[i] , 1 ,1))
			
		Elseif iCodeCase = 2 Then
			
			Mid(pwsToCode[i] , 1 ,1) = Lcase(Mid(pwsToCode[i] , 1 ,1))
			
		Elseif iCodeCase = 3 Then	
			
			If i = iBeginWordPosition Then
				
				Mid(pwsToCode[i] , 1 ,1) = Ucase(Mid(pwsToCode[i] , 1 ,1))
				
			Else
				
				Mid(pwsToCode[i] , 1 ,1) = Lcase(Mid(pwsToCode[i] , 1 ,1))
				
			Endif
			
		Endif
		
	Next
	
End Sub

Function cnv_convert_case_before_save_file(pszBuf As Zstring Ptr , Byref iFlagDeallocate As Long) As Zstring Ptr
	
	If Len(*pszBuf) = 0 Then Return pszBuf
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Integer iSizeRetIconv
	
	Dim As Wstring Ptr pwsToCode
	
	Dim As Zstring Ptr pszReturn
	
	Dim As Long iSize = Len(*pszBuf) , iCodeCase 
	
	Select Case *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "case")
			
		Case "up"
			
			iCodeCase = 1
			
		Case "down"
			
			iCodeCase = 2
			
		Case "camel"   
			
			iCodeCase = 3
			
		Case Else   
			
			Return pszBuf
			
	End Select
	
	#ifdef __fb_win32__
		pwsToCode = Cast(Wstring Ptr , enc_encode_buffer_proc("UTF-16LE" , "UTF-8" , pszBuf , iSize ,iSizeRetIconv))
	#else	
		pwsToCode = Cast(Wstring Ptr , enc_encode_buffer_proc("UTF-32LE" , "UTF-8" , pszBuf , iSize ,iSizeRetIconv))
	#endif
	
	If pwsToCode = 0 Then Return pszBuf
	
	Dim As Long iUboundAsmBlocks = cnv_find_asmblock(pwsToCode)
	
	Dim As Long iPosBeginFindInCode , iBeginWordPosition = 0 , iEndWordPosition = 0
	
	While cnv_find_word_from_position_unibuffer(pwsToCode , iPosBeginFindInCode , iBeginWordPosition  , iEndWordPosition)
		
		If iEndWordPosition < Len(*pwsToCode) Then
			
			For q As Long = 0 To iUboundAsmBlocks - 1
				
				If cnv_iBlocks(q).iStartBlock = iBeginWordPosition Then
					
					cnv_convert_word_asmwords(pwsToCode , iBeginWordPosition , iBeginWordPosition+2 , iCodeCase)
					
					If cnv_iBlocks(q).iStartTwoWord Then
						
						cnv_convert_word_asmwords(pwsToCode , cnv_iBlocks(q).iStartTwoWord - 1 , cnv_iBlocks(q).iStartTwoWord + 1 , iCodeCase)
						
						cnv_convert_word_asmwords(pwsToCode , cnv_iBlocks(q).iEndTwoWord - 2 , cnv_iBlocks(q).iEndTwoWord , iCodeCase)
						
					Endif
					
					iPosBeginFindInCode = cnv_iBlocks(q).iEndBlock
					
					If iPosBeginFindInCode < Len(*pwsToCode) Then
						
						Continue While
						
					Else
						
						Exit While
						
					Endif
					
				Endif
				
			Next
			
			iPosBeginFindInCode = iEndWordPosition + 1
			
			cnv_convert_word_asmwords(pwsToCode , iBeginWordPosition , iEndWordPosition , iCodeCase)
			
			iBeginWordPosition = 0
			
			iEndWordPosition = 0
			
		Else 
			
			Exit While
			
		Endif
		
	Wend
	
	#ifdef __fb_win32__
		pszReturn = Cast(Zstring Ptr , enc_encode_buffer_proc("UTF-8", "UTF-16LE" , Cast(Byte Ptr, pwsToCode ) , Len(*pwsToCode)*Sizeof(Wstring) , iSizeRetIconv))	
	#else	
		pszReturn = Cast(Zstring Ptr , enc_encode_buffer_proc("UTF-8", "UTF-32LE" , Cast(Byte Ptr, pwsToCode ) , Len(*pwsToCode)*Sizeof(Wstring) , iSizeRetIconv))	
	#endif
	
	If pszReturn Then
		
		iFlagDeallocate = 1
		
		Function = pszReturn
		
	Else
		
		Function = pszBuf
		
	Endif
	
	Deallocate (pwsToCode)
	
End Function
