' Retrieve the path for a single file
Function fdlg_dlg_open_proc (pszTitle As Zstring Ptr , pszFilter As Zstring Ptr , hParent As iHandle Ptr) As String Export
	
	Dim As Ihandle Ptr dlg = IupFileDlg()
	
	IupSetAttributeHandle(dlg, "PARENTDIALOG", hParent)
	
	IupSetAttribute(dlg, "DIALOGTYPE", "OPEN")
	
	IupSetAttribute(dlg, "TITLE", pszTitle)
	
	IupSetAttribute(dlg, "EXTFILTER" , pszFilter)

	IupPopup(dlg, IUP_CURRENT, IUP_CURRENT)	
	
	If (IupGetInt(dlg, "STATUS")) <> Cint(-1) Then
		
		Function = *IupGetAttribute(dlg, "VALUE")
		
	Endif
	
	IupDestroy(dlg)
	
End Function

' Retrieve the path for a dir
Function fdlg_dlg_opendir_proc (hParent As iHandle Ptr) As String Export
	
	Dim As Ihandle Ptr dlg = IupFileDlg()
	
	IupSetAttributeHandle(dlg, "PARENTDIALOG", hParent )
	
	IupSetAttribute(dlg, "DIALOGTYPE", "DIR")

	IupPopup(dlg, IUP_CURRENT, IUP_CURRENT)	
	
	If (IupGetInt(dlg, "STATUS")) <> Cint(-1) Then
		
		Function = *IupGetAttribute(dlg, "VALUE")
		
	Endif
	
	IupDestroy(dlg)
	
End Function

' get paths for single and multiple file selection
Function fdlg_open_dialog_files_proc() As Zstring Ptr Export

	Static As Zstring*10000 szPath

	For i As Long  = 0 To 9999

		szPath[i] = 0

	Next

	Dim As Ihandle Ptr dlg = IupFileDlg()
	
	IupSetAttributeHandle(dlg, "PARENTDIALOG", TGlobalVariables->dlg )

	IupSetAttribute(dlg, "DIALOGTYPE", "OPEN")

	IupSetAttribute(dlg, "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgopenfile"))
	
	#ifdef __fb_win32__
		IupSetAttribute(dlg, "EXTFILTER" , "Freebasic files (bas)|*.bas|FreeBasic headers files (bi)|*.bi|All files|*.*|")
	#else	
		IupSetAttribute(dlg, "EXTFILTER" , "Freebasic files (bas)|*.bas|FreeBasic headers files (bi)|*.bi|All files|**|")
	#endif
	
	IupSetAttribute(dlg, "MULTIPLEFILES", "YES")

	IupPopup(dlg, IUP_CURRENT, IUP_CURRENT)

	If IupGetInt(dlg, "STATUS") = 0 Then
		
		szPath = *IupGetAttribute(dlg, "VALUE")

		Function = @szPath

	EndIf

	IupDestroy(dlg)

End Function

' getting the path to save the file
Function fdlg_save_dialog_proc() As Zstring Ptr Export

	Static As Zstring*1000 szPath

	For i As Long  = 0 To 999

		szPath[i] = 0

	Next

	Dim As Ihandle Ptr dlg = IupFileDlg()
	
	IupSetAttributeHandle(dlg, "PARENTDIALOG", TGlobalVariables->dlg )

	IupSetAttribute(dlg, "DIALOGTYPE", "SAVE")

	IupSetAttribute(dlg, "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgsaveas"))

	#ifdef __fb_win32__
		IupSetAttribute(dlg, "EXTFILTER" , "Freebasic files (bas)|*.bas|FreeBasic headers files (bi)|*.bi|All files|*.*|")
	#else
		IupSetAttribute(dlg, "EXTFILTER" , "Freebasic files (bas)|*.bas|FreeBasic headers files (bi)|*.bi|All files|**|")
	#endif
	
	IupPopup(dlg, IUP_CURRENT, IUP_CURRENT)

	If IupGetInt(dlg, "STATUS") <> -1 Then

		szPath = *IupGetAttribute(dlg, "VALUE")
		
		If Lcase(Right(szPath,3)) = "bas" Orelse Lcase(Right(szPath,2)) = "bi" Then						
			
		Else
			
			If IupGetInt(dlg, "FILTERUSED") = 1 Then
				
				szPath &= ".bas"
				
			Elseif IupGetInt(dlg, "FILTERUSED") = 2 Then
				
				szPath &= ".bi"
				
			Endif		 
			
		Endif	
		
		Function = @szPath

	EndIf

	IupDestroy(dlg)

End Function
