
Function msdlg_dialog_message_yes_no_proc(pszTitle As Zstring Ptr , pszMessage As Zstring Ptr , iCountButtons As Long = 3 , hParent as iHandle ptr = 0) As Integer Export
	
	#ifdef __fb_win32__
		
		Dim As Integer iRet
		
		dim as HWND pParentDlg
		
		if hParent = 0 then
			
			pParentDlg = Cast(HWND,IupGetAttribute(TGlobalVariables->dlg , "HWND"))
			
		else
		
			pParentDlg = Cast(HWND,IupGetAttribute(hParent , "HWND"))
			
		EndIf
		
		Dim As Wstring Ptr pwsMess , pwsTitle

		pwsMess = enc_encode_msgbox_warning_proc(pszMessage)
		
		pwsTitle = enc_encode_msgbox_warning_proc(pszTitle)
		
		Select Case iCountButtons
			
			Case 1
			
				iRet = MessageBoxW(pParentDlg, pwsMess , pwsTitle , 0)

			Case 2
				
				iRet = MessageBoxW(pParentDlg, pwsMess , pwsTitle, 4)
			
			Case 3
				
				iRet = MessageBoxW(pParentDlg, pwsMess , pwsTitle , 3)
				
		End Select
		
		If pwsMess Then Deallocate(pwsMess)
		
		If pwsTitle Then Deallocate(pwsTitle)
		
		Select Case iRet
			
			Case 6
			
				Return 1
			
			Case 7
			
				Return 2
			
			Case Else 
			
				Return 3
			 
		End Select
		
	#else
	
		Dim As Ihandle Ptr dlg = IupMessageDlg()
		
		if hParent = 0 then
			
			IupSetAttributeHandle(dlg, "PARENTDIALOG", TGlobalVariables->dlg )
			
		else
			
			IupSetAttributeHandle(dlg, "PARENTDIALOG", hParent )
			
		EndIf
		
		IupSetAttribute(dlg, "DIALOGTYPE", "QUESTION")
		
		IupSetAttribute(dlg, "TITLE", pszTitle)
		
		IupSetAttribute(dlg, "VALUE", pszMessage)

		select case iCountButtons
			
			Case 1
			
				IupSetAttribute(dlg, "BUTTONS", "OK")
				
				IupSetAttribute(dlg, "DIALOGTYPE", "MESSAGE")
				
			case 2
				
				IupSetAttribute(dlg, "BUTTONS", "YESNO")
				
			case 3
				
				IupSetAttribute(dlg, "BUTTONS", "YESNOCANCEL")
			
		End Select
		
		IupPopup(dlg, IUP_CURRENT, IUP_CURRENT)
		
		Dim As Integer iRet =  Val(*IupGetAttribute(dlg, "BUTTONRESPONSE"))
		
		IupDestroy(dlg)
	
	#endif
	
	Return iRet
	
End Function