#Include "../tlist.bi"
#include "../declarations.bi"

dim shared as T_GlobalVariables Ptr TGlobalVariablesDll

sub load_image_reload_bmp() export

  Dim As Ubyte imgdata(...) = {_
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,_
    1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1,_
    1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1,_
    1, 1, 2, 2, 2, 1, 1, 1, 1, 1, 1, 2, 2, 2, 1, 1,_
    1, 1, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 1, 1,_
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 1, 1,_
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2,_
    1, 1, 2, 2, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 1,_
    1, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 2, 2, 1, 1,_
    2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,_
    1, 1, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,_
    1, 1, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 1, 1,_
    1, 1, 2, 2, 2, 1, 1, 1, 1, 1, 1, 2, 2, 2, 1, 1,_
    1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1,_
    1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1,_
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1}

  Dim As Ihandle Ptr image = IupImage(16, 16, @imgdata(0))

  IupSetAttribute(image, "1", "BGCOLOR")
  IupSetAttribute(image, "2", "34 193 222")
  
  IupSetHandle ( "image_reload", image )
  
end sub



#Ifdef __FB_WIN32__
	
	Dim pDll As  Any Ptr

	#undef fl_re_open_file_proc

	Dim Shared  fl_re_open_file_proc as sub (As Zstring Ptr)

	pDll = DylibLoad("../fbnp.exe")

	If pDll <> 0 Then
		fl_re_open_file_proc = DylibSymbol(pDll, "FL_RE_OPEN_FILE_PROC")

	EndIf
	
#else

	declare Sub fl_re_open_file_proc (pszEnc As Zstring Ptr)
	
#EndIf

function reload_file cdecl(ih As Ihandle Ptr) as integer
	
	If IupGetChildCount(TGlobalVariablesdll->tabs) < 2 then Return IUP_DEFAULT
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariablesdll->tabs, "VALUEPOS"))
	
	dim as zstring ptr pszEnc = IupGetAttribute(TGlobalVariablesdll->tTabsOptions(idTabs).multitext, "CURRENTENCODING")
	
	fl_re_open_file_proc(pszEnc)
	
	Return IUP_DEFAULT
	
End Function

function InitPluginProc(TGlobalVariables as T_GlobalVariables Ptr , pszDimErrors() as zstring ptr , bEncodingBool() as byte , szEncodingString as any ptr) as Integer export
	
	if TGlobalVariables = 0 then return 0
	
	TGlobalVariablesDll = TGlobalVariables
	
	Dim As iHandle Ptr hToolbar = TGlobalVariablesDLL->toolBar
	
	If 	hToolbar = 0 Then Return 0
	
	load_image_reload_bmp()

	Dim As IHandle Ptr btn = IupButton(NULL, NULL)
	
	IupSetAttribute(btn, "IMAGE", "image_reload")
	
	IupSetAttribute(btn, "FLAT", "YES")
	
	IupSetCallback(btn, "ACTION", Cast(Any Ptr , @reload_file))

	Static As String sTips
	
	sTips = *IupConfigGetVariableStr(TGlobalVariablesDll->hConfigplug,TGlobalVariablesDLL->szLangid,"plug_reload")
	
	IupSetAttribute(btn, "TIP", Strptr(sTips))
	
	IupSetAttribute(btn, "CANFOCUS", "No")

	IupAppend(hToolbar , btn)

	IupMap(btn)

	IupRefreshChildren(hToolbar)

	return 1	
	
End Function