Sub winside_set_visual_params_info_proc(iParam As Byte = 0) Export
	
	optdlg_get_theme_color_proc(iParam)
	
	Dim As ihandle Ptr list = IupGetDialogChild(TGlobalVariables->dlg,"listboxsidewin")
	
	IupSetAttribute(list, "BGCOLOR" , TGlobalVariables->szColorbtn(38))
	
	IupSetAttribute(list, "FGCOLOR" , TGlobalVariables->szColorbtn(40))
	
	Dim As Zstring*100 szFont
	
	If iParam = 0 Then
		
		szFont = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","winside")
		
	Else
		
		szFont = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions,"ftxtwinside"),"VALUE")
		
	Endif
	
	If Instr(szFont, " Bold ") Then 
		
		szFont = misc_replace_string_proc(szFont , " Bold " , " " )	   
		
	Endif
	
	If Instr(szFont, " Italic ") Then 
		
		szFont = misc_replace_string_proc(szFont , " Italic " , " " )	   
		
	Endif
	
	If Instr(szFont, " Underline ") Then 
		
		szFont = misc_replace_string_proc(szFont , " Underline " , " " )	   
		
	Endif
	
	If Instr(szFont, " Strikeout ") Then 
		
		szFont = misc_replace_string_proc(szFont , " Strikeout " , " " )	   
		
	Endif	
	
	Dim As Integer iPosSpace = Instrrev(szFont , " ")
	
	TGlobalVariables->szFontWinSideSize = Mid(szFont , iPosSpace , (Len(szFont) - iPosSpace)+1)
	
	TGlobalVariables->szFontWinSide = Rtrim(Mid(szFont , 1 , iPosSpace) , Any " ,")
	
	If Len(TGlobalVariables->szFontWinSideSize) Then
		
		IupSetAttribute(list, "FONTSIZE" , TGlobalVariables->szFontWinSideSize)
		
	Endif
	
	If Len(TGlobalVariables->szFontWinSide) Then
		
		IupSetAttribute(list, "FONTFACE" , TGlobalVariables->szFontWinSide)
		
	Endif
	
End Sub


Sub winside_qsort_list_proc(iStart As Ulong, iFinish As Ulong)
	
	Dim As Ulong I = iStart , J = iFinish  , iT , iExt
	
	Dim As String szX = Lcase(tDimInfoSideList(Int((I+J)/2)).szText) , szA
	
	While  I <= J
		
		While Lcase(tDimInfoSideList(I).szText) < szX
			
			I+=1
			
		Wend
		
		While Lcase(tDimInfoSideList(J).szText) > szX
			
			J-=1
			
		Wend
		
		If I <= J Then
			
			If Lcase(tDimInfoSideList(I).szText) <> Lcase(tDimInfoSideList(J).szText) Then
				
				szA = tDimInfoSideList(I).szText
				
				iT = tDimInfoSideList(I).iLine
				
				iExt = tDimInfoSideList(I).iExtLine
				
				tDimInfoSideList(I).szText = tDimInfoSideList(J).szText
				
				tDimInfoSideList(I).iLine = tDimInfoSideList(J).iLine
				
				tDimInfoSideList(I).iExtLine = tDimInfoSideList(J).iExtLine
				
				tDimInfoSideList(J).szText = szA
				
				tDimInfoSideList(J).iLine = iT
				
				tDimInfoSideList(J).iExtLine = iExt			
				
			Endif
			
			I+=1
			
			If J>0 Then J-=1
			
		Endif
		
	Wend
	
	If J > iStart Then winside_qsort_list_proc(iStart , J)
	
	If I < iFinish Then winside_qsort_list_proc(I , iFinish)
	
End Sub

Sub winside_qsort_prjfiles_proc(iStart As Ulong, iFinish As Ulong , sArray() As String)
	
	Dim As Ulong I = iStart , J = iFinish
	
	Dim As String szX = misc_case_utf8(sArray(Int((I+J)/2))) , szA
	
	While  I <= J
		
		While misc_case_utf8(sArray(I)) < szX
			
			I+=1
			
		Wend
		
		While misc_case_utf8(sArray(J)) > szX
			
			J-=1
			
		Wend
		
		If I <= J Then
			
			If misc_case_utf8(sArray(I)) <> misc_case_utf8(sArray(J)) Then
				
				szA = sArray(I)
				
				sArray(I) = sArray(J)
				
				sArray(J) = szA	
				
			Endif
			
			I+=1
			
			If J>0 Then J-=1
			
		Endif
		
	Wend
	
	If J > iStart Then winside_qsort_prjfiles_proc(iStart , J , sArray())
	
	If I < iFinish Then winside_qsort_prjfiles_proc(I , iFinish , sArray())
	
End Sub

Sub winside_addInfo_inlist_proc()
	
	Dim As String sRet
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then 
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"listboxsidewin"), "1" , 0)
		
		Exit Sub
		
	Endif
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	If TGlobalVariables->tTabsOptions(idTabs).multitext = 0 Then Exit Sub
	
	Dim As iHandle Ptr btn = IupGetDialogChild(TGlobalVariables->dlg,"btnsortsidewin")
	
	Dim As Integer iLineCount = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINECOUNT") , iRet
	
	Dim As Long iComboItem = Val(*IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"combosidewin") , "VALUE"))
	
	Dim As Ihandle Ptr list = IupGetDialogChild(TGlobalVariables->dlg,"listboxsidewin")
	
	Dim As Long iCurent = Val(*IupGetAttribute(list, "VALUE"))
	
	Dim As TMultiCommentsLinePositions Ptr ListMKLP = cmt_multi_comments_line_positions_proc(TGlobalVariables->tTabsOptions(idTabs).multitext)
	
	Redim As T_DimInfoSideList tDimInfoSideList(10)
	
	Dim As Long iIndex , iFindB , iFindE , iASMblock
	
	For i As Long = 0 To iLineCount-1
		
		If ListMKLP Then
			
			If ListMKLP->IsIn(i) Then
				
				Continue For
				
			Endif
			
		Endif
		
		If iASMblock = 0 Then
			
			iRet = atc_get_autocomplect_proc( i ,sRet)
			
		Else
			
			Dim As String sRet = Ltrim(Lcase(*IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext , "LINE" & i)) , Any Chr(9) & " ")
			
			If (Len(sRet) > 5) Andalso Left(sRet , 4) = "end " Then
				
				If Instr(sRet , " asm") Then
					
					iASMBlock = 0
					
				Endif
				
			Endif
			
			Continue For
			
		Endif
		
		Dim As String sFind
		
		Select Case iRet
				
			Case 1
				
				If iComboItem <> 1 Andalso iComboItem <> 2 Then Continue For
				
				sFind = "function"
				
			Case 2
				
				If iComboItem <> 1 Andalso iComboItem <> 3 Then Continue For
				
				sFind = "sub"
				
			Case 3
				
				If iComboItem <> 4 Then Continue For
				
				sFind = "type"
				
			Case 5
				
				If iComboItem <> 5 Then Continue For
				
				sFind = "union"
				
			Case 6
				
				If iComboItem <> 6 Then Continue For
				
				sFind = "enum"				
				
			Case 10
				
				If iComboItem <> 7 Then Continue For
				
				sFind = "constructor"
				
			Case 11
				
				If iComboItem <> 8 Then Continue For
				
				sFind = "destructor"
				
			Case 12
				
				If iComboItem <> 10 Then Continue For
				
				sFind = "operator"	
				
			Case 13
				
				If iComboItem <> 9 Then Continue For
				
				sFind = "property"
				
			Case 20
				
				iASMblock = 1
				
				Continue For
				
			Case Else
				
				Continue For					
				
		End Select
		
		Dim As String sTextL
		
		tDimInfoSideList(iIndex).iExtLine = atc_get_string_from_multiline_text_proc(TGlobalVariables->tTabsOptions(idTabs).multitext , i , sTextL , 0) 
		
		Dim As String sTextLine = Lcase(sTextL)				
		
		iFindB = Instr(sTextLine , sFind) + Len(sFind) 
		
		sTextLine = Trim(Mid(sTextL , iFindB) , Any Chr(9) & " " & Chr(10) & Chr(13))
		
		If Len(sTextLine) Then
			
			iFindB = Instr(sTextLine , " ")
			
			iFindE = Instr(sTextLine , "(")
			
			If iFindB + iFindE = 0 Then
				
				tDimInfoSideList(iIndex).szText = Trim(Mid(sTextLine , 1), Any Chr(9) & " ")
				
			Elseif iFindB = 0 Then
				
				tDimInfoSideList(iIndex).szText = Trim(Left(sTextLine , iFindE-1), Any Chr(9) & " ")
				
			Elseif iFindE = 0 Orelse iFindB < iFindE Then
				
				tDimInfoSideList(iIndex).szText = Trim(Left(sTextLine , iFindB-1), Any Chr(9) & " ")
				
			Elseif iFindB > iFindE Then	
				
				tDimInfoSideList(iIndex).szText = Trim(Left(sTextLine , iFindE-1), Any Chr(9) & " ")
				
			Elseif iFindB < iFindE Then	
				
				tDimInfoSideList(iIndex).szText = Trim(Left(sTextLine , iFindB-1), Any Chr(9) & " ")
				
			Endif
			
			tDimInfoSideList(iIndex).iLine = i 
			
			iIndex +=1
			
			If iIndex > Ubound(tDimInfoSideList) Then
				
				Redim Preserve As T_DimInfoSideList tDimInfoSideList(Ubound(tDimInfoSideList)+10)
				
			Endif			
			
		Endif
		
	Next
	
	If iIndex Then
		
		Dim As String sTempString
		
		If iCurent Andalso *IupGetAttribute(btn,"iChanges") = "1" Then sTempString = *IupGetAttribute(list , Str(iCurent))
		
		If iIndex > 1 Andalso *IupGetAttribute(btn , "VALUE") = "ON" Then 
			
			winside_qsort_list_proc(0 , iIndex-1)
			
		Endif
		
		For i As Long = 0 To iIndex-1
			
			If tDimInfoSideList(i).szText = *IupGetAttribute(list , Str(i+1)) Then
				
				Continue For
				
			Endif
			
			IupSetAttribute(list , Str(i+1) , Strptr(tDimInfoSideList(i).szText))
			
			If *IupGetAttribute(btn,"iChanges") = "1" Andalso sTempString = tDimInfoSideList(i).szText  Then
				
				iCurent = i+1
				
				IupSetAttribute(btn,"iChanges", "0")
				
			Endif
			
		Next		
		
	Endif
	
	IupSetAttribute(list , Str(iIndex+1) , "")
	
	IupSetAttribute(list , Str(iIndex+2) , 0)
	
	If iCurent Then 
		
		IupSetAttribute(list, "VALUE" , Str(iCurent))
		
	Endif
	
	If ListMKLP Then
		
		ListMKLP->delAll()
		
		Delete ListMKLP
		
	Endif
	
End Sub

Sub winside_addInfo_prj_inlist_proc()
	
	Dim As Ihandle Ptr list = IupGetDialogChild(TGlobalVariables->dlg,"listboxsidewin")
	
	If pProject.iProjectLoad = 0 Then
		
		winside_add_info_recent_prj_proc(list)
		
		Exit Sub
		
	Endif
	
	Dim As Long iIndexBas , iIndexBi ,  iIndexRc , iIndexList = 1
	
	Static As String arrayBas(1000)
	
	Static As String arrayBi(1000)
	
	Static As String arrayRc(100)
	
	IupSetAttribute(list, "1" , 0)
	
	For i As Long = 0 To 1000
		
		arrayBas(i) = ""
		
		arrayBi(i) = ""
		
		If i < 101 Then
			
			arrayRc(i) = ""
			
		Endif
		
	Next
	
	For i As Long = 0 To 1000
		
		If pProject.tBasFiles(i).pszFile Then
			
			If i = pProject.iCurentMainFile Then
				
				If pProject.tBasFiles(i).mt Then
					
					arrayBas(i) = "(" & *(pProject.tBasFiles(i).pszFile) & ") M+"
					
				Else
					
					arrayBas(i) = "(" & *(pProject.tBasFiles(i).pszFile) & ") M-"
					
				Endif
				
			Elseif pProject.tBasFiles(i).mt Then
				
				arrayBas(i) = *(pProject.tBasFiles(i).pszFile) & " M+"
				
			Else
				
				arrayBas(i) = *(pProject.tBasFiles(i).pszFile) & " M-"
				
			Endif
			
			#ifdef __fb_win32__
				
				arrayBas(i) = enc_encode_path_proc(arrayBas(i), 1)
				
			#endif
			
			iIndexBas+=1
			
		Endif
		
		If pProject.tBiFiles(i).pszFile Then
			
			If pProject.tBiFiles(i).mt Then
				
				arrayBi(i) = *(pProject.tBiFiles(i).pszFile) & " +"
				
			Else
				
				arrayBi(i) = *(pProject.tBiFiles(i).pszFile) & " -"
				
			Endif
			
			iIndexBi+=1
			
			#ifdef __fb_win32__
				
				arrayBi(i) = enc_encode_path_proc(arrayBi(i), 1)
				
			#endif
			
		Endif
		
		If i < 101 Andalso pProject.tRcFiles(i).pszFile	Then
			
			If pProject.tRcFiles(i).mt Then
				
				arrayRc(i) = *(pProject.tRcFiles(i).pszFile) & " +"
				
			Else
				
				arrayRc(i) = *(pProject.tRcFiles(i).pszFile) & " -"
				
			Endif
			
			#ifdef __fb_win32__
				
				arrayRc(i) = enc_encode_path_proc(arrayRc(i), 1)
				
			#endif
			
			iIndexRc+=1			
			
		Endif
		
	Next
	
	If iIndexBas Then
		
		If iIndexBas > 1 Then
			
			winside_qsort_prjfiles_proc(0 , iIndexBas-1 , arrayBas())
			
		Endif
		
		For i As Long = 0 To iIndexBas-1
			
			IupSetAttribute(list, Str(iIndexList) , arrayBas(i))
			
			iIndexList+=1
			
		Next
		
	Endif
	
	If iIndexBi Then
		
		If iIndexBi > 1 Then
			
			winside_qsort_prjfiles_proc(0 , iIndexBi-1 , arrayBi())
			
		Endif
		
		For i As Long = 0 To iIndexBi-1
			
			IupSetAttribute(list, Str(iIndexList) , arrayBi(i))
			
			iIndexList+=1
			
		Next
		
	Endif	
	
	If iIndexRc Then
		
		If iIndexRc > 1 Then
			
			winside_qsort_prjfiles_proc(0 , iIndexRc-1 , arrayRc())
			
		Endif
		
		For i As Long = 0 To iIndexRc-1
			
			IupSetAttribute(list, Str(iIndexList) , arrayRc(i))
			
			iIndexList+=1
			
		Next
		
	Endif
	
	IupSetAttribute(list, Str(iIndexList) , "")
	
End Sub

Sub winside_add_info_recent_prj_proc(list As ihandle Ptr)
	
	IupSetAttribute(list, "1" , 0)
	
	IupSetAttribute(list, "1" , *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"prjnotload"))
	
	If tRecentProjectInfo Andalso tRecentProjectInfo->iIndex Then
		
		IupSetAttribute(list, "2" , " ")
		
		IupSetAttribute(list, "3" , *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"prjrecent"))
		
		Dim As TQueueList Ptr pTemp = tRecentProjectInfo->pF
		
		For i As Long = 1 To tRecentProjectInfo->iIndex
			
			If pTemp Andalso pTemp->psPath Then
				
				Dim As String sItemValue = tRecentProjectInfo->GetName(pTemp->psPath) & " (" & *(pTemp->psPath) & ")"
				
				IupSetStrAttribute(list, Str(i+3) , Strptr(sItemValue))
				
				pTemp = pTemp->p
				
			Endif
			
		Next
		
	Endif
	
End Sub

Sub winside_create_window_side_info_proc()
	
	Dim As Ihandle Ptr vBox , hBox , hBox0 , bgBox, combo , list , btn , btnprj
	
	Dim As Byte bToggle = Val(*IupConfigGetVariableStr(TGlobalVariables->hConfig,"ChildParam","btnsortwinside")) 
	
	btn = IupToggle(0,0)
	
	IupSetAttribute(btn, "IMAGE", "img_sort")
	
	IupSetAttribute(btn, "NAME" , "btnsortsidewin")
	
	IupSetAttribute(btn, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"winsidesort"))
	
	If bToggle Then
		
		IupSetAttribute(btn , "VALUE" , "ON")
		
	Endif
	
	IupSetCallback(btn, "VALUECHANGED_CB", Cast(Any Ptr,@btn_sort_winside_callback))
	
	Dim As Byte bTogglePrj = Val(*IupConfigGetVariableStr(TGlobalVariables->hConfig,"ChildParam","btnprjwinside")) 
	
	btnprj = IupToggle(0,0)
	
	IupSetAttribute(btnprj, "IMAGE", "img_prj")
	
	IupSetAttribute(btnprj, "NAME" , "btnprjsidewin")
	
	IupSetAttribute(btnprj, "TIP", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"winsideprj"))
	
	IupSetCallback(btnprj, "VALUECHANGED_CB", Cast(Any Ptr,@btn_prj_winside_callback))	
	
	combo = IupList(NULL)
	
	IupSetAttributes(combo, "DROPDOWN=YES")	
	
	IupSetAttributes(combo, "EXPAND=HORIZONTAL")	
	
	IupSetAttribute(combo, "NAME" , "combosidewin")
	
	IupSetAttribute(combo , "1" , "Functions and Subs")
	
	IupSetAttribute(combo , "2" , "Functions")	
	
	IupSetAttribute(combo , "3" , "Subs")
	
	IupSetAttribute(combo , "4" , "Types")
	
	IupSetAttribute(combo , "5" , "Unions")	
	
	IupSetAttribute(combo , "6" , "Enums")
	
	IupSetAttribute(combo , "7" , "Constructors")
	
	IupSetAttribute(combo , "8" , "Destructors")
	
	IupSetAttribute(combo , "9" , "Properties")
	
	IupSetAttribute(combo , "10" , "Operators")	 
	
	IupSetAttribute(combo , "VALUE" , "1")
	
	list = IupList(NULL)
	
	IupSetAttributes(list, "EXPAND=YES")
	
	IupSetCallback(list, "BUTTON_CB", Cast(Any Ptr,@listbox_winside_callback))
	
	IupSetCallback(list, "DBLCLICK_CB", Cast(Any Ptr,@listbox_winside_dblclick_callback))
	
	IupSetAttribute(list, "NAME" , "listboxsidewin")
	
	If bTogglePrj Then
		
		IupSetAttribute(btnprj , "VALUE" , "ON")
		
		IupSetAttribute(btn , "ACTIVE" , "NO")
		
		IupSetAttribute(combo , "ACTIVE" , "NO")
		
		'IupSetAttribute(list, "1" , *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"prjnotload"))
		
		winside_add_info_recent_prj_proc(list)
		
	Endif	
	
	Dim As String sTemp = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"DialogSize","splitrastersize")
	
	Dim As Long iRasterSize = Val(Mid(sTemp , Instr(sTemp , "x")+1))
	
	iRasterSize = (iRasterSize * Val(*IupConfigGetVariableStr(TGlobalVariables->hConfig,"DialogSize","splitsize")))\1000 - 23
	
	IupSetAttributes(list, "MAXSIZE=x" & iRasterSize) 
	
	hBox0 = IupHbox(btnprj , btn  , combo, 0)	
	
	vBox = IupVbox(hBox0 , list , 0)
	
	hBox = IupHbox(vBox , 0)
	
	bgBox = IupBackgroundBox(hBox)
	
	IupAppend(IupGetChild(TGlobalVariables->split , 1), bgBox)		
	
End Sub

Sub winside_setactiveitem_prj_proc(idTabs As Long)
	
	If pProject.iProjectLoad Andalso *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnprjsidewin") , "VALUE") = "ON" Then
		
		Dim iFlagProjectTab As Long
		
		For i As Long = 0 To 1000
			
			If TGlobalVariables->tTabsOptions(idTabs).multitext = pProject.tBasFiles(i).mt Orelse _
			TGlobalVariables->tTabsOptions(idTabs).multitext = pProject.tBiFiles(i).mt Orelse _
			(i < 101 Andalso TGlobalVariables->tTabsOptions(idTabs).multitext = pProject.tRcFiles(i).mt) Then
				
				iFlagProjectTab = 1
				
				Exit For
				
			Endif
			
		Next
		
		If iFlagProjectTab = 0 Then Exit Sub
		
		Dim As Ihandle Ptr list = IupGetDialogChild(TGlobalVariables->dlg,"listboxsidewin")
		
		Dim As String sTextTabs = *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILENAME")
		
		#ifdef __fb_win32__
			
			sTextTabs = enc_encode_path_proc(sTextTabs , 1)
			
		#endif
		
		Dim As Long iCount = Val(*IupGetAttribute(list , "COUNT"))
		
		If iCount Then
			
			For i As Long = 1 To iCount
				
				Dim As Long iModule
				
				Dim As String sListItem = prj_get_file_from_winside_or_tabs(iModule , i)
				
				If sListItem = sTextTabs Then
					
					IupSetAttribute(list , "VALUE" , Str(i))
					
					Exit For
					
				Endif
				
			Next
			
		Endif
		
	Endif
	
End Sub
