
Sub optdlg_set_checkbox_style_font_group_proc(ih As Ihandle Ptr , iState As Integer) Export
	
	Dim As Zstring*10 szBoldOption , szItalicOption
	
	Dim As String szTheme
	
	szTheme = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "VALUE")
	
	szBoldOption = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme"),"bold" & szTheme)
	
	If Len(szBoldOption) < 9 Then szBoldOption = "000000000"
	
	szItalicOption = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme"),"italic" & szTheme)	   
	
	If Len(szItalicOption) < 9 Then szItalicOption = "000000000"
	
	Select Case ih
			
		Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_str")
			
			szBoldOption[0] = Asc(Str(iState))
			
		Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_str") 
			
			szItalicOption[0] = Asc(Str(iState))
			
		Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_comm")
			
			szBoldOption[1] = Asc(Str(iState))
			
		Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_comm") 
			
			szItalicOption[1] = Asc(Str(iState))
			
		Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_numb")
			
			szBoldOption[2] = Asc(Str(iState))
			
		Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_numb") 
			
			szItalicOption[2] = Asc(Str(iState))
			
		Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_oper")
			
			szBoldOption[3] = Asc(Str(iState))
			
		Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_oper") 
			
			szItalicOption[3] = Asc(Str(iState))
			
		Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_iden")
			
			szBoldOption[4] = Asc(Str(iState))
			
		Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_iden") 
			
			szItalicOption[4] = Asc(Str(iState))
			
		Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw0")
			
			szBoldOption[5] = Asc(Str(iState))
			
		Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw0") 
			
			szItalicOption[5] = Asc(Str(iState))
			
		Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw1")
			
			szBoldOption[6] = Asc(Str(iState))
			
		Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw1")
			
			szItalicOption[6] = Asc(Str(iState))
			
		Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw2")
			
			szBoldOption[7] = Asc(Str(iState))
			
		Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw2") 
			
			szItalicOption[7] = Asc(Str(iState))
			
		Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw3")
			
			szBoldOption[8] = Asc(Str(iState))
			
		Case IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw3") 
			
			szItalicOption[8] = Asc(Str(iState))
			
	End Select
	
	IupSetStrAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "bold" & szTheme , szBoldOption)
	
	IupSetStrAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "italic" & szTheme , szItalicOption)   
	
End Sub

' Convert colors in string format (from: 255 255 255 , in: #FFFFFF)
Function optdlg_convert_color_in_hex_proc(sColor As String) As String Export
	
	Dim As Byte r,g,b
	
	Dim As Integer iPos , iPos1
	
	iPos = Instr(sColor , " ")
	
	r = Val(Mid(sColor, 1, iPos))
	
	iPos = Instr(iPos , sColor , " ")
	
	iPos1 = Instr(iPos+1 , sColor , " ")
	
	g = Val(Mid(sColor, iPos+1, iPos1-(iPos+1)))
	
	b = Val(Mid(sColor, iPos1+1))
	
	Return "#" & Hex(r,2) & Hex(g,2) & Hex(b,2)
	
End Function

' System Dialog "COLOR"
Function optdlg_get_color_dlg_proc(sPrevColor As String) As String Export
	
	Dim As Ihandle Ptr dlg = IupColorDlg()
	
	IupSetAttribute(dlg, "VALUE", sPrevColor)
	
	IupSetAttribute(dlg, "SHOWHEX", "YES")
	
	IupSetAttribute(dlg, "SHOWCOLORTABLE", "YES")
	
	IupPopup(dlg, IUP_CURRENT, IUP_CURRENT)
	
	If IupGetInt(dlg, "STATUS") = Cint(1) Then
		
		Function = optdlg_convert_color_in_hex_proc(*IupGetAttribute(dlg, "VALUE"))
		
	Endif
	
	IupDestroy(dlg)
	
End Function

' get theme ; get colors from theme 
Sub optdlg_get_theme_color_proc(iParam As Byte = 0) Export
	
	Dim As Zstring*2 szTheme 
	
	Dim As Zstring*260 szColTheme
	
	Dim As Zstring*80 szColAnother
	
	Dim As Zstring*4 szAlpha 	
	
	Dim As Zstring*10 szBoldOption
	
	Dim As Zstring*10 szItalicOption
	
	If iParam = 0 Then
		
		szTheme = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme","0")
		
		szColTheme = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme",szTheme & "c")	
		
		szColAnother = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme",szTheme & "f")
		
		szAlpha = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme",szTheme & "a")
		
		szBoldOption = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme",szTheme & "bold")
		
		szItalicOption = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme",szTheme & "italic")
		
		If Len(szColTheme) = 0 Then
			
			szTheme = "1"
			
			IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme","0" , szTheme)
			
			szColTheme = "#F0F0C0 #800000 #F0F0C0 #000000 #808080 #400080 #FFFFFF #008000 #808080 #808080 " & _
			"#000000 #FFFFFF #A5F0BE #000000 #FBFFB0 #FF0000 #F0F0C0 #C0C0C0 #F0F0C0 #FF0000 #F0F0C0 #000000 " & _
			"#F0F0C0 #067603 #F0F0C0 #408080 #F0F0C0 #FF8040 #F0F0C0 #000000 #F0F0C0 #0000FF"
			
			IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme",szTheme & "c" , szColTheme)	
			
			szColAnother = "#F0F0C0 #800000 #F0F0C0 #000000 #FEF4F4 #400080 #F0F0C0 #008000 #0000FF #FF0000" 
			
			IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme",szTheme & "f" , szColAnother)	
			
			szAlpha = "60"
			
			IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme",szTheme & "a" , szAlpha)
			
			szBoldOption = "000101111"
			
			IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme",szTheme & "bold" , szBoldOption)
			
			szItalicOption = "010000000"
			
			IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme",szTheme & "italic" , szItalicOption)
			
			IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme",szTheme & "n" , "STTheme")
			
		else
		
			if len(szColAnother) < 79 then
				
				szColAnother &= " #0000FF #FF0000"
				
				IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme",szTheme & "f" , szColAnother)
				
			EndIf
			
		Endif
		
	Else	
		
		szTheme = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "VALUE")
		
		szColTheme = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme"),"b" & szTheme)
		
		szColAnother = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme"),"f" & szTheme)
		
		szAlpha = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme"),"ba" & szTheme)
		
		szBoldOption = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme"),"bold" & szTheme)
		
		szItalicOption = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme"),"italic" & szTheme)			
		
	Endif
	
	If Len(szColTheme) >= 255 Then
		
		For i As Long = 1 To 8
			
			TGlobalVariables->szColorbtn(i) = Mid( szColTheme , (i-1)*16+1 , 7)
			
			TGlobalVariables->szColorbtn(i+8) = Mid( szColTheme , (i-1)*16+9 , 7)
			
			TGlobalVariables->szColorbtn(i+16) =  Mid( szColTheme , (i-1)*16+129 , 7)
			
			TGlobalVariables->szColorbtn(i+24) =  Mid( szColTheme , (i-1)*16+137 , 7)
			
			If TGlobalVariables->hOptions Then
				
				Dim As Ihandle Ptr btn = IupGetDialogChild(TGlobalVariables->hOptions, "B1_" & i)
				
				IupSetAttribute(btn, "BGCOLOR" , TGlobalVariables->szColorbtn(i))
				
				btn = IupGetDialogChild(TGlobalVariables->hOptions, "B2_" & i)
				
				IupSetAttribute(btn, "BGCOLOR" , TGlobalVariables->szColorbtn(i+8))
				
				btn = IupGetDialogChild(TGlobalVariables->hOptions, "B3_" & i)
				
				IupSetAttribute(btn, "BGCOLOR" , TGlobalVariables->szColorbtn(i+16))	
				
				btn = IupGetDialogChild(TGlobalVariables->hOptions, "B4_" & i)
				
				IupSetAttribute(btn, "BGCOLOR" , TGlobalVariables->szColorbtn(i+24))		
				
			Endif				
			
		Next
		
		For i As Long = 1 To 2
			
			TGlobalVariables->szColorbtn(i+32) = Mid( szColAnother , (i-1)*16+1 , 7) 
			
			TGlobalVariables->szColorbtn(i+34) = Mid( szColAnother , (i-1)*16+9 , 7) 
			
			TGlobalVariables->szColorbtn(i+36) =  Mid( szColAnother , (i-1)*16+33 , 7) 
			
			TGlobalVariables->szColorbtn(i+38) =  Mid( szColAnother , (i-1)*16+41 , 7)
			
			If TGlobalVariables->hOptions Then
				
				Dim As Ihandle Ptr btn = IupGetDialogChild(TGlobalVariables->hOptions, "B1_" & i+8)
				
				IupSetAttribute(btn, "BGCOLOR" , TGlobalVariables->szColorbtn(i+32))
				
				btn = IupGetDialogChild(TGlobalVariables->hOptions, "B2_" & i+8)
				
				IupSetAttribute(btn, "BGCOLOR" , TGlobalVariables->szColorbtn(i+34))
				
				btn = IupGetDialogChild(TGlobalVariables->hOptions, "B3_" & i+8)
				
				IupSetAttribute(btn, "BGCOLOR" , TGlobalVariables->szColorbtn(i+36))	
				
				btn = IupGetDialogChild(TGlobalVariables->hOptions, "B4_" & i+8)
				
				IupSetAttribute(btn, "BGCOLOR" , TGlobalVariables->szColorbtn(i+38))
				
			Endif				
			
		Next
		
		TGlobalVariables->szColorbtn(41) =  Mid( szColAnother , 65 , 7)
		
		TGlobalVariables->szColorbtn(42) =  Mid( szColAnother , 73 , 7)
		
		Dim As Ihandle Ptr btn = IupGetDialogChild(TGlobalVariables->hOptions, "B1_" & 11)
		
		IupSetAttribute(btn, "BGCOLOR" , TGlobalVariables->szColorbtn(41))	
		
		btn = IupGetDialogChild(TGlobalVariables->hOptions, "B2_" & 11)
		
		IupSetAttribute(btn, "BGCOLOR" , TGlobalVariables->szColorbtn(42))
		
		
		TGlobalVariables->szAlphaCaret = szAlpha
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updownalpha"), "VALUE" , TGlobalVariables->szAlphaCaret)	
		
		If TGlobalVariables->hOptions Then
			
			If Mid(szBoldOption,1,1) = "1" Then
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_str"), "VALUE", "ON")
				
			Else
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_str"), "VALUE", "OFF")
				
			Endif
			
			If Mid(szItalicOption,1,1) = "1" Then
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_str"), "VALUE", "ON")
				
			Else
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_str"), "VALUE", "OFF")
				
			Endif	
			
			If Mid(szBoldOption,2,1) = "1" Then
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_comm"), "VALUE", "ON")
				
			Else
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_comm"), "VALUE", "OFF")
				
			Endif
			
			If Mid(szItalicOption,2,1) = "1" Then
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_comm"), "VALUE", "ON")
				
			Else
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_comm"), "VALUE", "OFF")
				
			Endif			
			
			If Mid(szBoldOption,3,1) = "1" Then
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_numb"), "VALUE", "ON")
				
			Else
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_numb"), "VALUE", "OFF")
				
			Endif
			
			If Mid(szItalicOption,3,1) = "1" Then
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_numb"), "VALUE", "ON")
				
			Else
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_numb"), "VALUE", "OFF")
				
			Endif	
			
			If Mid(szBoldOption,4,1) = "1" Then
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_oper"), "VALUE", "ON")
				
			Else
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_oper"), "VALUE", "OFF")
				
			Endif
			
			If Mid(szItalicOption,4,1) = "1" Then
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_oper"), "VALUE", "ON")
				
			Else
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_oper"), "VALUE", "OFF")
				
			Endif	
			
			If Mid(szBoldOption,5,1) = "1" Then
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_iden"), "VALUE", "ON")
				
			Else
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_iden"), "VALUE", "OFF")
				
			Endif
			
			If Mid(szItalicOption,5,1) = "1" Then
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_iden"), "VALUE", "ON")
				
			Else
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_iden"), "VALUE", "OFF")
				
			Endif			
			
			If Mid(szBoldOption,6,1) = "1" Then
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw0"), "VALUE", "ON")
				
			Else
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw0"), "VALUE", "OFF")
				
			Endif
			
			If Mid(szItalicOption,6,1) = "1" Then
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw0"), "VALUE", "ON")
				
			Else
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw0"), "VALUE", "OFF")
				
			Endif	
			
			If Mid(szBoldOption,7,1) = "1" Then
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw1"), "VALUE", "ON")
				
			Else
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw1"), "VALUE", "OFF")
				
			Endif
			
			If Mid(szItalicOption,7,1) = "1" Then
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw1"), "VALUE", "ON")
				
			Else
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw1"), "VALUE", "OFF")
				
			Endif	
			
			If Mid(szBoldOption,8,1) = "1" Then
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw2"), "VALUE", "ON")
				
			Else
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw2"), "VALUE", "OFF")
				
			Endif
			
			If Mid(szItalicOption,8,1) = "1" Then
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw2"), "VALUE", "ON")
				
			Else
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw2"), "VALUE", "OFF")
				
			Endif	
			
			If Mid(szBoldOption,9,1) = "1" Then
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw3"), "VALUE", "ON")
				
			Else
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_b_kw3"), "VALUE", "OFF")
				
			Endif
			
			If Mid(szItalicOption,9,1) = "1" Then
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw3"), "VALUE", "ON")
				
			Else
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_i_kw3"), "VALUE", "OFF")
				
			Endif	
			
		Endif
		
	Endif
	
End Sub

' create tab "PATH" for dialog options "EDIT"
Function optdlg_create_tab_path_proc() As Ihandle Ptr Export
	
	'--------------------------- Path -------------------------------------
	Dim As Ihandle Ptr hBoxPath1, hBoxPath2, hBoxPath3, hBoxPath4 , hBoxPath5 , hBoxPath6 , vBoxPath, txtcompilierpath ,txtincludepath ,_
	txtdebuggerpath , txtterminalpath, txtbrowserpath , lblcompilier , lblinclude , lbldebugger ,_
	lblterminal , lblbrowser, btnselcompilier , btnselinclude ,btnseldebug 
	
	
	lblcompilier = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionpathcompilier"))
	
	lblinclude = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionpathinclude"))
	
	lbldebugger = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionpathdebug"))
	
	lblterminal = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionpathterminal"))
	
	lblbrowser = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionpathbrowser"))
	
	txtcompilierpath = IupText(0)
	
	IupSetAttribute(txtcompilierpath , "MINSIZE" , "300x30")
	
	IupSetAttribute(txtcompilierpath , "NAME" , "txtcomppath")
	
	IupSetAttribute(txtcompilierpath , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathcompilier"))
	
	txtincludepath = IupText(0)
	
	IupSetAttribute(txtincludepath , "MINSIZE" , "300x30")
	
	IupSetAttribute(txtincludepath , "NAME" , "txtincludepath")
	
	IupSetAttribute(txtincludepath , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathinclude"))	
	
	txtdebuggerpath = IupText(0)
	
	IupSetAttribute(txtdebuggerpath , "MINSIZE" , "300x30")
	
	IupSetAttribute(txtdebuggerpath , "NAME" , "txtdebugpath")
	
	IupSetAttribute(txtdebuggerpath , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathdebugger"))
	
	txtterminalpath = IupText(0)
	
	IupSetAttribute(txtterminalpath , "MINSIZE" , "300x30")
	
	IupSetAttribute(txtterminalpath , "NAME" , "txtterminal")	
	
	IupSetAttribute(txtterminalpath, "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathterminal"))
	
	txtbrowserpath = IupText(0) 
	
	IupSetAttribute(txtbrowserpath , "MINSIZE" , "300x30")
	
	IupSetAttribute(txtbrowserpath , "NAME" , "txtbrowser")	
	
	IupSetAttribute(txtbrowserpath, "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathbrowser"))	
	
	btnselcompilier = IupButton("...", 0)
	
	IupSetAttribute(btnselcompilier , "MAXSIZE" , "x30")
	
	IupSetAttribute(btnselcompilier , "MINSIZE" , "30x30")
	
	IupSetCallback(btnselcompilier , "ACTION" , Cast(Any Ptr, @option_btn_path_compilier_callback()))
	
	btnselinclude = IupButton("...", 0)
	
	IupSetAttribute(btnselinclude , "MAXSIZE" , "x30")
	
	IupSetAttribute(btnselinclude , "MINSIZE" , "30x30")
	
	IupSetCallback(btnselinclude , "ACTION" , Cast(Any Ptr, @option_btn_path_include_callback()))	
	
	btnseldebug = IupButton("...", 0)
	
	IupSetAttribute(btnseldebug , "MAXSIZE" , "x30")
	
	IupSetAttribute(btnseldebug , "MINSIZE" , "30x30")
	
	IupSetCallback(btnseldebug , "ACTION" , Cast(Any Ptr, @option_btn_path_debugger_callback()))
	
	hBoxPath1 = IupHbox(txtcompilierpath , btnselcompilier, IupFill(),0)
	
	hBoxPath2 = IupHbox(txtdebuggerpath , btnseldebug, 0)
	
	hBoxPath4 = IupHbox(txtterminalpath ,  0)
	
	hBoxPath5 = IupHbox(txtbrowserpath ,  0)
	
	hBoxPath6 = IupHbox(txtincludepath , btnselinclude, 0)
	
	vBoxPath = IupVBox(lblcompilier , hBoxPath1 , lblinclude , hBoxPath6 , lbldebugger , hBoxPath2 ,_
	lblterminal ,hBoxPath4, lblbrowser , hBoxPath5, IupFill(), 0)
	
	IupSetAttribute(vBoxPath, "NMARGIN", "85x60")
	
	Return vBoxPath	
	
End Function

' create tab "COLOR" for dialog options "EDIT"
Function optdlg_create_tab_color_proc() As Ihandle Ptr Export
	
	'----------------------- Theme --------------------
	
	Dim As Ihandle Ptr vBoxColor , fr_theme , fr_color , th_hbox ,  th_combo , th_txt, th_btn_ok , updown, col_hboxup , gridbox , _
	lbl1 , lbl2 , lbl3 , lbl4 , lbl5 , lbl6 ,lbl7 , lbl8 , lbl9 ,lbl10 , lbl11 , lbl12 ,lbl13 , lbl14 ,_
	lbl15 , lbl16  , lbl17 , lbl18 , lbl19 , lbl20, lbl21 , lbl22 , lblup, btn_dim1(11) , btn_dim2(11) , btn_dim3(11) , btn_dim4(11), checkstringB,checkstringI,_
	checkcommentB,checkcommentI, checknumbersB, checknumbersI ,  checkidentifiersB, checkidentifiersI,_
	checkoperB, checkoperI, checkkw0B,checkkw0I,checkkw1B,checkkw1I,checkkw2B,checkkw2I,checkkw3B,checkkw3I
	
	Static As Zstring*6 szbtn_str_dim1(11) , szbtn_str_dim2(11) , szbtn_str_dim3(11) , szbtn_str_dim4(11)
	
	th_combo = IupList(0)
	
	IupSetAttribute(th_combo , "DROPDOWN", "YES")
	
	IupSetAttribute(th_combo , "MINSIZE", "170x")	
	
	For i As Long = 1 To 100
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "n") <> "" Then
			
			IupSetAttribute(th_combo , Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "n"))
			
			IupSetStrAttribute(th_combo , "b" & Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "c"))
			
			IupSetStrAttribute(th_combo , "f" & Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "f"))
			
			IupSetStrAttribute(th_combo , "ba" & Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "a"))
			
			IupSetStrAttribute(th_combo , "bold" & Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "bold"))
			
			IupSetStrAttribute(th_combo , "italic" & Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "italic"))
			
		Else
			
			Exit For
			
		Endif
		
	Next
	
	IupSetAttribute(th_combo , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", "0"))
	
	IupSetCallback(th_combo , "ACTION" , Cast(Any Ptr , @options_combo_select_theme_callback()))
	
	IupSetAttribute(th_combo , "NAME" , "combotheme")
	
	th_txt = IupText("")
	
	IupSetAttribute(th_txt , "MINSIZE", "200x30")
	
	IupSetAttribute(th_txt , "NAME" , "txtnewtheme")
	
	th_btn_ok = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionthemeadd"),0)
	
	IupSetAttribute(th_btn_ok , "NAME" , "btnoknewtheme")
	
	IupSetCallback(th_btn_ok , "ACTION" , Cast(Any Ptr , @options_add_new_theme_callback()))
	
	IupSetAttribute(th_btn_ok , "MINSIZE", "120x30")
	
	th_hbox = IupHbox(th_combo , th_txt , IupFill() , th_btn_ok ,  0)
	
	IupSetAttribute(th_hbox , "GAP", "5")
	
	IupSetAttribute(th_hbox , "NCMARGIN", "3x7")
	
	fr_theme = IupFrame(th_hbox)
	
	IupSetAttribute(fr_theme , "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optiontheme"))
	
	lbl1 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncedit"))
	
	IupSetAttribute(lbl1 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl1 , "MINSIZE" , "x25")
	
	lbl2 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncwinout"))
	
	IupSetAttribute(lbl2 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl2 , "MINSIZE" , "x25")
	
	lbl3 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncpanelnumbers"))
	
	IupSetAttribute(lbl3 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl3 , "MINSIZE" , "x25")
	
	lbl4 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncmarker"))
	
	IupSetAttribute(lbl4 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl4 , "MINSIZE" , "x25")
	
	lbl5 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncpanelcollapse"))
	
	IupSetAttribute(lbl5 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl5 , "MINSIZE" , "x25")
	
	lbl6 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncseltext"))
	
	IupSetAttribute(lbl6 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl6 , "MINSIZE" , "x25")
	
	lbl7 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionccaret"))
	
	IupSetAttribute(lbl7 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl7 , "MINSIZE" , "x25")
	
	lbl8 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncstrings"))
	
	IupSetAttribute(lbl8 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl8 , "MINSIZE" , "x25")
	
	checkstringB = IupToggle("B",0)
	
	IupSetAttribute(checkstringB , "NAME" , "ch_b_str")
	
	checkstringI = IupToggle("I",0)
	
	IupSetAttribute(checkstringI , "NAME" , "ch_i_str")
	
	IupSetAttribute(checkstringB , "MINSIZE" , "x25")
	
	IupSetAttribute(checkstringI , "MINSIZE" , "x25")
	
	IupSetAttribute(checkstringB , "MAXSIZE" , "x25")
	
	IupSetAttribute(checkstringI , "MAXSIZE" , "x25")		
	
	IupSetCallback(checkstringB , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	IupSetCallback(checkstringI , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	lbl9 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionccomments"))
	
	IupSetAttribute(lbl9 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl9 , "MINSIZE" , "x25")
	
	checkcommentB = IupToggle("B",0)
	
	IupSetAttribute(checkcommentB , "NAME" , "ch_b_comm")
	
	checkcommentI = IupToggle("I",0)
	
	IupSetAttribute(checkcommentI , "NAME" , "ch_i_comm")
	
	IupSetAttribute(checkcommentB , "MINSIZE" , "x25")
	
	IupSetAttribute(checkcommentI , "MINSIZE" , "x25")
	
	IupSetAttribute(checkcommentB , "MAXSIZE" , "x25")
	
	IupSetAttribute(checkcommentI , "MAXSIZE" , "x25")		
	
	IupSetCallback(checkcommentB , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	IupSetCallback(checkcommentI , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))	
	
	lbl10 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncnumbers"))
	
	IupSetAttribute(lbl10 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl10 , "MINSIZE" , "x25")
	
	checknumbersB = IupToggle("B",0)
	
	IupSetAttribute(checknumbersB , "NAME" , "ch_b_numb")
	
	checknumbersI = IupToggle("I",0)
	
	IupSetAttribute(checknumbersI , "NAME" , "ch_i_numb")
	
	IupSetAttribute(checknumbersB , "MINSIZE" , "x25")
	
	IupSetAttribute(checknumbersI , "MINSIZE" , "x25")
	
	IupSetAttribute(checknumbersB , "MAXSIZE" , "x25")
	
	IupSetAttribute(checknumbersI , "MAXSIZE" , "x25")
	
	IupSetCallback(checknumbersB , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	IupSetCallback(checknumbersI , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	lbl11 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncoperator"))
	
	IupSetAttribute(lbl11 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl11 , "MINSIZE" , "x25")
	
	checkoperB = IupToggle("B",0)
	
	IupSetAttribute(checkoperB , "NAME" , "ch_b_oper")
	
	checkoperI = IupToggle("I",0)
	
	IupSetAttribute(checkoperI , "NAME" , "ch_i_oper")
	
	IupSetAttribute(checkoperB , "MINSIZE" , "x25")
	
	IupSetAttribute(checkoperI , "MINSIZE" , "x25")
	
	IupSetAttribute(checkoperB , "MAXSIZE" , "x25")
	
	IupSetAttribute(checkoperI , "MAXSIZE" , "x25")	
	
	IupSetCallback(checkoperB , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	IupSetCallback(checkoperI , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))	
	
	lbl12 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncidentifiers"))	
	
	IupSetAttribute(lbl12 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl12 , "MINSIZE" , "x25")
	
	checkidentifiersB = IupToggle("B",0)
	
	IupSetAttribute(checkidentifiersB , "NAME" , "ch_b_iden")
	
	checkidentifiersI = IupToggle("I",0)
	
	IupSetAttribute(checkidentifiersI , "NAME" , "ch_i_iden")
	
	IupSetAttribute(checkidentifiersB , "MINSIZE" , "x25")
	
	IupSetAttribute(checkidentifiersI , "MINSIZE" , "x25")
	
	IupSetAttribute(checkidentifiersB , "MAXSIZE" , "x25")
	
	IupSetAttribute(checkidentifiersI , "MAXSIZE" , "x25")	
	
	IupSetCallback(checkidentifiersB , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	IupSetCallback(checkidentifiersI , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))					
	
	lbl13 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionckeywords0"))
	
	IupSetAttribute(lbl13 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl13 , "MINSIZE" , "x25")
	
	checkkw0B = IupToggle("B",0)
	
	IupSetAttribute(checkkw0B , "NAME" , "ch_b_kw0")
	
	checkkw0I = IupToggle("I",0)
	
	IupSetAttribute(checkkw0I , "NAME" , "ch_i_kw0")
	
	IupSetAttribute(checkkw0B , "MINSIZE" , "x25")
	
	IupSetAttribute(checkkw0I , "MINSIZE" , "x25")
	
	IupSetAttribute(checkkw0B , "MAXSIZE" , "x25")
	
	IupSetAttribute(checkkw0I , "MAXSIZE" , "x25")		
	
	IupSetCallback(checkkw0B , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	IupSetCallback(checkkw0I , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))			
	
	lbl14 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionckeywords1"))
	
	IupSetAttribute(lbl14 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl14 , "MINSIZE" , "x25")
	
	checkkw1B = IupToggle("B",0)
	
	IupSetAttribute(checkkw1B , "NAME" , "ch_b_kw1")
	
	checkkw1I = IupToggle("I",0)
	
	IupSetAttribute(checkkw1I , "NAME" , "ch_i_kw1")
	
	IupSetAttribute(checkkw1B , "MINSIZE" , "x25")
	
	IupSetAttribute(checkkw1I , "MINSIZE" , "x25")
	
	IupSetAttribute(checkkw1B , "MAXSIZE" , "x25")
	
	IupSetAttribute(checkkw1I , "MAXSIZE" , "x25")		
	
	IupSetCallback(checkkw1B , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	IupSetCallback(checkkw1I , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	lbl15 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionckeywords2"))
	
	IupSetAttribute(lbl15 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl15 , "MINSIZE" , "x25")
	
	checkkw2B = IupToggle("B",0)
	
	IupSetAttribute(checkkw2B , "NAME" , "ch_b_kw2")
	
	checkkw2I = IupToggle("I",0)
	
	IupSetAttribute(checkkw2I , "NAME" , "ch_i_kw2")
	
	IupSetAttribute(checkkw2B , "MINSIZE" , "x25")
	
	IupSetAttribute(checkkw2I , "MINSIZE" , "x25")
	
	IupSetAttribute(checkkw2B , "MAXSIZE" , "x25")
	
	IupSetAttribute(checkkw2I , "MAXSIZE" , "x25")	
	
	IupSetCallback(checkkw2B , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	IupSetCallback(checkkw2I , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))	
	
	lbl16 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionckeywords3"))
	
	IupSetAttribute(lbl16 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl16 , "MINSIZE" , "x25")
	
	checkkw3B = IupToggle("B",0)
	
	IupSetAttribute(checkkw3B , "NAME" , "ch_b_kw3")
	
	checkkw3I = IupToggle("I",0)
	
	IupSetAttribute(checkkw3I , "NAME" , "ch_i_kw3")
	
	IupSetAttribute(checkkw3B , "MINSIZE" , "x25")
	
	IupSetAttribute(checkkw3I , "MINSIZE" , "x25")
	
	IupSetAttribute(checkkw3B , "MAXSIZE" , "x25")
	
	IupSetAttribute(checkkw3I , "MAXSIZE" , "x25")	
	
	IupSetCallback(checkkw3B , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))
	
	IupSetCallback(checkkw3I , "ACTION" , Cast(Any Ptr, @action_checkbox_style_group_callback))	
	
	lbl17 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionannot1"))
	
	IupSetAttribute(lbl17 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl17 , "MINSIZE" , "x25")	
	
	lbl18 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionannot2"))
	
	IupSetAttribute(lbl18 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl18 , "MINSIZE" , "x25")
	
	lbl19 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionannot3"))
	
	IupSetAttribute(lbl19 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl19 , "MINSIZE" , "x25")	
	
	lbl20 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionwinside"))
	
	IupSetAttribute(lbl20 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl20 , "MINSIZE" , "x25")
	
	lbl21 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"signnonconservation"))
	
	IupSetAttribute(lbl21 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl21 , "MINSIZE" , "x25")
	
	lbl22 = IupLabel("Reserved")
	
	IupSetAttribute(lbl22 , "MAXSIZE" , "x25")
	
	IupSetAttribute(lbl22 , "MINSIZE" , "x25")
	
	
	For i As Long = 1 To 11
		
		btn_dim1(i-1) = IupButton(0,0)
		
		szbtn_str_dim1(i-1) = "B1_" & i
		
		IupSetAttribute(btn_dim1(i-1) , "NAME" , szbtn_str_dim1(i-1))
		
		#ifdef __USE_GTK3__
			
			IupSetAttribute(btn_dim1(i-1) , "TITLE" , "")
			
		#endif
		
		IupSetAttribute(btn_dim1(i-1) , "MINSIZE" , "30x25")
		
		IupSetAttribute(btn_dim1(i-1) , "MAXSIZE" , "30x25")
		
		IupSetCallback(btn_dim1(i-1) , "ACTION" , Cast(Any Ptr , @options_select_color_callback()))
		
		btn_dim2(i-1) = IupButton(0,0)
		
		szbtn_str_dim2(i-1) = "B2_" & i
		
		IupSetAttribute(btn_dim2(i-1) , "NAME" , szbtn_str_dim2(i-1))
		
		#ifdef __USE_GTK3__
			
			IupSetAttribute(btn_dim2(i-1) , "TITLE" , "")
			
		#endif
		
		IupSetAttribute(btn_dim2(i-1) , "MINSIZE" , "30x25")
		
		IupSetAttribute(btn_dim2(i-1) , "MAXSIZE" , "30x25")
		
		IupSetCallback(btn_dim2(i-1) , "ACTION" , Cast(Any Ptr , @options_select_color_callback()))
		
		btn_dim3(i-1) = IupButton(0,0) 
		
		szbtn_str_dim3(i-1) = "B3_" & i
		
		IupSetAttribute(btn_dim3(i-1) , "NAME" , szbtn_str_dim3(i-1))
		
		#ifdef __USE_GTK3__
			
			IupSetAttribute(btn_dim3(i-1) , "TITLE" , "")
			
		#endif
		
		IupSetAttribute(btn_dim3(i-1) , "MINSIZE" , "30x25")
		
		IupSetAttribute(btn_dim3(i-1) , "MAXSIZE" , "30x25")
		
		IupSetCallback(btn_dim3(i-1) , "ACTION" , Cast(Any Ptr , @options_select_color_callback()))
		
		btn_dim4(i-1) = IupButton(0,0)
		
		szbtn_str_dim4(i-1) = "B4_" & i
		
		IupSetAttribute(btn_dim4(i-1) , "NAME" , szbtn_str_dim4(i-1))
		
		#ifdef __USE_GTK3__
			
			IupSetAttribute(btn_dim4(i-1) , "TITLE" , "")
			
		#endif
		
		IupSetAttribute(btn_dim4(i-1) , "MINSIZE" , "30x25")	
		
		IupSetAttribute(btn_dim4(i-1) , "MAXSIZE" , "30x25")		
		
		IupSetCallback(btn_dim4(i-1) , "ACTION" , Cast(Any Ptr , @options_select_color_callback()))
		
	Next
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Parser" , "tips1") = "1" Then
		
		IupSetAttribute(btn_dim1(8) , "VISIBLE" , "NO")
		
		IupSetAttribute(btn_dim2(8) , "VISIBLE" , "NO")
		
		IupSetAttribute(btn_dim3(8) , "VISIBLE" , "NO")
		
	Endif
	
	IupSetAttribute(btn_dim3(10) , "VISIBLE" , "NO")
	
	IupSetAttribute(btn_dim4(10) , "VISIBLE" , "NO")
	
	IupSetAttribute(lbl22 , "VISIBLE" , "NO")
	
	
	updown = IupText(0)
	
	lblup = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionalpha"))
	
	col_hboxup = IupHbox(lblup , updown , 0 )
	
	IupSetAttribute(updown , "SPIN", "YES")
	
	IupSetAttribute(updown , "MAXSIZE" , "70x")
	
	IupSetAttribute(updown , "MINSIZE" , "x30")
	
	IupSetAttribute(updown , "NAME" , "updownalpha")
	
	IupSetAttribute(updown , "SPINMAX" , "255")
	
	Dim As Zstring*4 szNull = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", "0")
	
	IupSetAttribute(updown , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", szNull & "a"))
	
	Var hSpaceBox = IupHBox(IupFill() , 0 )
	
	IupSetAttribute(hSpaceBox, "MARGIN", "50x")
	
	gridbox = IupGridBox(lbl1 , lbl2 , lbl3 , lbl4 , lbl5 , lbl6 , lbl7 , lbl8 , lbl17 , lbl18, lbl21, _
	btn_dim1(0) , btn_dim1(1) , btn_dim1(2) , btn_dim1(3) , btn_dim1(4) , btn_dim1(5), btn_dim1(6) , btn_dim1(7) , btn_dim1(8) ,btn_dim1(9), btn_dim1(10),_
	btn_dim2(0) , btn_dim2(1) , btn_dim2(2) , btn_dim2(3) , btn_dim2(4) , btn_dim2(5), btn_dim2(6) , btn_dim2(7) , btn_dim2(8), btn_dim2(9) , btn_dim2(10),_
	IupFill() ,IupFill() ,IupFill() ,IupFill() ,IupFill() ,IupFill() ,IupFill() , checkstringB ,IupFill() ,IupFill() ,IupFill(),_
	IupFill() , IupFill() ,IupFill() ,IupFill() ,IupFill() ,IupFill() ,IupFill() ,checkstringI,IupFill() ,IupFill() ,IupFill(),_
	hSpaceBox , IupFill() ,IupFill() ,IupFill() ,IupFill() ,IupFill() ,IupFill() ,IupFill(),IupFill() ,IupFill() ,IupFill(),_
	lbl9 , lbl10 , lbl11 , lbl12 , lbl13 , lbl14 , lbl15 , lbl16 ,lbl19 ,lbl20 ,lbl22 ,_
	btn_dim3(0) , btn_dim3(1) , btn_dim3(2) , btn_dim3(3) , btn_dim3(4) , btn_dim3(5), btn_dim3(6) , btn_dim3(7) , btn_dim3(8), btn_dim3(9) , btn_dim3(10),_
	btn_dim4(0) , btn_dim4(1) , btn_dim4(2) , btn_dim4(3) , btn_dim4(4) , btn_dim4(5), btn_dim4(6) , btn_dim4(7) , btn_dim4(8), btn_dim4(9) , btn_dim4(10),_
	checkcommentB ,checknumbersB, checkoperB, checkidentifiersB , checkkw0B,checkkw1B ,checkkw2B,checkkw3B,IupFill() ,IupFill() ,IupFill(),_
	checkcommentI ,checknumbersI, checkoperI ,checkidentifiersI , checkkw0I,checkkw1I ,checkkw2I,checkkw3I,IupFill() ,IupFill() ,IupFill(), 0)
	
	IupSetAttribute(gridbox, "SIZELIN", "-1")
	
	IupSetAttribute(gridbox, "NUMDIV", "11")
	
	IupSetAttribute(gridbox, "ALIGNMENTLIN", "ACENTER")
	
	IupSetAttribute(gridbox, "ORIENTATION", "VERTICAL")
	
	IupSetAttribute(gridbox, "EXPANDCHILDREN" , "HORIZONTAL")
	
	IupSetAttribute(gridbox, "MARGIN", "10x10")
	
	IupSetAttribute(gridbox, "GAPLIN", "5")
	
	IupSetAttribute(gridbox, "GAPCOL", "2")
	
	fr_color = IupFrame(gridbox)
	
	IupSetAttribute(fr_color , "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbackfront"))
	
	vBoxColor = IupVbox( IupFill() ,fr_theme, IupFill() ,col_hboxup ,IupFill() ,  fr_color ,  0)
	
	Return vBoxColor
	
End Function

' create tab "GENERAL" for dialog options "EDIT"
Function optdlg_create_tab_general_proc() As iHandle Ptr Export
	
	'----------------------- general --------------------
	
	Dim As Ihandle Ptr genfrlineends , genfrtabs , genfrlang , genfreditor , genfrfont,_
	genfrcase , vboxle , vboxt1 , vboxt2 , hboxt , hboxlang , vboxedit1 , vboxedit2 , hboxedit , _
	vboxfont1 , vboxfont2 , hboxfont , hboxcase , hboxsave ,  mainbox , radiowin , radiolin , radiotab , radiospace , _
	updown , combo , checkwrap , checkwhitespace , checkspacesimv , checknumbers ,  checksavecase , _
	radiodowncase , radioupcase , radiocamelcase , radiomixedcase , checkfolding, btnedit , btnwinout ,_
	btnstatus , btnwinside , btnannot , btnTabs , txtedit ,  txtwinout , txtstatus , txtwinside , txtannot , txtTabs
	
	radiowin = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionlinewin"),0)
	
	IupSetAttribute(radiowin , "NAME" , "radiowin")
	
	radiolin = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionlinelin"),0)
	
	IupSetAttribute(radiolin , "NAME" , "radiolin")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends") = "WIN" Then
		
		IupSetAttribute(radiowin , "VALUE" , "ON")
		
	Else	
		
		IupSetAttribute(radiolin , "VALUE" , "ON")
		
	Endif
	
	radiotab = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optiontab"),0)
	
	IupSetAttribute(radiotab , "NAME" , "radiotab")
	
	radiospace = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionspace"),0)
	
	IupSetAttribute(radiospace , "NAME" , "radiospace")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "indent") = "TAB" Then
		
		IupSetAttribute(radiotab , "VALUE" , "ON")
		
	Else
		
		IupSetAttribute(radiospace , "VALUE" , "ON")
		
	Endif	
	
	updown = IupText(0)
	
	IupSetAttribute(updown , "SPIN", "YES")
	
	#ifdef __USE_GTK3__
		
		IupSetAttribute(updown , "MAXSIZE" , "80x")
		
	#else
		
		IupSetAttribute(updown , "MAXSIZE" , "50x")
		
	#endif
	
	IupSetAttribute(updown , "MINSIZE" , "x30")
	
	IupSetAttribute(updown , "NAME" , "updownindent")
	
	IupSetAttribute(updown , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "indentsize"))
	
	combo = IupList(0)
	
	IupSetAttribute(combo , "DROPDOWN", "YES")
	
	IupSetAttribute(combo , "MINSIZE", "135x")	
	
	For i As Long  = 1 To 100
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Lang" , "n" & i) <> "" Then
			
			IupSetAttribute(combo , Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Lang" , "n" & i) )
			
		Else	
			
			Exit For
			
		Endif
		
	Next
	
	IupSetAttribute(combo , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Lang", "current"))
	
	IupSetAttribute(combo , "NAME" , "combolang")
	
	checkwrap = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionwrapline"),0)
	
	IupSetAttribute(checkwrap , "NAME" , "checkwrap")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","wrap")  = "WORD" Then
		
		IupSetAttribute(checkwrap , "VALUE", "ON")
		
	Endif
	
	checkwhitespace = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionvisiblespace"),0)
	
	IupSetAttribute(checkwhitespace , "NAME" , "checkwhitespace")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","whitespace")  = "VISIBLEALWAYS" Then
		
		IupSetAttribute(checkwhitespace , "VALUE" , "ON")
		
	Endif	
	
	checkspacesimv = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionvisibleindents"),0)
	
	IupSetAttribute(checkspacesimv , "NAME" , "checkspacesimv")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","indentationguides")  = "REAL" Then
		
		IupSetAttribute(checkspacesimv , "VALUE" , "ON")
		
	Endif		
	
	checknumbers = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionvisiblenumbers"),0)
	
	IupSetAttribute(checknumbers , "NAME" , "checknumbers")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","viewnumbers")  = "YES" Then
		
		IupSetAttribute(checknumbers , "VALUE" , "ON")
		
	Endif			
	
	checkfolding = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionvisiblefolding"),0)
	
	IupSetAttribute(checkfolding , "NAME" , "checkfolding")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","folding")  = "YES" Then
		
		IupSetAttribute(checkfolding , "VALUE" , "ON")
		
	Endif
	
	checksavecase = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncasesave"),0)
	
	IupSetAttribute(checksavecase , "NAME" , "checksavecase")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","savecase")  = "YES" Then
		
		IupSetAttribute(checksavecase , "VALUE" , "ON")
		
	Endif	
	
	radioupcase = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncaseup"),0)
	
	IupSetAttribute(radioupcase , "NAME" , "radioupcase")
	
	radiodowncase = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncasedown"),0)
	
	IupSetAttribute(radiodowncase , "NAME" , "radiodowncase")
	
	radiocamelcase = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncasecamel"),0)
	
	IupSetAttribute(radiocamelcase , "NAME" , "radiocamelcase")
	
	radiomixedcase = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncasemixed"),0)
	
	IupSetAttribute(radiomixedcase , "NAME" , "radiomixedcase")	
	
	Select Case *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "case")
			
		Case "up"
			
			IupSetAttribute(radioupcase , "VALUE" , "ON")
			
		Case "down"
			
			IupSetAttribute(radiodowncase , "VALUE" , "ON")
			
		Case "camel"   
			
			IupSetAttribute(radiocamelcase , "VALUE" , "ON")
			
		Case Else   
			
			IupSetAttribute(radiomixedcase , "VALUE" , "ON")
			
	End Select
	
	btnedit = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionfontedit"),0)
	
	IupSetAttribute(btnedit , "MINSIZE" , "130x30")
	
	IupSetCallback(btnedit , "ACTION" , Cast(Any Ptr , @options_select_fontedit_callback()))
	
	btnwinout = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionfontwinout"),0)
	
	IupSetAttribute(btnwinout , "MINSIZE" , "130x30")
	
	IupSetCallback(btnwinout , "ACTION" , Cast(Any Ptr , @options_select_fontwinout_callback()))
	
	btnstatus = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionfontstatus"),0)
	
	IupSetAttribute(btnstatus , "MINSIZE" , "130x30")
	
	IupSetCallback(btnstatus , "ACTION" , Cast(Any Ptr , @options_select_fontstatus_callback()))
	
	btnwinside = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionfontwinside"),0)
	
	IupSetAttribute(btnwinside , "MINSIZE" , "130x30")
	
	IupSetCallback(btnwinside , "ACTION" , Cast(Any Ptr , @options_select_fontwinside_callback()))
	
	btnannot = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionfontannot"),0)
	
	IupSetAttribute(btnannot , "MINSIZE" , "130x30")
	
	IupSetCallback(btnannot , "ACTION" , Cast(Any Ptr , @options_select_fontannot_callback()))
	
	btnTabs = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionfonttabs"),0)
	
	IupSetAttribute(btntabs , "MINSIZE" , "130x30")
	
	IupSetCallback(btntabs , "ACTION" , Cast(Any Ptr , @options_select_fonttabs_callback()))	
	
	txtedit = IupText("")
	
	IupSetAttribute(txtedit , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","editor"))
	
	IupSetAttribute(txtedit , "NAME" , "ftxtedit")
	
	IupSetAttribute(txtedit , "MINSIZE" , "330x30")
	
	'IupSetAttribute(txtedit , "MAXSIZE" , "x21")
	
	txtwinout = IupText("")
	
	IupSetAttribute(txtwinout , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","winout"))
	
	IupSetAttribute(txtwinout , "NAME" , "ftxtwinout")
	
	IupSetAttribute(txtwinout , "MINSIZE" , "330x30")
	
	'IupSetAttribute(txtwinout , "MAXSIZE" , "x21")
	
	txtstatus = IupText("")
	
	IupSetAttribute(txtstatus , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","status"))
	
	IupSetAttribute(txtstatus , "NAME" , "ftxtstatus")
	
	IupSetAttribute(txtstatus , "MINSIZE" , "330x30")
	
	'IupSetAttribute(txtstatus , "MAXSIZE" , "x21")
	
	txtwinside = IupText("")
	
	IupSetAttribute(txtwinside , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","winside"))
	
	IupSetAttribute(txtwinside , "NAME" , "ftxtwinside")
	
	IupSetAttribute(txtwinside , "MINSIZE" , "330x30")
	
	'IupSetAttribute(txtwinside , "MAXSIZE" , "x21")	
	
	txtannot = IupText("")
	
	IupSetAttribute(txtannot , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","annot"))
	
	IupSetAttribute(txtannot , "NAME" , "ftxtannot")
	
	IupSetAttribute(txtannot , "MINSIZE" , "330x30")
	
	'IupSetAttribute(txtannot , "MAXSIZE" , "x21")
	
	txtTabs = IupText("")
	
	IupSetAttribute(txtTabs , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","tabs"))
	
	IupSetAttribute(txtTabs , "NAME" , "ftxttabs")
	
	IupSetAttribute(txtTabs , "MINSIZE" , "330x30")
	
	vboxle = IupVbox(radiowin , radiolin , 0 )
	
	IupSetAttribute(vboxle , "GAP", "5")
	
	IupSetAttribute(vboxle , "NCMARGIN", "3x5")
	
	genfrlineends = IupFrame(IupRadio(vboxle))
	
	IupSetAttribute(genfrlineends , "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionlineend"))
	
	vboxt1 = IupVbox(radiotab , radiospace , 0 )
	
	IupSetAttribute(vboxt1 , "GAP", "5")
	
	vboxt2 = IupVbox(updown, 0 )
	
	hboxt = IupHbox(IupRadio(vboxt1) , vboxt2 , 0 )
	
	IupSetAttribute(hboxt , "NCMARGIN", "3x5")
	
	genfrtabs = IupFrame(hboxt)
	
	IupSetAttribute(genfrtabs , "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionindents"))
	
	hboxlang = IupHbox(combo , 0 )
	
	IupSetAttribute(hboxlang , "NCMARGIN", "3x8")
	
	genfrlang = IupFrame(hboxlang)
	
	IupSetAttribute(genfrlang , "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionlang"))
	
	vboxedit1 = IupVbox(checkwrap , checkwhitespace , checkfolding , 0 )
	
	IupSetAttribute(vboxedit1 , "GAP", "5")
	
	vboxedit2 = IupVbox( checkspacesimv , checknumbers , 0 )	
	
	IupSetAttribute(vboxedit2 , "GAP", "5")
	
	hboxedit = IupHbox(vboxedit1 , IupFill() , vboxedit2 , 0 )
	
	IupSetAttribute(hboxedit , "NCMARGIN", "3x7")
	
	genfreditor = IupFrame(hboxedit)
	
	IupSetAttribute(genfreditor , "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionedit"))
	
	hboxcase = IupHbox(IupFill(),radioupcase , IupFill(), radiodowncase , IupFill(), radiocamelcase , IupFill(), radiomixedcase , IupFill(), 0) 
	
	IupSetAttribute(hboxcase , "NCMARGIN", "x3")
	
	hboxsave = IupHbox(iupfill() , checksavecase , iupfill() , 0)
	
	genfrcase = IupFrame(iupvbox(IupRadio(hboxcase) , hboxsave , 0))
	
	IupSetAttribute(genfrcase , "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncodecase"))
	
	vboxfont1 = IupVbox(btnedit , btnwinout , btnstatus , btnwinside, btnannot, btnTabs, 0 )
	
	IupSetAttribute(vboxfont1 , "NCMARGIN", "3x4")
	
	IupSetAttribute(vboxfont1 , "GAP", "2")
	
	vboxfont2 = IupVbox(txtedit ,  txtwinout , txtstatus, txtwinside, txtannot, txtTabs , 0 )
	
	IupSetAttribute(vboxfont2 , "NCMARGIN", "3x4")
	
	IupSetAttribute(vboxfont2 , "GAP", "2")
	
	hboxfont = IupHbox(vboxfont1 , IupFill(), vboxfont2 , 0 )
	
	genfrfont = IupFrame(hboxfont)
	
	IupSetAttribute(genfrfont , "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionfont"))
	
	mainbox = IupVbox(IupFill(),IupHbox(genfrlineends , IupFill(), genfrtabs , IupFill(), genfrlang , 0) ,IupFill(), genfreditor ,IupFill(),genfrcase , IupFill(), genfrfont,IupFill(), 0 )	
	
	Return mainbox
	
End Function

' create tab "another" for dialog options "EDIT"
Function optdlg_create_tab_another_proc() As Ihandle Ptr Export
	
	Dim As Ihandle Ptr checkparser , checkautokeyword , checkautoas , checkautofieldtype , checktips , checkdelaytips , checkautocomplect ,_
	checkplusrows ,checkendifspace , checkcom , lbllenght  , lbllexer , lbltimeparser , lbltimewinside , lbltimetips,  updownlenght , updownparser , _
	updownwinside , updowntips, combo , frame , radio1,radio2, hBox0 , hBox1  , hbox2 ,hBox3, hBox4  , hbox5 , hBox6, hbox7 , hBox8 , hbox9, hbox10 ,_
	hbox10_1 , hbox11 , hbox12 , hBox13 , hBox8_1, hBox8_2, vBox1 , vBox2 , vBox3 , vBoxtips , hBoxtips
	
	'--------------------------- another  -------------------------------------
	
	checkparser = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionparser"),0)
	
	IupSetAttribute(checkparser , "NAME" , "ch_parser")
	
	IupSetAttribute(checkparser , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser","isparser"))
	
	IupSetCallback(checkparser, "ACTION" , Cast(Any Ptr, @option_disable_parser_callback))
	
	checkautokeyword = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionautokeyword"),0)
	
	IupSetAttribute(checkautokeyword , "NAME" , "ch_autokeyword")
	
	IupSetAttribute(checkautokeyword , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser","isautokeyword"))
	
	checkautoas = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionautoas"),0)
	
	IupSetAttribute(checkautoas , "NAME" , "ch_autoas")
	
	IupSetAttribute(checkautoas , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser","isautoas"))
	
	checkautofieldtype = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionfieldtype"),0)
	
	IupSetAttribute(checkautofieldtype , "NAME" , "ch_autoft")
	
	IupSetAttribute(checkautofieldtype , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser","isautoft"))	
	
	checktips = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionchecktips"),0)
	
	IupSetAttribute(checktips , "NAME" , "ch_tips")
	
	IupSetAttribute(checktips , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser","istips"))
	
	checkdelaytips = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optiondelaytips"),0)
	
	IupSetAttribute(checkdelaytips , "NAME" , "ch_delaytips")
	
	IupSetAttribute(checkdelaytips , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser","isdelaytips"))	
	
	IupSetCallback(checkdelaytips, "ACTION" , Cast(Any Ptr, @option_enable_delaytips_callback))
	
	radio1 = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionstyletips") & "1",0)
	
	IupSetAttribute(radio1 , "NAME" , "radiotips1")
	
	IupSetCallback(radio1, "VALUECHANGED_CB" , Cast(Any Ptr, @option_select_tips_callback))
	
	radio2 = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionstyletips") & "2",0)
	
	IupSetAttribute(radio2 , "NAME" , "radiotips2")
	
	IupSetCallback(radio2, "VALUECHANGED_CB" , Cast(Any Ptr, @option_select_tips_callback))
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Parser" , "tips1") = "1" Then
		
		IupSetAttribute(radio1 , "VALUE" , "ON")
		
	Else	
		
		IupSetAttribute(radio2 , "VALUE" , "ON")
		
	Endif
	
	lbllenght = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionparserlenghtword"))
	
	IupSetAttribute(lbllenght , "MINSIZE", "x30")
	
	lbllexer = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionlexer"))
	
	'IupSetAttribute(lbllexer , "MINSIZE", "x30")
	
	lbltimeparser = IupLabel( *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionparsertime"))
	
	IupSetAttribute(lbltimeparser , "MINSIZE", "x30")
	
	lbltimewinside = IupLabel( *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionwinsidetime"))	
	
	IupSetAttribute(lbltimewinside , "MINSIZE", "x30")
	
	lbltimetips = IupLabel( *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optiontipstime"))	
	
	IupSetAttribute(lbltimetips , "MINSIZE", "x30")
	
	combo = IupList(0)
	
	IupSetAttribute(combo , "DROPDOWN", "YES")
	
	IupSetAttribute(combo , "MINSIZE", "120x")
	
	IupSetAttribute(combo , "NAME" , "combolexer")
	
	IupSetAttribute(combo , "1" , "freebasic")
	
	IupSetAttribute(combo , "2" , "vb")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Lexer","lex") = "freebasic" Then
		
		IupSetAttribute(combo , "VALUE" , "1")
		
	Else
		
		IupSetAttribute(combo , "VALUE" , "2")
		
	Endif
	
	updownlenght = IupText(0)
	
	IupSetAttribute(updownlenght , "SPIN", "YES")
	
	IupSetAttribute(updownlenght , "MAXSIZE" , "70x")
	
	IupSetAttribute(updownlenght , "MINSIZE" , "x30")
	
	IupSetAttribute(updownlenght , "NAME" , "updownlenghtword")
	
	IupSetAttribute(updownlenght , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Parser" , "lenght"))
	
	updownparser = IupText(0)
	
	IupSetAttribute(updownparser , "SPIN", "YES")
	
	IupSetAttribute(updownparser , "MAXSIZE" , "70x")
	
	IupSetAttribute(updownparser , "MINSIZE" , "x30")
	
	IupSetAttribute(updownparser , "SPINMAX" , "100000")
	
	IupSetAttribute(updownparser , "SPINMIN" , "50")
	
	IupSetAttribute(updownparser , "NAME" , "updownprsms")
	
	IupSetAttribute(updownparser , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Parser" , "parserms"))	
	
	updownwinside = IupText(0)
	
	IupSetAttribute(updownwinside , "SPIN", "YES")
	
	IupSetAttribute(updownwinside , "MAXSIZE" , "70x")
	
	IupSetAttribute(updownwinside , "MINSIZE" , "x30")
	
	IupSetAttribute(updownwinside , "SPINMAX" , "100000")
	
	IupSetAttribute(updownwinside , "SPINMIN" , "50")	
	
	IupSetAttribute(updownwinside , "NAME" , "updownwinms")
	
	IupSetAttribute(updownwinside , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Parser" , "winsidems"))		
	
	updowntips = IupText(0)
	
	IupSetAttribute(updowntips , "SPIN", "YES")
	
	IupSetAttribute(updowntips , "MAXSIZE" , "70x")
	
	IupSetAttribute(updowntips , "MINSIZE" , "x30")
	
	IupSetAttribute(updowntips , "SPINMAX" , "100000")
	
	IupSetAttribute(updowntips , "SPINMIN" , "0")	
	
	IupSetAttribute(updowntips , "NAME" , "updowntipsms")
	
	IupSetAttribute(updowntips , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Parser" , "tipsms"))	
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser","isparser") = "OFF" Orelse _
	*IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser","isparser") = "" Then
		
		IupSetAttribute(checkautokeyword , "ACTIVE", "NO")
		
		IupSetAttribute(checkautoas , "ACTIVE", "NO")		
		
		IupSetAttribute(checkautofieldtype , "ACTIVE", "NO")
		
		IupSetAttribute(checktips , "ACTIVE", "NO")
		
		IupSetAttribute(updownlenght , "ACTIVE", "NO")
		
		IupSetAttribute(updownparser , "ACTIVE", "NO")
		
		IupSetAttribute(updowntips , "ACTIVE", "NO")
		
	Endif
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser","isdelaytips") = "OFF" Orelse _
	*IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser","isdelaytips") = "" Then
		
		IupSetAttribute(updowntips , "ACTIVE", "NO")
		
	Endif
	
	checkautocomplect = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionautocomplect"),0)
	
	IupSetAttribute(checkautocomplect , "NAME" , "checkautocomplect")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","autocomplect")  = "YES" Then
		
		IupSetAttribute(checkautocomplect , "VALUE" , "ON")
		
	Endif
	
	checkplusrows = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionplusrows"),0)
	
	IupSetAttribute(checkplusrows , "NAME" , "checkplusrows")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","plusrows")  = "YES" Then
		
		IupSetAttribute(checkplusrows , "VALUE" , "ON")
		
	Endif
	
	checkendifspace = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionendif"),0)
	
	IupSetAttribute(checkendifspace , "NAME" , "checkendifspace")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","endifspace")  = "YES" Then
		
		IupSetAttribute(checkendifspace , "VALUE" , "ON")
		
	Endif	
	
	checkcom = IupToggle(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncom"),0)
	
	IupSetAttribute(checkcom , "NAME" , "checkcom")
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","checkcom")  = "YES" Then
		
		IupSetAttribute(checkcom , "VALUE" , "ON")
		
	Endif
	
	vBoxtips = IupVbox(radio1 , radio2 , 0)
	
	hBoxtips = IupHbox(IupRadio(vBoxtips) , 0)
	
	hBox1 = IupHbox(checkparser , 0)
	
	hBox2 = IupHbox(checkautokeyword , 0)
	
	hBox3 = IupHbox(checkautoas , 0)
	
	hBox4 = IupHbox(checkautofieldtype , 0)
	
	hBox5 = IupHbox(checktips , 0)
	
	hBox6 = IupHbox(lbllenght , updownlenght ,  0)
	
	hBox7 = IupHbox(lbltimeparser , updownparser ,  0)
	
	hBox8 = IupHbox(lbltimewinside , updownwinside , 0)	
	
	hBox8_1 = IupHbox(lbltimetips , updowntips , 0)	
	
	hBox8_2 = IupHbox(checkdelaytips , 0)
	
	hbox10 = IupHbox(checkautocomplect,checkplusrows,0)
	
	hbox10_1 = IupHbox(checkendifspace,0)
	
	hbox11 = IupHbox(checkcom,0)
	
	hbox12 = IupHbox(IupFill() , combo, IupFill() , 0)
	
	hbox13 = IupHbox(IupFill() ,lbllexer, IupFill() , 0)
	
	IupSetAttribute(hBoxtips , "MARGIN" , "30x5")
	
	IupSetAttribute(hBox1 , "MARGIN" , "3x5")
	
	IupSetAttribute(hBox2 , "MARGIN" , "20x1")
	
	IupSetAttribute(hBox3 , "MARGIN" , "20x1")
	
	IupSetAttribute(hBox4 , "MARGIN" , "20x1")
	
	IupSetAttribute(hBox5 , "MARGIN" , "20x5")
	
	IupSetAttribute(hBox6 , "MARGIN" , "20x5")
	
	IupSetAttribute(hBox7 , "MARGIN" , "20x5")	
	
	IupSetAttribute(hBox8_1 , "MARGIN" , "20x5")
	
	IupSetAttribute(hBox8_2 , "MARGIN" , "20x5")	
	
	IupSetAttribute(hBox8 , "MARGIN" , "5x5")
	
	IupSetAttribute(hBox11 , "MARGIN" , "x8")
	
	IupSetAttribute(hBox12 , "MARGIN" , "x8")
	
	IupSetAttribute(hBox6 , "NGAP" , "5")	
	
	IupSetAttribute(hBox7 , "NGAP" , "5")
	
	IupSetAttribute(hBox8_1 , "NGAP" , "5")
	
	IupSetAttribute(hBox8_2 , "NGAP" , "5")
	
	IupSetAttribute(hBox8 , "NGAP" , "5")
	
	vBox1 = IupVbox( hBox1 , hBox2 , hBox3 , hBox4 , hBox5 , hBoxtips , hBox6 , hBox7 , hBox8_2, hBox8_1, 0)
	
	vBox2 = IupVbox(hbox13, hbox12 , hbox10, hbox10_1, hbox11, IupFill()  , 0)
	
	'IupSetAttribute(vBox2 , "NGAP" , "5")
	
	'IupSetAttribute(vBox2 , "ALIGNMENT" , "ACENTER")	
	
	hBox9 = IupHbox(vBox1 ,  0)
	
	frame = IupFrame(hBox9)
	
	vBox3 = IupVbox(frame,hBox8,0)
	
	IupSetAttribute(vBox3 , "NGAP" , "5")
	
	hbox0 = IupHbox(vBox3 , vBox2 , 0)
	
	IupSetAttribute(hBox0 , "NGAP" , "40")
	
	Return	hbox0
	
End Function

' create  dialog options "EDIT"
Function optdlg_create_dialog_proc() As iHandle Ptr Export	
	
	If TGlobalVariables->hOptions Then Return 0
	
	Dim As Ihandle Ptr dlg, vboxMain , hBoxBut, tabs ,  btnOK , btnCancel , btnApply
	
	'----------------------- main options --------------------
	
	btnApply = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtnapply"), 0) 
	
	btnOK = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtnok"), 0)
	
	btnCancel = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtncancel"), 0)
	
	IupSetAttribute(btnApply , "MINSIZE" , "90x25")
	
	IupSetCallback(btnApply , "ACTION", Cast(Any Ptr, @option_apply_callback()))
	
	IupSetAttribute(btnOK , "MINSIZE" , "90x25")
	
	IupSetCallback(btnOK , "ACTION", Cast(Any Ptr, @option_ok_callback()))
	
	IupSetAttribute(btnCancel , "MINSIZE" , "90x25")
	
	IupSetCallback(btnCancel , "ACTION", Cast(Any Ptr, @option_cancel_callback()))
	
	hBoxBut = IupHbox(IupFill() , btnApply , btnOK , btnCancel ,IupFill(), 0)
	
	IupSetAttribute(hBoxBut, "GAP", "10")
	
	IupSetAttribute(hBoxBut, "NMARGIN", "x10")
	
	tabs = IupTabs(optdlg_create_tab_general_proc() , optdlg_create_tab_path_proc(), optdlg_create_tab_color_proc() , optdlg_create_tab_another_proc() ,0)
	
	IupSetAttribute(tabs, "EXPAND", "Yes")
	
	IupSetAttributeId(tabs, "TABTITLE",0 ,*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optiongen"))
	
	IupSetAttributeId(tabs, "TABTITLE",1 ,*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionpath"))
	
	IupSetAttributeId(tabs, "TABTITLE",2 ,*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optioncolor"))
	
	IupSetAttributeId(tabs, "TABTITLE",3 ,*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionanother"))	
	
	vboxMain = IupVbox(tabs , hBoxBut , 0)
	
	dlg = IupDialog(vboxMain)
	
	TGlobalVariables->hOptions = dlg
	
	IupSetCallback(dlg, "CLOSE_CB", Cast(Any Ptr , @options_close_action_callback))
	
	IupSetAttribute(dlg, "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"submenuoptions"))
	
	optdlg_get_theme_color_proc(1)
	
	IupSetAttribute(dlg, "DIALOGFRAME", "Yes")
	
	IupSetAttributeHandle(dlg, "DEFAULTENTER", btnok)
	
	IupSetAttributeHandle(dlg, "DEFAULTESC", btncancel)
	
	'IupSetAttribute(dlg, "RASTERSIZE" , "500x")
	
	IupShow(dlg)
	
	IupRefresh(dlg)
	
	Return dlg
	
End Function


'create dlg "TOOL" ; iParam =1 (Build) , iParam =2 (Help) , iParam =3 (tool) ,
Function optdlg_create_tool_dialog_proc(iParam As Byte) As iHandle Ptr Export
	
	If TGlobalVariables->tool_dlg Then Return 0
	
	Dim As Ihandle Ptr lbl1, lbl2 , txt1 , txt2 , btnedit , _
	btnok, btncancel , btninsert , btndelete , btnup , btndown , btnpath, list ,_
	vboxM , vbox1 , vbox2 , vbox3 , hbox , dlg
	
	list = IupList(0)
	
	IupSetAttribute(list , "NAME" , "toollist")
	
	IupSetAttribute(list , "EXPAND" , "YES")
	
	IupSetAttribute(list , "MINSIZE" , "173x165")
	
	IupSetAttribute(list , "MAXSIZE" , "173x165")
	
	IupSetCallback(list, "ACTION", Cast(Any Ptr , @options_tool_action_list_callback))
	
	btnup = IupButton(0,0)
	
	IupSetAttribute(btnup , "IMAGE" , "img_toolup")
	
	IupSetAttribute(btnup , "MINSIZE" , "30x30")
	
	IupSetAttribute(btnup , "MAXSIZE" , "30x30")	
	
	IupSetAttribute(btnup , "NAME" , "tooldup")
	
	IupSetCallback(btnup, "ACTION", Cast(Any Ptr , @options_tool_action_btnup_callback))
	
	btndown = IupButton(0,0)
	
	IupSetAttribute(btndown , "IMAGE" , "img_tooldown")
	
	IupSetAttribute(btndown , "MINSIZE" , "30x30")
	
	IupSetAttribute(btndown , "MAXSIZE" , "30x30")		
	
	IupSetAttribute(btndown , "NAME" , "tooldown")
	
	IupSetCallback(btndown, "ACTION", Cast(Any Ptr , @options_tool_action_btndown_callback))
	
	btnok = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtnok"),0)
	
	IupSetAttribute(btnok , "NAME" , "toolok") 
	
	IupSetAttribute(btnok , "MINSIZE" , "70x")
	
	IupSetCallback(btnok, "ACTION", Cast(Any Ptr , @options_tool_action_btnok_callback))
	
	btncancel = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtncancel"),0)
	
	IupSetAttribute(btncancel , "NAME" , "toolcancel") 	
	
	IupSetAttribute(btncancel , "MINSIZE" , "70x")
	
	IupSetCallback(btncancel, "ACTION", Cast(Any Ptr , @options_tool_action_btncancel_callback))
	
	btnedit = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"finddlgr"),0)
	
	IupSetAttribute(btnedit , "NAME" , "tooledit") 
	
	IupSetAttribute(btnedit , "MINSIZE" , "70x")
	
	IupSetCallback(btnedit, "ACTION", Cast(Any Ptr , @options_tool_action_btnedit_callback))	
	
	btninsert = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtninsert"),0)
	
	IupSetAttribute(btninsert , "NAME" , "toolinsert") 
	
	IupSetAttribute(btninsert , "MINSIZE" , "70x")
	
	IupSetCallback(btninsert, "ACTION", Cast(Any Ptr , @options_tool_action_btninsert_callback))
	
	btndelete = IupButton(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbtndelete"),0)
	
	IupSetAttribute(btndelete , "NAME" , "tooldelete") 
	
	IupSetAttribute(btndelete , "MINSIZE" , "70x")
	
	IupSetCallback(btndelete, "ACTION", Cast(Any Ptr , @options_tool_action_btndelete_callback))
	
	lbl1 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbuilditem"))
	
	lbl2 = IupLabel(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionbuildcommand"))	
	
	txt1 = IupText("")
	
	IupSetAttribute(txt1 , "MINSIZE" , "290x30")
	
	'IupSetAttribute(txt1 , "MAXSIZE" , "275x30")
	
	IupSetAttribute(txt1 , "NAME" , "tooltxt1")
	
	txt2 = IupText("")
	
	IupSetAttribute(txt2 , "MINSIZE" , "260x30")
	
	'IupSetAttribute(txt2 , "MAXSIZE" , "260x30")
	
	IupSetAttribute(txt2 , "NAME" , "tooltxt2")	
	
	btnpath = IupButton("...",0)
	
	IupSetAttribute(btnpath , "NAME" , "toolpath") 
	
	IupSetAttribute(btnpath , "MINSIZE" , "30x30")
	
	'IupSetAttribute(btnpath , "MAXSIZE" , "x30")
	
	If iParam = 1 Then
		
		IupSetAttribute(btnpath , "ACTIVE" , "NO")
		
	Endif
	
	IupSetCallback(btnpath, "ACTION", Cast(Any Ptr , @options_tool_action_btnpath_callback))
	
	vbox1 = IupVbox(list,0)
	
	vbox2 = IupVbox(btnup, IupFill(), btndown,0)
	
	vbox3 = IupVbox(btnok , btncancel , IupFill() , btnedit , IupFill(), btninsert , btndelete , 0)
	
	hBox = IupHbox(vbox1 , vbox2 , vbox3 , 0)
	
	IupSetAttribute(hBox , "GAP" , "3")
	
	vboxM = IupVbox( hBox , lbl1 , txt1,lbl2 , IupHbox(txt2 ,btnpath,0) ,0)
	
	IupSetAttribute(vboxM, "NMARGIN", "2x2")
	
	dlg = IupDialog(vboxM)
	
	TGlobalVariables->tool_dlg = dlg
	
	IupSetCallback(dlg, "CLOSE_CB", Cast(Any Ptr , @options_close_tool_callback))
	
	Dim As Zstring*10 szOpt
	
	Select Case iParam
			
		Case 1
			
			IupSetAttribute(dlg, "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitletoolbuild"))
			
			szOpt = "BUILD"
			
		Case 2
			
			IupSetAttribute(dlg, "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitletoolhelp"))
			
			szOpt = "HELPF"
			
		Case 3	
			
			IupSetAttribute(dlg, "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitletool"))
			
			szOpt = "TOOL"
			
	End Select	
	
	TGlobalVariables->t_list = New Tlist
	
	if TGlobalVariables->t_list = 0 then
		
		winout_error_memory_proc()
		
		return 0
		
	EndIf
	
	For i As Long  = 1 To 100
		
		Dim As String sTempN = *IupConfigGetVariableStr(TGlobalVariables->hConfig, szOpt , "n" & i)
		
		Dim As String sTempC = *IupConfigGetVariableStr(TGlobalVariables->hConfig, szOpt , "c" & i)
		
		If sTempN <> "" Then
			
			Dim As Zstring Ptr pszListStringName = Callocate(Len(sTempN)+1)
			
			Dim As Zstring Ptr pszListStringCommand = Callocate(Len(sTempC)+1)
			
			if pszListStringName = 0 orelse pszListStringCommand = 0 then
				
				if pszListStringName then deallocate(pszListStringName)
				
				if pszListStringCommand then deallocate(pszListStringCommand)
				
				winout_error_memory_proc()
				
				return 0
				
			EndIf
			
			*pszListStringName = sTempN
			
			*pszListStringCommand = sTempC	
			
			TGlobalVariables->t_list->insert( i-1 , pszListStringCommand , pszListStringName)	
			
			IupSetAttribute(list , Str(i) , *pszListStringName )
			
		Else	
			
			Exit For
			
		Endif
		
	Next		
	
	IupSetAttribute(dlg, "DIALOGFRAME", "Yes")
	
	IupSetAttributeHandle(dlg, "DEFAULTENTER", btnok)
	
	IupSetAttributeHandle(dlg, "DEFAULTESC", btncancel)
	
	'IupSetAttribute(dlg, "RASTERSIZE" , "285x")
	
	IupShow(dlg)
	
	'IupRefresh(dlg)
	
	Return dlg	
	
End Function

' Processing Button "INSERT" in the dialog TOOL
Sub optdlg_tool_btninsert_proc() Export
	
	Dim As Ihandle Ptr txtN , txtC , list 
	
	txtN = IupGetDialogChild(TGlobalVariables->tool_dlg, "tooltxt1")
	
	txtC = IupGetDialogChild(TGlobalVariables->tool_dlg, "tooltxt2")
	
	list = IupGetDialogChild(TGlobalVariables->tool_dlg, "toollist")
	
	Dim As Zstring Ptr pszTempN = IupGetAttribute (txtN , "VALUE")
	
	Dim As Zstring Ptr pszTempC = IupGetAttribute (txtC , "VALUE")
	
	If Len(*pszTempN) = 0 Orelse Len(*pszTempC) = 0 Then

		msdlg_dialog_message_yes_no_proc(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstextbuildempty"),_
		1 , TGlobalVariables->tool_dlg)

		Exit Sub	
		
	Endif
	
	Dim As Long iInsertPos =  Val(*IupGetAttribute (list , "VALUE"))
	
	Dim As Zstring Ptr pszListStringName = Callocate(Len(*pszTempN)+1)
	
	Dim As Zstring Ptr pszListStringCommand = Callocate(Len(*pszTempC)+1)
	
	if pszListStringName = 0 orelse pszListStringCommand = 0 then
		
		if pszListStringName then deallocate(pszListStringName)
		
		if pszListStringCommand then deallocate(pszListStringCommand)
		
		winout_error_memory_proc()
		
		exit sub
		
	EndIf
	
	*pszListStringName = *pszTempN
	
	*pszListStringCommand = *pszTempC
	
	TGlobalVariables->t_list->insert(iInsertPos ,pszListStringCommand , pszListStringName) 
	
	IupSetAttribute (list , "INSERTITEM" & Str(iInsertPos+1) , pszListStringName )
	
	IupSetAttribute (list , "VALUE" , Str(iInsertPos+1))
	
End Sub

' Processing Button "Edit" in the dialog TOOL
Sub optdlg_tool_btnedit_proc() Export
	
	Dim As Ihandle Ptr txtN , txtC , list 
	
	txtN = IupGetDialogChild(TGlobalVariables->tool_dlg, "tooltxt1")
	
	txtC = IupGetDialogChild(TGlobalVariables->tool_dlg, "tooltxt2")
	
	list = IupGetDialogChild(TGlobalVariables->tool_dlg, "toollist")
	
	Dim As Zstring Ptr pszTempN = IupGetAttribute (txtN , "VALUE")
	
	Dim As Zstring Ptr pszTempC = IupGetAttribute (txtC , "VALUE")
	
	If Len(*pszTempN) = 0 Orelse Len(*pszTempC) = 0 Then
		
		msdlg_dialog_message_yes_no_proc(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstextbuildempty"),_
		1 , TGlobalVariables->tool_dlg)
		
		Exit Sub	
		
	Endif
	
	Dim As Long iEditPos =  Val(*IupGetAttribute (list , "VALUE")) - 1
	
	If iEditPos < 0 Then Exit Sub
	
	Dim As Zstring Ptr pszListStringName = Callocate(Len(*pszTempN)+1)
	
	Dim As Zstring Ptr pszListStringCommand = Callocate(Len(*pszTempC)+1)
	
	if pszListStringName = 0 orelse pszListStringCommand = 0 then
		
		if pszListStringName then deallocate(pszListStringName)
		
		if pszListStringCommand then deallocate(pszListStringCommand)
		
		winout_error_memory_proc()
		
		exit sub
		
	EndIf
	
	*pszListStringName = *pszTempN
	
	*pszListStringCommand = *pszTempC
	
	Dim As Tlistnode Ptr pTemp = TGlobalVariables->t_list->pFirst
	
	Dim As Long iListIndex
	
	While pTemp
		
		If iEditPos = iListIndex Then
			
			If pTemp->pszCommand Then
				
				Deallocate(pTemp->pszCommand)
				
			Endif
			
			If pTemp->pszName Then
				
				Deallocate(pTemp->pszName)
				
			Endif
			
			pTemp->pszCommand = pszListStringCommand
			
			pTemp->pszName = pszListStringName
			
			IupSetAttribute(list , Str(iEditPos+1) , *pszListStringName )
			
			IupSetAttribute(list , "VALUE" , Str(iEditPos+1))
			
			Exit While
			
		Endif
		
		iListIndex+=1
		
		pTemp = pTemp->pNext
		
	Wend
	
End Sub

' Processing Button "DELETE" in the dialog TOOL
Sub optdlg_tool_btndelete_proc() Export
	
	Dim As Ihandle Ptr list 
	
	list = IupGetDialogChild(TGlobalVariables->tool_dlg, "toollist")	
	
	Dim As Long iDelPos =  Val(*IupGetAttribute (list , "VALUE"))
	
	If iDelPos = 0 Then Exit Sub
	
	TGlobalVariables->t_list->del(iDelPos - 1) 
	
	IupSetAttribute(list , "REMOVEITEM" , "ALL")
	
	Dim As Tlistnode Ptr TempNode = TGlobalVariables->t_list->pFirst
	
	Dim As Long iIndex = 1
	
	While TempNode
		
		IupSetAttribute(list , Str(iIndex) ,TempNode->pszName )
		
		TempNode = TempNode->pNext
		
		iIndex +=1
		
	Wend
	
	If iDelPos > 1 Then
		
		IupSetAttribute (list , "VALUE" , Str(iDelPos - 1))
		
		optdlg_tool_list_action_proc(iDelPos - 1)
		
	Elseif iDelPos = 1 Andalso Val(*IupGetAttribute (list,"COUNT")) > 0 Then
		
		IupSetAttribute (list , "VALUE" , "1")
		
		optdlg_tool_list_action_proc(1)
		
	Endif
	
End Sub

' Processing Button "CANCEL" in the dialog TOOL
Sub optdlg_tool_btncancel_proc() Export
	
	TGlobalVariables->t_list->delAll()
	
	if TGlobalVariables->t_list then Delete TGlobalVariables->t_list
	
	TGlobalVariables->t_list = 0
	
End Sub

' Processing Button "OK" in the dialog TOOL
Sub optdlg_tool_btnok_proc() Export
	
	Dim As Tlistnode Ptr tl = TGlobalVariables->t_list->pFirst
	
	Dim As Ihandle Ptr list_combo = IupGetDialogChild(TGlobalVariables->toolbar, "comboselectbuild")
	
	Dim As Long iIndex = 1
	
	Dim As Zstring*10 zsOpt
	
	If *IupGetAttribute(TGlobalVariables->tool_dlg, "TITLE") = *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitletoolbuild") Then
		
		zsOpt = "BUILD"
		
	Elseif *IupGetAttribute(TGlobalVariables->tool_dlg, "TITLE") = *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitletoolhelp") Then	
		
		zsOpt = "HELPF"
		
	Else	
		
		zsOpt = "TOOL"
		
	Endif
	
	If zsOpt = "BUILD" Then
		
		IupSetAttribute(list_combo , "REMOVEITEM" , "ALL")
		
	Elseif zsOpt = "HELPF" Then	
		
		While 1
			
			Dim As Ihandle Ptr hTemp = IupGetchild(IupGetParent(TGlobalVariables->hItemAbout),1)
			
			If hTemp <> TGlobalVariables->hItemAbout Then
				
				IupDestroy(hTemp)
				
			Else
				
				Exit While
				
			Endif
			
		Wend		
		
	Elseif zsOpt = "TOOL" Then	
		
		While 1
			
			Dim As Ihandle Ptr hTemp = IupGetchild(TGlobalVariables->hItemTools,0)
			
			If hTemp Then
				
				IupDestroy(hTemp)
				
			Else
				
				Exit While
				
			Endif
			
		Wend
		
	Endif
	
	While tl
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig , zsOpt , "n" & iIndex , *(tl->pszName) )
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig , zsOpt , "c" & iIndex , *(tl->pszCommand) )
		
		If zsOpt = "BUILD" Then
			
			IupSetAttribute(list_combo , Str(iIndex) , tl->pszName)
			
		Elseif zsOpt = "HELPF" Then
			
			If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"HELPF", "n" & iIndex) <> "" Then
				
				Dim As Ihandle Ptr hTempMenu = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfig,"HELPF", "n" & iIndex ), NULL)
				
				IupInsert(IupGetParent(TGlobalVariables->hItemAbout), TGlobalVariables->hItemAbout , hTempMenu)
				
				IupSetCallback(hTempMenu, "ACTION", Cast(Any Ptr , @item_helps_custom_callback))
				
				IupMap(hTempMenu)
				
			Endif				
			
		Elseif zsOpt = "TOOL" Then	
			
			If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"TOOL", "n" & iIndex) <> "" Then
				
				Dim As Ihandle Ptr hTempMenu = IupItem(*IupConfigGetVariableStr(TGlobalVariables->hConfig,"TOOL", "n" & iIndex ), NULL)
				
				IupAppend(TGlobalVariables->hItemTools , hTempMenu)
				
				IupSetCallback(hTempMenu, "ACTION", Cast(Any Ptr , @item_tools_custom_callback))
				
				IupMap(hTempMenu)
				
			Endif		
			
		Endif			
		
		tl = tl->pNext
		
		iIndex+=1
		
	Wend
	
	If zsOpt = "BUILD" Then
		
		IupSetAttribute(list_combo , "VALUE" , "1")
		
	Endif
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig , zsOpt , "n" & iIndex , "" )
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig , zsOpt , "c" & iIndex , "" )		
	
	TGlobalVariables->t_list->delAll()
	
	if TGlobalVariables->t_list then Delete TGlobalVariables->t_list
	
	TGlobalVariables->t_list = 0
	
	If zsOpt = "HELPF" Then
		
		Threadcreate(@hlp_enum_keywords_helps())
		
	Endif
	
End Sub

' Processing Button "UP" in the dialog TOOL
Sub optdlg_tool_btnup_proc() Export
	
	Dim As Ihandle Ptr list 
	
	list = IupGetDialogChild(TGlobalVariables->tool_dlg, "toollist")	
	
	Dim As Long iPos =  Val(*IupGetAttribute (list , "VALUE"))
	
	If iPos = 0 Orelse iPos = 1 Then Exit Sub	
	
	TGlobalVariables->t_list->move(iPos - 1 , iPos - 2 ) 
	
	IupSetAttribute(list , "REMOVEITEM" , "ALL")	
	
	Dim As Tlistnode Ptr TempNode = TGlobalVariables->t_list->pFirst
	
	Dim As Long iIndex = 1
	
	While TempNode
		
		IupSetAttribute(list , Str(iIndex) ,TempNode->pszName )
		
		TempNode = TempNode->pNext
		
		iIndex +=1
		
	Wend
	
	IupSetAttribute (list , "VALUE" , Str(iPos - 1))
	
End Sub

' Processing Button "DOWN" in the dialog TOOL
Sub optdlg_tool_btndown_proc() Export
	
	Dim As Ihandle Ptr list 
	
	list = IupGetDialogChild(TGlobalVariables->tool_dlg, "toollist")	
	
	Dim As Long iPos =  Val(*IupGetAttribute (list , "VALUE"))
	
	If iPos = 0 Orelse iPos = Val(*IupGetAttribute (list , "COUNT")) Then Exit Sub	
	
	TGlobalVariables->t_list->move(iPos - 1 , iPos ) 
	
	IupSetAttribute(list , "REMOVEITEM" , "ALL")	
	
	Dim As Tlistnode Ptr TempNode = TGlobalVariables->t_list->pFirst
	
	Dim As Long iIndex = 1
	
	While TempNode
		
		IupSetAttribute(list , Str(iIndex) ,TempNode->pszName )
		
		TempNode = TempNode->pNext
		
		iIndex +=1
		
	Wend
	
	IupSetAttribute (list , "VALUE" , Str(iPos+1))
	
End Sub

' Processing Click Mouse on "LIST" in the dialog "TOOL"
Sub optdlg_tool_list_action_proc(iItem As Integer) Export
	
	Dim As Tlistnode Ptr TempNode = TGlobalVariables->t_list->getNode(iItem - 1)
	
	Dim As Ihandle Ptr txtN , txtC 
	
	txtN = IupGetDialogChild(TGlobalVariables->tool_dlg, "tooltxt1")
	
	txtC = IupGetDialogChild(TGlobalVariables->tool_dlg, "tooltxt2")	
	
	IupSetAttribute(txtN , "VALUE" , TempNode->pszName)
	
	IupSetAttribute(txtC , "VALUE" , TempNode->pszCommand)
	
End Sub

' Processing Button "Cancel" in the options EDIT
Sub optdlg_reset_proc() Export
	
	Dim As Integer ic = IupGetChildCount(TGlobalVariables->tabs)
	
	winout_set_visual_params_build_info_proc(0)
	
	sb_set_visual_params_statusbar_proc(0)	
	
	winside_set_visual_params_info_proc(0)
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combolang") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Lang", "current"))
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends") = "WIN" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiowin") , "VALUE" , "ON")
		
	Else	
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiolin") , "VALUE" , "ON")
		
	Endif	
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "indent") = "TAB" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiotab"), "VALUE" , "ON")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiospace"), "VALUE" , "ON")
		
	Endif		
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updownindent") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "indentsize"))	
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","wrap")  = "WORD" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkwrap") , "VALUE", "ON")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkwrap") , "VALUE", "OFF")
		
	Endif	
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","whitespace")  = "VISIBLEALWAYS" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkwhitespace") , "VALUE" , "ON")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkwhitespace") , "VALUE" , "OFF")
		
	Endif		
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","indentationguides")  = "REAL" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkspacesimv") , "VALUE" , "ON")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkspacesimv") , "VALUE" , "OFF")
		
	Endif	
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","viewnumbers")  = "YES" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checknumbers") , "VALUE" , "ON")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checknumbers") , "VALUE" , "OFF")
		
	Endif	
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","autocomplect")  = "YES" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkautocomplect") , "VALUE" , "ON")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkautocomplect") , "VALUE" , "OFF")
		
	Endif
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","plusrows")  = "YES" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkplusrows") , "VALUE" , "ON")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkplusrows") , "VALUE" , "OFF")
		
	Endif
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","endifspace")  = "YES" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkendifspace") , "VALUE" , "ON")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkendifspace") , "VALUE" , "OFF")
		
	Endif	
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","checkcom")  = "YES" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkcom") , "VALUE" , "ON")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkcom") , "VALUE" , "OFF")
		
	Endif		
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","folding")  = "YES" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkfolding") , "VALUE" , "ON")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkfolding") , "VALUE" , "OFF")
		
	Endif
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","savecase")  = "YES" Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checksavecase") , "VALUE" , "ON")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checksavecase") , "VALUE" , "OFF")
		
	Endif			
	
	
	Select Case *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "case")
			
		Case "up"
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radioupcase") , "VALUE" , "ON")
			
		Case "down"
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiodowncase") , "VALUE" , "ON")
			
		Case "camel"   
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiocamelcase") , "VALUE" , "ON")
			
		Case Else   
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiomixedcase") , "VALUE" , "ON")
			
	End Select	
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtedit")  , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","editor"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtwinout") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","winout"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtstatus") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","status"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtwinside") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","winside"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtannot") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","annot"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxttabs") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","tabs"))	
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "REMOVEITEM" , "ALL")
	
	For i As Long = 1 To 100
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "n") <> "" Then
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "n"))
			
			IupSetStrAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "b" & Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "c"))
			
			IupSetStrAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "f" & Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "f"))		
			
			IupSetStrAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "ba" & Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "a"))
			
			IupSetStrAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "bold" & Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "bold"))
			
			IupSetStrAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "italic" & Str(i) , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", i & "italic"))					
			
		Else
			
			Exit For
			
		Endif
		
	Next	
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", "0"))
	
	Dim As Zstring*4 szNull = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", "0")
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updownalpha") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Theme", szNull & "a"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtcomppath") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathcompilier"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtincludepath") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathinclude"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtdebugpath") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathdebugger"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtterminal") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathterminal"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtbrowser") , "VALUE" , *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathbrowser"))
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtnewtheme") , "VALUE" , "")
	
	If ic < 2 Then 
		
		IupHide(TGlobalVariables->hOptions)
		
		Exit Sub
		
	Endif
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	mtxt_set_attribute_multitext_proc(TGlobalVariables->tTabsOptions(idTabs).multitext , 0)
	
	tbs_setfont_tab_proc(0)
	
End Sub

' ' Processing Button "OK" in the options EDIT
Sub optdlg_ok_proc() Export
	
	
	Dim As Integer ic = IupGetChildCount(TGlobalVariables->tabs)
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Lang", "current") <> *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combolang") , "VALUE") Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Lang", "current" , *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combolang") , "VALUE"))
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstextlangreboot"))
		
	Endif
	
	dim as string sTempWinEndsIsOn = *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends")
	
	DIM AS lONG iTempWinEndsIsOn
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiowin") , "VALUE") =  "ON" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends" , "WIN")
		
	Else
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends" , "LIN")
		
	Endif
	
	if sTempWinEndsIsOn <> *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends") then
		
		iTempWinEndsIsOn = 1
		
	EndIf
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiotab"), "VALUE") =  "ON" Then 
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "Editor" , "indent" , "TAB")
		
	Else
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "Editor" , "indent" , "SPACE")
		
	Endif
	
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig, "Editor" , "indentsize" , *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updownindent") , "VALUE"))
	
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkwrap") , "VALUE") =  "ON" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","wrap" , "WORD")
		
	Else
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","wrap" , "NONE")
		
	Endif
	
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkwhitespace") , "VALUE") =  "ON" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor", "whitespace" , "VISIBLEALWAYS")
		
	Else
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor", "whitespace" , "INVISIBLE")
		
	Endif
	
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkspacesimv") , "VALUE") = "ON" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor" , "indentationguides" ,  "REAL")
		
	Else
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","indentationguides" ,  "NONE")
		
	Endif
	
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checknumbers") , "VALUE") = "ON" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","viewnumbers" , "YES")
		
	Else	
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","viewnumbers" , "NO")
		
	Endif
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkfolding") , "VALUE") = "ON" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","folding" , "YES")
		
	Else	
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","folding" , "NO")
		
	Endif
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checksavecase") , "VALUE") = "ON" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","savecase" , "YES")
		
	Else	
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","savecase" , "NO")
		
	Endif		
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkautocomplect") , "VALUE") = "ON" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","autocomplect" , "YES")
		
	Else	
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","autocomplect" , "NO")
		
	Endif
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkplusrows") , "VALUE") = "ON" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","plusrows" , "YES")
		
	Else	
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","plusrows" , "NO")
		
	Endif
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkendifspace") , "VALUE") = "ON" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","endifspace" , "YES")
		
	Else	
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","endifspace" , "NO")
		
	Endif
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "checkcom") , "VALUE") = "ON" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","checkcom" , "YES")
		
	Else	
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Editor","checkcom" , "NO")
		
	Endif		
	
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig,"Parser","isparser" , *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_parser") , "VALUE"))
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig,"Parser","isautokeyword" , *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_autokeyword") , "VALUE"))
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig, "Parser","isautoas" , *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_autoas") , "VALUE"))
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig, "Parser","isautoft" , *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_autoft") , "VALUE"))
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig, "Parser","istips" , *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_tips") , "VALUE"))
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig, "Parser","isdelaytips" , *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ch_delaytips") , "VALUE"))
	
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combolexer") , "VALUE") = "1" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "Lexer","lex" , "freebasic")
		
	Else
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "Lexer","lex" , "vb")
		
	Endif
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig,"Parser" , "lenght", IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updownlenghtword") , "VALUE" ))
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig,"Parser" , "parserms", IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updownprsms") , "VALUE" ))
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig,"Parser" , "winsidems", IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updownwinms") , "VALUE" ))
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig,"Parser" , "tipsms", IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updowntipsms") , "VALUE" ))
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiotips1") , "VALUE") = "ON" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "Parser" , "tips1" , "1")
		
	Else
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig, "Parser" , "tips1" , "2")
		
	Endif
	
	Select Case "ON"
			
		Case *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radioupcase") , "VALUE")
			
			IupConfigSetVariableStr(TGlobalVariables->hConfig, "Editor" , "case" , "up")
			
		Case *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiodowncase") , "VALUE")
			
			IupConfigSetVariableStr(TGlobalVariables->hConfig, "Editor" , "case" , "down")
			
		Case *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "radiocamelcase") , "VALUE")
			
			IupConfigSetVariableStr(TGlobalVariables->hConfig, "Editor" , "case" , "camel")
			
		Case Else   
			
			IupConfigSetVariableStr(TGlobalVariables->hConfig, "Editor" , "case" , "mixed")
			
	End Select	
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtedit")  , "VALUE") <> "" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Fonts","editor", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtedit")  , "VALUE"))
		
	Endif
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtwinout")  , "VALUE") <> "" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Fonts","winout", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtwinout")  , "VALUE"))
		
	Endif
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtstatus")  , "VALUE") <> "" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Fonts","status", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtstatus")  , "VALUE"))
		
	Endif
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtwinside")  , "VALUE") <> "" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Fonts","winside", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtwinside")  , "VALUE"))
		
	Endif
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtannot")  , "VALUE") <> "" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Fonts","annot", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxtannot")  , "VALUE"))
		
	Endif
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxttabs")  , "VALUE") <> "" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Fonts","tabs", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "ftxttabs")  , "VALUE"))
		
	Endif	
	
	
	For i As Long = 1 To *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "COUNT")
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme", i & "n", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , Str(i)))
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme", i & "c", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "b" & Str(i)))
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme", i & "f", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "f" & Str(i)))
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme", i & "a", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "ba" & Str(i)))	
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme", i & "bold", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "bold" & Str(i)))
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme", i & "italic", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "italic" & Str(i)))
		
	Next
	
	IupConfigSetVariableStr(TGlobalVariables->hConfig,"Theme", "0" , *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "VALUE"))
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtcomppath") , "VALUE") <> "" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Path","pathcompilier" , *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtcomppath") , "VALUE"))
		
	Endif
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtincludepath") , "VALUE") <> "" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Path","pathinclude" , *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtincludepath") , "VALUE"))
		
	Endif	
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtdebugpath") , "VALUE") <> "" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Path","pathdebugger", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtdebugpath") , "VALUE"))
		
	Endif
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtterminal") , "VALUE") <> "" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Path","pathterminal", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtterminal") , "VALUE"))
		
	Endif
	
	If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtbrowser") , "VALUE") <> "" Then
		
		IupConfigSetVariableStr(TGlobalVariables->hConfig,"Path","pathbrowser", *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtbrowser") , "VALUE"))
		
	Endif		
	
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "txtnewtheme") , "VALUE" , "")
	
	If ic < 2 Then 
		
		IupHide(TGlobalVariables->hOptions)
		
		Exit Sub
		
	Endif
	
	For i As Long  = 1 To ic - 1
		
		mtxt_set_attribute_multitext_proc(TGlobalVariables->tTabsOptions(i).multitext , 0)
		
		Dim As String sName = *IupGetAttribute(TGlobalVariables->tTabsOptions(i).multitext, "FILENAMETAB")
		
		mtxt_set_attribute_for_another_files(TGlobalVariables->tTabsOptions(i).multitext , sName)
		
		if iTempWinEndsIsOn then
			
			#ifdef __fb_win32__
				IupSetAttribute(TGlobalVariables->tabs,"FORECOLOR" , TGlobalVariables->szColorbtn(41))
				IupSetAttribute(TGlobalVariables->tabs,"TABFORECOLOR" & i , TGlobalVariables->szColorbtn(41))
			#else
				#ifdef __fb_64bit__
					IupSetAttribute(TGlobalVariables->tabs,"FORECOLOR" , TGlobalVariables->szColorbtn(41))
					IupSetAttribute(TGlobalVariables->tabs,"TABFORECOLOR" & i , TGlobalVariables->szColorbtn(41))
				#endif
			#endif
			
		EndIf
		
	Next
	
	tbs_setfont_tab_proc(0)
	
	IupSetStrAttribute(TGlobalVariables->statusbar, "OPTIONS_APPLY_UPDATE" , "1")
	
End Sub

' Processing Button "Apply" in the options EDIT
Sub optdlg_apply_proc() Export
	
	Dim As Integer ic = IupGetChildCount(TGlobalVariables->tabs)
	
	Dim As String szTheme = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme") , "VALUE")
	
	Dim As Zstring Ptr pszColAlpha = IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "combotheme"),"ba" & szTheme)
	
	*pszColAlpha = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions, "updownalpha"), "VALUE")
	
	winout_set_visual_params_build_info_proc(1)
	
	sb_set_visual_params_statusbar_proc(1)	
	
	winside_set_visual_params_info_proc(1)
	
	If ic < 2 Then Exit Sub
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	mtxt_set_attribute_multitext_proc(TGlobalVariables->tTabsOptions(idTabs).multitext , 1)
	
	tbs_setfont_tab_proc(1)
	
	IupSetStrAttribute(TGlobalVariables->statusbar, "OPTIONS_APPLY_UPDATE" , "1")
	
End Sub

