#include "../tlist.bi"
#include "../declarations.bi"

Dim Shared As T_GlobalVariables Ptr TGlobalVariablesDll

Dim Shared As iHandle Ptr hDLG

#ifdef __fb_win32__
	
	Dim pDll As  Any Ptr
	
	#undef enc_encode_buffer_proc
	
	#undef tbspc_tab_to_spaces_proc
	
	Dim Shared tbspc_tab_to_spaces_proc As Sub()
	
	Dim Shared enc_encode_buffer_proc As Function (pszEncToStack As Zstring Ptr , pszEncFromStack As Zstring Ptr , pbBuf As Byte Ptr, iSizeBuf As Integer , Byref iSizeReturnBytes As Integer , multitext As Ihandle Ptr = 0 , iProjectFlag As Long = 0) As Byte Ptr
	
	pDll = Dylibload("../fbnp.exe")
	
	If pDll <> 0 Then
		
		enc_encode_buffer_proc = Dylibsymbol(pDll, "ENC_ENCODE_BUFFER_PROC")
		
		tbspc_tab_to_spaces_proc = Dylibsymbol(pDll, "TBSPC_TAB_TO_SPACES_PROC")
		
	Endif
	
#endif

Sub paste_text_proc (pszParamText As Zstring Ptr , iColumn As Long = 0, iFlag As Long = 0, iStartLine As Long = 1 , iEndLine As Long = 1)
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariablesDll->tabs, "VALUEPOS"))
	
	If iStartLine - 1 >= 0 Then iStartLine -= 1
	
	If iEndLine - 1 >= 0 Then iEndLine -= 1
	
	Dim As Integer iLineCount
	
	iLineCount = IupGetInt(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "LINECOUNT")
	
	If iStartLine > iLineCount-1 Then
		
		iStartLine = iLineCount-1
		
	Endif
	
	If iStartLine > iEndLine Then
		
		iEndLine = iStartLine
		
	Endif
	
	If (iEndLine - iStartLine) >= iLineCount - 1 Then
		
		iEndLine = iLineCount - 1
		
	Endif
	
	Dim As Integer iRetBytes2
	
	Dim As Integer iLenSz2 = Len(*pszParamText)
	
	#ifdef __fb_win32__
		
		Dim As Wstring Ptr pwsTextInsert = Cast(Wstring Ptr,enc_encode_buffer_proc("UTF-16LE","UTF-8",Cast(Byte Ptr,pszParamText),iLenSz2,iRetBytes2))
		
	#else
		
		Dim As Wstring Ptr pwsTextInsert = Cast(Wstring Ptr,enc_encode_buffer_proc("UTF-32LE","UTF-8",Cast(Byte Ptr,pszParamText),iLenSz2,iRetBytes2))	
		
	#endif
	
	if pwsTextInsert = 0 then
		
		exit sub
		
	EndIf
	
	IupSetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	For i As Long = iStartLine To iEndLine
		
		Dim As Zstring Ptr pszText = IupGetAttributeId(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "LINE", i)
		
		Dim As Integer iRetBytes
		
		Dim As Integer iLenSz = Len(*pszText)
		
		Dim As Long iRealLen
		
		#ifdef __fb_win32__
			
			Dim As Wstring Ptr pwsText = Cast(Wstring Ptr,enc_encode_buffer_proc("UTF-16LE","UTF-8",Cast(Byte Ptr,pszText),iLenSz,iRetBytes))
			
		#else
			
			Dim As Wstring Ptr pwsText = Cast(Wstring Ptr,enc_encode_buffer_proc("UTF-32LE","UTF-8",Cast(Byte Ptr,pszText),iLenSz,iRetBytes))
			
		#endif
		
		if pwsText then
			
			If Len(*pwsText) = 0 Then
				
				iRealLen = 0
				
			Elseif Len(*pwsText) = 1 Then
				
				If *pwsText = Wchr(10) Then
					
					iRealLen = 0
					
				Else
					
					iRealLen = 1
					
				Endif
				
			Elseif Len(*pwsText) = 2 Then
				
				If Right(*pwsText , 2) = Wchr(13,10) Then
					
					iRealLen = 0
					
				Elseif Right(*pwsText , 1) = Wchr(10) Then	
					
					iRealLen = 1
					
				Else
					
					iRealLen = 2
					
				Endif
				
			Elseif Len(*pwsText) > 2 Then
				
				If Right(*pwsText , 2) = Wchr(13,10) Then
					
					iRealLen = Len(*pwsText) - 2
					
				Elseif Right(*pwsText , 1) = Wchr(10) Then	
					
					iRealLen = Len(*pwsText) - 1
					
				Else
					
					iRealLen = Len(*pwsText)
					
				Endif				
				
			Endif
			
		endif
		
		If iFlag = 1 Andalso iRealLen < iColumn Then
			
			If *IupGetAttribute(IupGetDialogChild(hDlg, "PLUG_BPCHECKADDSPACE"), "VALUE") =  "ON" Then 
				
				If pwsText Then
					
					Dim As Wstring Ptr pTemp = Callocate((Len(*pwsText)+2)*Sizeof(Wstring))
					
					if pTemp = 0 then
						
						Deallocate(pwsText)
						
						deallocate(pwsTextInsert)
						
						exit sub
						
					EndIf
					
					*pTemp = *pwsText
					
					Deallocate(pwsText)	
					
					pwsText = Callocate((iColumn+4)*Sizeof(Wstring))
					
					if pwsText = 0 then
						
						deallocate(pwsTextInsert)
						
						exit sub
						
					EndIf
					
					If Right(*pTemp,2) = Chr(13) & Chr(10) Then
						
						*pwsText = Mid(*pTemp , 1 , Len(*pTemp)-2) & Wspace(iColumn - iRealLen) & Chr(13) & Chr(10)
						
					Elseif Right(*pTemp,1) = Chr(10) Then
						
						*pwsText = Mid(*pTemp , 1 , Len(*pTemp)-1) & Wspace(iColumn - iRealLen) & Chr(10)
						
					Else
						
						*pwsText = *pTemp & Wspace(iColumn - iRealLen) 
						
					Endif 
					
					Deallocate(pTemp)
					
				Else
					
					pwsText = Callocate((iColumn+4)*Sizeof(Wstring))
					
					if pwsText = 0 then
						
						deallocate(pwsTextInsert)
						
						exit sub
						
					EndIf
					
					*pwsText = Wspace(iColumn)		
					
				Endif
				
				iRealLen = Len(Trim(*pwsText, Any Wchr(13) & Wchr(10)))
				
				iRetBytes = Len(*pwsText)
				
			Else	
				
				If pwsText Then Deallocate(pwsText)
				
				Continue For				
				
			Endif	
			
		Endif 
		
		Dim As Wstring Ptr pwsTempText = Callocate(iRetBytes*Sizeof(Wstring)+iRetBytes2*Sizeof(Wstring)+2)
		
		if pwsTempText = 0 then
			
			if pwsText then Deallocate(pwsText)
			
			if pwsTextInsert then deallocate(pwsTextInsert)
			
			exit sub
			
		EndIf
		
		Dim As Wstring*3 wineol = Wchr(13,10)
		
		Dim As Wstring*2 lineol = Wchr(10)
		
		If *pwsText = wineol Orelse *pwsText = lineol Then 
			
			*pwsTempText = *pwsTextInsert & *pwsText
			
		Else
			
			If iColumn < iRealLen Then		
				
				*pwsTempText = Left(*pwsText , iColumn) & *pwsTextInsert & Mid(*pwsText , iColumn+1)
				
			Else
				
				If Right(*pwsText , 2) = Wchr(13,10) Then
					
					*pwsTempText = Left(*pwsText , Len(*pwsText)-2) & *pwsTextInsert & Wchr(13,10)
					
				Elseif Right(*pwsText , 1) = Wchr(10) Then
					
					*pwsTempText = Left(*pwsText , Len(*pwsText)-1) & *pwsTextInsert & Wchr(10)
					
				Else
					
					*pwsTempText = *pwsText & *pwsTextInsert
					
				Endif				
				
			Endif
			
		Endif
		
		Dim As Integer iPos 
		
		IupTextConvertLinColToPos(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, i, 0, Cast(Any Ptr, @iPos))		
		
		IupSetStrf(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "DELETERANGE", !"%d,%d", iPos, iLenSz)	
		
		#ifdef __fb_win32__
			
			pszText = Cast(Zstring Ptr,enc_encode_buffer_proc("UTF-8","UTF-16LE",Cast(Byte Ptr,pwsTempText),Len(*pwsTempText)*Sizeof(Wstring),iRetBytes))
			
		#else
			
			pszText = Cast(Zstring Ptr,enc_encode_buffer_proc("UTF-8","UTF-32LE",Cast(Byte Ptr,pwsTempText),Len(*pwsTempText)*Sizeof(Wstring),iRetBytes))
			
		#endif		
		
		IupSetAttributeId(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "INSERT", iPos, pszText)
		
		If pszText Then Deallocate(pszText)
		
		If pwsText Then Deallocate(pwsText)
		
		If pwsTempText Then Deallocate(pwsTempText)		
		
	Next
	
	If pwsTextInsert Then Deallocate(pwsTextInsert)
	
	IupSetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
	IupSetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "ISCHANGES", "YES")
	
End Sub

Function plug_dlg_bp_exit_callback Cdecl(ih As Ihandle Ptr ) As Integer
	
	IupDestroy(ih)
	
	Return IUP_IGNORE
	
End Function

Function k_any_esc_dialog_callback Cdecl ( ih As Ihandle Ptr, c As Integer) As Integer
	
	if c = K_ESC then
		
		IupDestroy(ih)
		
	endif
	
	Return IUP_DEFAULT
	
End Function

Function plug_bp_check_column_callback Cdecl(ih As Ihandle Ptr ) As Integer
	
	If *IupGetAttribute(ih, "VALUE") =  "ON" Then
		
		IupSetAttribute(IupGetDialogChild(hDlg, "PLUG_BPCHECKADDSPACE"), "ACTIVE", "YES")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(hDlg, "PLUG_BPCHECKADDSPACE"), "ACTIVE", "NO")
		
	Endif
	
	Return IUP_IGNORE
	
End Function

Function plug_bp_ok_callback Cdecl(ih As Ihandle Ptr) As Integer
	
	tbspc_tab_to_spaces_proc()
	
	Dim As ihandle Ptr hTxt , hColumn , hCheck , hStartRow , hEndRow
	
	hTxt = IupGetDialogChild(hDlg, "PLUG_BPTXT")
	
	hColumn = IupGetDialogChild(hDlg, "PLUG_BPUPDOWNCOLUMN")
	
	hCheck = IupGetDialogChild(hDlg, "PLUG_BPCHECK")
	
	hStartRow = IupGetDialogChild(hDlg, "PLUG_BPUPDOWNFSTR")
	
	hEndRow = IupGetDialogChild(hDlg, "PLUG_BPUPDOWNLSTR")	
	
	Dim As Zstring Ptr pszText = IupGetAttribute(hTxt,"VALUE")
	
	Dim As Long iColumn = Val(*IupGetAttribute(hColumn, "VALUE"))
	
	Dim As Long iFlag 
	
	If *IupGetAttribute(hCheck, "VALUE") = "ON" Then
		
		iFlag = 1
		
	Endif
	
	Dim As Long iStartSTR = Val(*IupGetAttribute(hStartRow, "VALUE"))
	
	Dim As Long iEndSTR = Val(*IupGetAttribute(hEndRow, "VALUE"))
	
	paste_text_proc(pszText , iColumn , iFlag , iStartSTR, iEndSTR)
	
	Return IUP_DEFAULT
	
End Function

Sub create_dialog_block_edit_proc()
	
	Dim As Ihandle Ptr bp_dlg , lbl_Text , lbl_Column, lbl_Firststr, lbl_Laststr, txt_Text , updown_column , updown_first_str ,_
	updown_last_str , check_column , check_addedspace, btn_ok, vboxm , vbox1, vbox2, vbox3, vbox4, hbox1, hbox2, hbox3
	
	lbl_Text = IupLabel(*IupConfigGetVariableStr(TGlobalVariablesDll->hConfigplug,TGlobalVariablesDLL->szLangid,"plug_bplbltext")) 
	
	lbl_Column = IupLabel(*IupConfigGetVariableStr(TGlobalVariablesDll->hConfigplug,TGlobalVariablesDLL->szLangid,"plug_bplblcolumn")) 
	
	lbl_Firststr = IupLabel(*IupConfigGetVariableStr(TGlobalVariablesDll->hConfigplug,TGlobalVariablesDLL->szLangid,"plug_bplblfstr")) 
	
	lbl_Laststr = IupLabel(*IupConfigGetVariableStr(TGlobalVariablesDll->hConfigplug,TGlobalVariablesDLL->szLangid,"plug_bplbllstr"))
	
	txt_Text = IupText("")
	
	IupSetAttributes(txt_Text, "EXPAND=YES")
	
	IupSetAttribute(txt_Text, "NAME", "PLUG_BPTXT")
	
	updown_column = IupText(0)
	
	IupSetAttribute(updown_column , "SPINMAX" , "2000")
	
	IupSetAttribute(updown_column , "SPIN", "YES")
	
	IupSetAttribute(updown_column , "MAXSIZE" , "80x")
	
	IupSetAttribute(updown_column , "NAME" , "PLUG_BPUPDOWNCOLUMN")
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariablesDll->tabs, "VALUEPOS"))
	
	Dim As Integer iLineCount
	
	iLineCount = IupGetInt(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "LINECOUNT")
	
	Static As Zstring*10 szLineCount 
	
	szLineCount = Str(iLineCount)
	
	updown_first_str = IupText(0)
	
	IupSetAttribute(updown_first_str , "SPIN", "YES")
	
	IupSetAttribute(updown_first_str , "MAXSIZE" , "80x")
	
	IupSetAttribute(updown_first_str , "SPINMIN" , "1")
	
	IupSetAttribute(updown_first_str , "SPINMAX" , szLineCount)
	
	IupSetAttribute(updown_first_str , "NAME" , "PLUG_BPUPDOWNFSTR")
	
	updown_last_str = IupText(0)
	
	IupSetAttribute(updown_last_str , "SPIN", "YES")
	
	IupSetAttribute(updown_last_str , "MAXSIZE" , "80x")
	
	IupSetAttribute(updown_last_str , "SPINMIN" , "1")
	
	IupSetAttribute(updown_last_str , "SPINMAX" , szLineCount)
	
	IupSetAttribute(updown_last_str , "NAME" , "PLUG_BPUPDOWNLSTR")
	
	IupSetAttribute(updown_last_str , "VALUE" , szLineCount)	
	
	check_column = IupToggle(*IupConfigGetVariableStr(TGlobalVariablesDll->hConfigplug,TGlobalVariablesDLL->szLangid,"plug_bpcheck"),NULL) 
	
	IupSetAttribute(check_column, "NAME", "PLUG_BPCHECK")
	
	IupSetCallback(check_column, "ACTION", Cast(Any Ptr , @plug_bp_check_column_callback))
	
	check_addedspace = IupToggle(*IupConfigGetVariableStr(TGlobalVariablesDll->hConfigplug,TGlobalVariablesDLL->szLangid,"plug_bpcheckaddspace"),NULL) 
	
	IupSetAttribute(check_addedspace, "NAME", "PLUG_BPCHECKADDSPACE")
	
	IupSetAttribute(check_addedspace, "ACTIVE", "NO")		
	
	btn_ok = IupButton(*IupConfigGetVariableStr(TGlobalVariablesDll->hConfigplug,TGlobalVariablesDLL->szLangid,"plug_bpok"),NULL) 
	
	IupSetCallback(btn_ok, "ACTION", Cast(Any Ptr , @plug_bp_ok_callback))
	
	IupSetAttribute(btn_ok, "NAME", "PLUG_BPOK")
	
	IupSetAttribute(btn_ok, "MINSIZE", "85x")	
	
	vbox1 = IupVbox(lbl_Text,txt_Text,null)
	
	vbox2 = IupVbox(lbl_Column , updown_column, check_column , check_addedspace, null)
	
	vbox3 = IupVbox(lbl_Firststr,updown_first_str,null)
	
	vbox4 = IupVbox(lbl_Laststr,updown_last_str,null)
	
	hbox1 = IupHbox(vbox1 , null)
	
	hbox2 = IupHbox(IupFill(),vbox2 ,IupFill(),IupFill(), vbox3 ,IupFill(),IupFill(), vbox4 ,IupFill(), null)
	
	hbox3 = IupHbox(IupFill(), IupFill(), btn_ok , null)
	
	vboxm = IupVbox(hbox1 , hbox2 , hbox3 , IupFill(), null)
	
	IupSetAttribute(vboxm , "NGAP" , "8")
	
	IupSetAttribute(vbox1 , "NGAP" , "3")
	
	IupSetAttribute(vbox2 , "NGAP" , "3")
	
	IupSetAttribute(vbox3 , "NGAP" , "3")
	
	IupSetAttribute(vbox4 , "NGAP" , "3")
	
	IupSetAttribute(hbox2 , "NGAP" , "10")	
	
	IupSetAttribute(hbox3, "MARGIN", "10x")
	
	bp_dlg = IupDialog(vboxm)
	
	hDLG = bp_dlg
	
	IupSetAttributeHandle(bp_dlg, "DEFAULTENTER", btn_ok)
	
	IupSetCallback(bp_dlg, "K_ANY", Cast(Any Ptr , @k_any_esc_dialog_callback))
	
	IupSetAttribute(bp_dlg, "TITLE", *IupConfigGetVariableStr(TGlobalVariablesDll->hConfigplug,TGlobalVariablesDLL->szLangid,"plug_bptitle")) 
	
	IupSetCallback(bp_dlg, "CLOSE_CB", Cast(Any Ptr, @plug_dlg_bp_exit_callback()))
	
	IupPopup(bp_dlg,IUP_CURRENT,IUP_CURRENT)	
	
End Sub


Function item_block_edit_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariablesDll->tabs) < 2 Then Return IUP_DEFAULT
	
	create_dialog_block_edit_proc()
	
	Return IUP_DEFAULT
	
End Function

Function InitPluginProc(TGlobalVariables As T_GlobalVariables Ptr , pszDimErrors() As Zstring Ptr , bEncodingBool() As Byte , szEncodingString As Any Ptr) As Integer Export
	
	If TGlobalVariables = 0 Then Return 0
	
	TGlobalVariablesDll = TGlobalVariables
	
	Dim As iHandle Ptr main_menu = IupGetParent(IupGetParent(IupGetParent(TGlobalVariablesDLL->hItemAbout)))
	
	If 	main_menu = 0 Then Return 0
	
	Dim As ihandle Ptr pPlugItem = IupItem(*IupConfigGetVariableStr(TGlobalVariablesDll->hConfigplug,TGlobalVariablesDLL->szLangid,"plug_bptitle"), NULL)
	
	IupSetCallback(pPlugItem, "ACTION", Cast(Any Ptr , @item_block_edit_callback))
	
	Dim As ihandle Ptr hItemEdit = IupGetChild(IupGetChild(main_menu, 1),0)
	
	Dim As Long i , iIndex =-1
	
	Do
		
		Dim As iHandle Ptr hItem = IupGetChild(hItemEdit, i)
		
		If hItem = 0 Then Exit Do
		
		If *IupGetAttribute(hItem , "TITLE") = *IupConfigGetVariableStr(TGlobalVariablesDLL->hConfigplug,TGlobalVariablesDLL->szLangid,"plug_extedit") Then
			
			iIndex = i
			
			Exit Do
			
		Endif
		
		i+=1
		
	Loop
	
	If iIndex <> -1 Then
		
		IupAppend( IupGetChild(IupGetChild(hItemEdit, iIndex),0),  pPlugItem)
		
	Else
		
		Dim As iHandle Ptr submenu = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariablesDLL->hConfigplug,TGlobalVariablesDLL->szLangid,"plug_extedit"), IupMenu(_
		pPlugItem,_
		NULL))
		
		IupAppend( hItemEdit, submenu )
		
		IupMap(submenu)
		
	Endif
	
	IupMap(pPlugItem)
	
	Return 1
	
End Function