#Include "../tlist.bi"
#include "../declarations.bi"

dim shared as T_GlobalVariables Ptr TGlobalVariablesDll

Sub CutTrailingSpcTab () 
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariablesDll->tabs, "VALUEPOS"))
	
	Dim As Integer iStartPos, iEndPos
	
	IupGetIntInt(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "SELECTIONPOS", cast(any ptr,@iStartPos), cast(any ptr,@iEndPos))
	
	Dim As ZString Ptr pszText = IupGetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "SELECTEDTEXT")
	
	If Len(*pszText) = 0 Then
		
		IupSetFocus(TGlobalVariablesDll->tTabsOptions(idTabs).multitext)
		
		Dim As Integer count = IupGetInt(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "COUNT")
		
		IupSetStrf(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "SELECTIONPOS", !"%d:%d", 0, count)	
		
		pszText = IupGetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "SELECTEDTEXT")	
		
		If Len(*pszText) = 0 Then Exit Sub
		
	EndIf
	
	dim as string strg=*pszText
	
	dim as integer posread=0,poswait=-1,poswrite=0,char
	var strglg=len(strg)-1

	while posread<=strglg
		char=strg[posread]
		if char=10 or char=13 then ''LF  CR
			strg[poswrite]=char
			poswrite+=1
			''skip spaces and tabs by reseting
			poswait=-1
		elseif char=32 or char=9 then ''space or tab
			''keep position only if not already done
			if poswait=-1 then
				poswait=posread
			EndIf
		else ''other characters
			if poswait<>-1 then
				''keep all space or tab
				for ichar as integer =poswait to posread
					strg[poswrite]=strg[ichar]
					poswrite+=1
				Next
				poswait=-1 ''reseting
			else
				strg[poswrite]=char
				poswrite+=1
			end if
		EndIf
		posread+=1 ''next char
	wend
	strg[poswrite]=0 ''zeroing the end of the string
	strg[poswrite+1]=0

	IupSetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "UNDOACTION", "BEGIN")
	
	If len(strg) = 0 Then
	
		IupSetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "SELECTEDTEXT", "")
		
	else
	
		IupSetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "SELECTEDTEXT", strptr(strg))

	EndIf
	
	IupSetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "UNDOACTION", "END")
	
	IupSetAttribute(TGlobalVariablesDll->tTabsOptions(idTabs).multitext, "ISCHANGES", "YES")
	
End Sub

Function item_cut_trailingspctab_callback Cdecl (ih As Ihandle Ptr) As Integer
	
	If IupGetChildCount(TGlobalVariablesDll->tabs) < 2 Then Return IUP_DEFAULT
	
	CutTrailingSpcTab()
	
	return IUP_DEFAULT
	
End Function

function InitPluginProc(TGlobalVariables as T_GlobalVariables Ptr , pszDimErrors() as zstring ptr , bEncodingBool() as byte , szEncodingString as any ptr) as Integer export
	
	if TGlobalVariables = 0 then return 0
	
	TGlobalVariablesDll = TGlobalVariables
	
	dim as iHandle ptr main_menu = IupGetParent(IupGetParent(IupGetParent(TGlobalVariablesDLL->hItemAbout)))
	
	if 	main_menu = 0 then return 0
	
	dim as ihandle ptr pPlugItem = IupItem(*IupConfigGetVariableStr(TGlobalVariablesDLL->hConfigplug,TGlobalVariablesDLL->szLangid,"plug_cuttrailingspctab"), NULL)
	
	IupSetCallback(pPlugItem, "ACTION", cast(any ptr , @item_cut_trailingspctab_callback))
	
	dim as ihandle ptr hItemEdit = IupGetChild(IupGetChild(main_menu, 1),0)
	
	dim as Long i , iIndex =-1
	
	do
		
		dim as iHandle ptr hItem = IupGetChild(hItemEdit, i)
		
		if hItem = 0 then exit do
		
		if *IupGetAttribute(hItem , "TITLE") = *IupConfigGetVariableStr(TGlobalVariablesDLL->hConfigplug,TGlobalVariablesDLL->szLangid,"plug_extedit") then
			
			iIndex = i
			
			exit do
			
		EndIf
		
		i+=1
		
	Loop
	
	if iIndex <> -1 then
		
		IupAppend( IupGetChild(IupGetChild(hItemEdit, iIndex),0),  pPlugItem)
		
	else
		
		dim as iHandle ptr submenu = IupSubmenu(*IupConfigGetVariableStr(TGlobalVariablesDLL->hConfigplug,TGlobalVariablesDLL->szLangid,"plug_extedit"), IupMenu(_
		pPlugItem,_
		NULL))
		
		IupAppend( hItemEdit, submenu )
		
		IupMap(submenu)
		
	EndIf
	
	IupMap(pPlugItem)
			
	return 1

End Function